;Template=3AXMILL=Mach3_3x

*** Start of include file MTOKEN.CGI ***
*************************************************************************
*   Machine independant Code Generator include file                     *
*                                                                       *
*   Filename:	MTOKEN.CGI                                              *
*	Author:		ADM (Derived from 3AXM-FAN.CGS -r1.41                   *
*          		and 3AXM-HH.CGS -r1.25)                                 *
*   Date:		6th December 1996                                       *
*                                                                       *
*************************************************************************
*   Change History                                                      *
*     Initial Version - Included fixes for db9831                       *
*   03/02/97 ADM -  Support incremental & absolute datum shifts (9008)  *
*                   and moved NEXTTOOL logic to the toolchange macro    *
*   05/02/97 ADM -  implemented token for absolute/incremental coords   *
*   21/04/97 ADM -  db10098 - remove speed from toolchange macro        *
*   26/09/97 ADM -  db10378 - LOOPNUMBER now set to #HEADER not #LOOP   *
*                   (used for Heidenhain tool definitions               *
*   05/11/97 ADM -  db10539 - FIRSTTOOL token should use #FIRSTTOOL     *
*                   variable not POSITION                               *
*                   db10541 - should use USERDEFINEDSTRING if tool not  *
*                   loaded from tool library                            *
*   06/11/97 ADM -  db10245 - change PROGDESCR token so that it does not*
*                   ask a question each time token used                 *
*   18/11/97 ADM -  Allow seperate code constructor for hole cycle      *
*                   points for Fanuc template (db10455 & db9616)        *
*   21/11/97 ADM -  Axis Reverse option now affects home and toolchange *
*                   positions (spotted when fixing db10578)             *
*   02/03/98 ADM -  Implement TNC400 Q parameter hole cycles (db10347)  *
*                   Implement TNC400 rigid tapping (db10329)            *
*   09/03/98 ADM -  Implement spline output for Fanuc and TNC400 (C1&C2)*
*   23/03/98 ADM -  Added RETRACTMCODE token for Okuma template (QA C4) *
*   30/03/98 ADM -  Added WARNING token for new warning code constructor*
*   18/05/98 ADM -  Prevent 2 line output from rapid to home/toolchange *
*                   code constructor when using literals (db10858)      *
*   17/08/98 ADM -  SMOOTHMCODE token now uses #EXACTGCODE (db10822)    *
*   22/09/98 RHA -  Add call to set_comp_to_string to token             *
*                   Add MAXFEED token for Heidenhain & TNC (DB11008)    *
*   28/09/98 RHA -  Tokens added for Sinumerik840 Cycles & Polynomials  *
*   08/10/98 RHA -  Independant HOME tokens for Siemens                 *
*   22/10/98 RHA -  Correction to MAXFEED token for Heidenhain          *
*   20/10/98 RHA -  Token LASTDEPTH added for Fadal                     *
*   04/01/98 RHA -  Tokens for G28 blocks added (Mori Seiki)            *
*                   ABS-INC - %CANCEL removed from token                *
*   07/01/99 RHA -  Format table references changed for 840 Spline tokens*
*   14/01/99 RHA -  OPNUM & OFFSETID tokens added for Mori Seiki        *
* 07/01/00 RHA DB11788 Remove length restriction on tool description    *
* 24/01/00 RHA DB11691 Z Reverse for Intial plane & Zclear tokens added *
* 10/02/00 RHA DB11879 Tokens added for Home/Tool Change Position
*                      Use of existing tokens for move to Home/Tool Change clarified
* 10/02/00 RHA DB11963 User Tokens Added
* 26/05/00 RHA DB12281 Extend max number of gear ranges to 6 for Siemens 840
* 12/06/00 RHA      Modify MAXFEED token to output via #FEED for modality purposes
* 23/10/00 RHA DEV00001648 Speed setting for token moved to PT_SPEED_SET and corrected
* 07/11/00 RHA DEV00001691 - Increase number of user tokens
* 13/12/00 RHA Semicolon token moved to mtoken.cgi
* 19/12/00 RHA Call SET_TOOL_TYPE from TOOLTYPE token
* 15/01/01 RHA DEV00002142 Place %ASK for tokens PROGVERSION & PROGRAMMER in procedures
* 25/06/01 RHA DEV00003177 Set #XMOVE etc for Home & Tool Change Position tokens
* 06/09/01 RHA Added tokens for ECS27xx, Define !SMOOTHGCODE
* 26/09/01 RHA DEV00002377 - Siemens840 Cycles, changes and additions
* 25/09/01 RHA DEV00002996 Add tokens for Job Record data.
* 30/10/01 RHA DEV00003699 Change variables in borestandoff-X & Y
* 11/08/03 RHA Various		New Tokens SPINDLE OFF, FLUTE
* 13/08/03 RHA DEV00000377 New procedure to set #HCODE
* 26/08/03 RHA DEV00008539 Add warning counter
* 27/08/03 RHA DEV00007609 ToolChange & Home setting Option
* 03/12/03 RHA DEV00009395 Correct TLO with HPCC
* 05/12/03 RHA DEV00007045 Table clamp codes and tokens
* 15/12/03 RHA DEV00009612 Add new date tokens
* Version 950
* 01/12/04 RHA DEV00011681 Additional mill tool tokens
* 10/01/05 RHA DEV00012570 Correct TNC Helix
* Version 10.50
* 11/11/05 RHA DEV00015555 Set value in #HIGHSPEEDTOL
* Version 11.5
* 24/11/06 RHA DEV00017338 Move CPLNAME to a template variable
* 04/12/07 RHA DEV00021534 Enable longhand tapping

*************************************************************************

%DECLARE=$CPLNAME
%DECLARE=#SKIPTAP
*
*	Constants for start of G function in DATA1 & M function in DATA2 statements
*
;Define^!RAPIDGCODE^1
;Define^!FEEDGCODE^2
;Define^!CIRCGCODE^3
;Define^!DWELLGCODE^5
;Define^!EXACTGCODE^10
;Define^!SETTOOLGCODE^11
;Define^!PLANEGCODE^13
;Define^!UNITSGCODE^16
;Define^!COMPGCODE^20
;Define^!PRESETGCODE^23
;Define^!WORKGCODE^24
;Define^!CHIPBREAKGCODE^34
;Define^!DRILLGCODE^35
;Define^!FEEDMODEGCODE^45
;Define^!ABSINCRGCODE^47
;Define^!RETRACTGCODE^49
;Define^!ROTARYGCODE^54
;Define^!SMOOTHGCODE^58
*
;Define^!STOPMCODE^1
;Define^!SPINMCODE^4
;Define^!TLCHMCODE^7
;Define^!COOLMCODE^8
;Define^!SPINCOOLMCODE^14
;Define^!SUBPROGMCODE^34
;Define^!GEARMCODE^36
;Define^!SMOOTHMCODE^42
;Define^!ROTDIRMCODE^45
;Define^!MODALCYCLE^47

*
*
*	*********************************
*	Tokens - Use in Code Constructor
*	*********************************
*
*
*	G-Codes
;Token^<75>^RAPIDGCODE^[#GCODE=!FT_GCODE]^<76>Rapid Code
;Token^<77>^FEEDGCODE^[#GCODE=!FT_GCODE]^<78>Feed Code
;Token^<79>^CLWGCODE^[#GCODE=!FT_GCODE]^<80>CLW Code
;Token^<81>^CCLWGCODE^[#GCODE=!FT_GCODE]^<82>CCLW Code
;Token^<83>^COMPGCODE^[#COMPGCODE=!FT_GCODE]^<526>Cutter Radius Compensation Code
;Token^<85>^DWELLGCODE^[#DWELLGCODE=!FT_GCODE]^<86>Dwell Code
;Token^<87>^EXACTSTOPGCODE^[#EXACTGCODE=!FT_GCODE]^<88>Exact Stop Code
;Token^<89>^PLANEGCODE^[#PLANEGCODE=!FT_GCODE]^<527>Co-ordinate Plane
;Token^<91>^UNITSGCODE^[#UNITSGCODE=!FT_GCODE]^<528>NC Program Units
;Token^<93>^RETRACTGCODE^[#RETRACTGCODE=!FT_GCODE]^<94>Cycle Retract Code
;Token^<95>^DRILLGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<27>Drill Cycle
;Token^<96>^SPOTGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<97>Spot Face Cycle
;Token^<98>^PECKGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<99>Peck Drill Cycle
;Token^<100>^TAPGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<28>Tapping Cycle
;Token^<101>^REAMGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<102>Ream / Bore Cycle
;Token^<103>^BOREGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<104>Bore Cycle
;Token^<107>^CHIPBREAKGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<108>Chipbreak Drill Cycle
;Token^<965>^CYCLEGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<966>Hole Cycle
;Token^<105>^ENDCYCLEGCODE^[#CYCLEGCODE=!FT_GCYCLE]^<106>End Canned Cycle
;Token^<109>^PRESETGCODE^[#PRESETGCODE=!FT_GCODE]^<529>Datum Shift Code
;Token^<110>^WORKGCODE^[#WORKGCODE=!FT_WORKGCODE]^<111>Work / Fixture Offset
;Token^<112>^FEEDMODEGCODE^[#FEEDMODEGCODE=!FT_GCODE]^<530>Feed Mode Code

*	M Codes
;Token^<122>^COOLANT ON^[#COOL=!FT_MCODE]^<531>Coolant Control
;Token^<124>^COOLANT OFF^[#COOL=!FT_MCODE]^<531>Coolant Control
;Token^<1800>^SPINDLE OFF^[#DIRECTION=!FT_MCODE]^<127>Spindle Direction
;Token^<126>^SPINDIR^[#DIRECTION=!FT_MCODE]^<127>Spindle Direction
;Token^<3253>^SPINDLE REV^[#DIRECTION=!FT_MCODE]^<3254>Spindle Reverse Direction
;Token^<128>^STOPMCODE^[#STOPMCODE=!FT_MCODE]^<129>Program / Optional Stop
;Token^<211>^GEARMCODE^[#GEARMCODE=!FT_MCODE]^<212>Gear Range
;Token^<532>^SMOOTHMCODE^[#EXACTGCODE=!FT_MCODE]^<533>Smooth Mcode
;Token^<1036>^RETRACTMCODE^[#RETRACTGCODE=!FT_MCODE]^<94>Cycle Retract Code

*	General
;Token^<146>^DELETE^[#DELETE=!FT_DELETE]^<147>Block Delete
;Token^<148>^BLKNUM^[#BNUM=!FT_BLKNUM]^<149>Block Number
;Token^<1293>^OPNUM^[#SBNUM=!FT_OPNUM]^<1294>Operation Number
;Token^<150>^SAFEBLKNUM^[#SBNUM=!FT_SAFEBLKNUM]^<151>Safe / Toolchange Block Number
;Token^<152>^PROGDESCR^[$DESCR]^<153>Program Description
;Token^<534>^PROGUNITS^[$PROGUNIT=5]^<528>NC Program Units
;Token^<1505>^XHOMEPOS^[#XMOVE=!FT_XMOVE]^<155>X Home Position
;Token^<1506>^YHOMEPOS^[#YMOVE=!FT_YMOVE]^<157>Y Home Position
;Token^<1507>^ZHOMEPOS^[#ZMOVE=!FT_ZMOVE]^<159>Z Home Position
;Token^<154>^XHOME^[#XMOVE=!FT_XMOVE]^<1508>Move to X Home
;Token^<156>^YHOME^[#YMOVE=!FT_YMOVE]^<1509>Move to Y Home
;Token^<158>^ZHOME^[#ZMOVE=!FT_ZMOVE]^<1510>Move to Z Home
;Token^<1511>^XTOOLPOS^[#XMOVE=!FT_XMOVE]^<161>X Toolchange Position
;Token^<1512>^YTOOLPOS^[#YMOVE=!FT_YMOVE]^<163>Y Toolchange Position
;Token^<1513>^ZTOOLPOS^[#ZMOVE=!FT_ZMOVE]^<165>Z Toolchange Position
;Token^<160>^XTOOL^[#XMOVE=!FT_XMOVE]^<1514>Move to X Toolchange
;Token^<162>^YTOOL^[#YMOVE=!FT_YMOVE]^<1515>Move to Y Toolchange
;Token^<164>^ZTOOL^[#ZMOVE=!FT_ZMOVE]^<1516>Move to Z Toolchange
;Token^<166>^XMOVE^[#XMOVE=!FT_XMOVE]^<167>X Move
;Token^<168>^YMOVE^[#YMOVE=!FT_YMOVE]^<169>Y Move
;Token^<170>^ZMOVE^[#ZMOVE=!FT_ZMOVE]^<171>Z Move
;Token^<2228>^IZMOVE^[#IZMOVE=!FT_IZMOVE]^<2229>Incremental Z Move
;Token^<172>^ZINITIAL^[#ZMOVE=!FT_ZMOVE]^<173>Initial Plane
;Token^<174>^FEED^[#FEED=!FT_FEED]^<175>Feedrate
;Token^<176>^SPEED^[#SPEED=!FT_SPEED]^<177>Spindle Speed
;Token^<970>^WARNING^[$WARNING]^<971>Warning messages
;Token^<1581>^SEMICOLON^[$TEMP]^<1582>Semi Colon character
;Token^<1801>^WARNCOUNT^^<1802>Output Warnings Count

*	Toolchange / Tooling
;Token^<182>^SETTOOLGCODE^[#SETTOOLGCODE=!FT_GCODETSET]^<43>Set Tool Data
;Token^<183>^TURRETNO^[POSITION=!FT_TPOSN]^<184>Turret / Position Number
;Token^<185>^NEXTTOOL^[#NEXTTOOL=!FT_TPOSN]^<186>Pre-select Next Tool
;Token^<187>^FIRSTTOOL^[#FIRSTTOOL=!FT_TPOSN]^<188>Re-select First Tool
;Token^<189>^LENGTHOFFSET^[#HCODE=!FT_TLONO]^<535>Tool Length Offset (TLO)
;Token^<191>^ZGAUGELENGTH^[#ZGAUGE=!FT_ZGAUGETSET]^<192>Tool Z Gauge Length
;Token^<197>^TOOLRADIUS^[TOOLRAD=!FT_RADTSET]^<198>Tool Radius
;Token^<195>^TOOLDIAM^[#TOOLDIA=!FT_DIATSET]^<196>Tool Diameter
;Token^<209>^LOOPNUMBER^[#HEADER=!FT_LOOPTSET]^<210>Loop Number

*	Cutter Radius Compensation
;Token^<217>^CRC REGISTER^[#COMPDCODE=!FT_CRCNO]^<536>Cutter Radius Compensation Register

*	Heidenhain & Anilam Only
;Token^<537>^CRC L/R^[$COMP]^<538>Compensation RR / RL

*	Circular Interpolation
;Token^<219>^XARCEND^[#XMOVE=!FT_XMOVE]^<220>Arc End X Coord
;Token^<221>^YARCEND^[#YMOVE=!FT_YMOVE]^<222>Arc End Y Coord
;Token^<223>^ZARCEND^[#ZMOVE=!FT_ZMOVE]^<224>Arc End Z Coord
;Token^<225>^IVALUE^[#IVALUE=!FT_IMOVE]^<226>Arc I Value
;Token^<227>^JVALUE^[#JVALUE=!FT_JMOVE]^<228>Arc J Value
;Token^<229>^KVALUE^[#KVALUE=!FT_KMOVE]^<230>Arc K Value
;Token^<231>^ARCRADIUS^[#RADIUS=!FT_RMOVE]^<232>Arc Radius
;Token^<233>^XCENTRE^[#XCENTRE=!FT_XMOVE]^<234>Arc Centre X Coord
;Token^<235>^YCENTRE^[#YCENTRE=!FT_YMOVE]^<236>Arc Centre Y Coord
;Token^<237>^ZCENTRE^[#ZCENTRE=!FT_ZMOVE]^<238>Arc Centre Z Coord

*	Hole Cycles
;Token^<239>^CYCLEZFEED^[#FEED=!FT_FCYCLE]^<240>Hole Cycle Z Feedrate
;Token^<241>^CYCLESPEED^[#SPEED=!FT_SCYCLE]^<177>Spindle Speed
;Token^<242>^DWELLTIME^[DWELL=!FT_DWELL]^<243>Dwell Time
;Token^<244>^CYCLEDWELLTIME^[DWELL=!FT_DWCYCLE]^<245>Counterbore Dwell Time
;Token^<539>^ZDEPTH^[#ZMOVE=!FT_ZCYCLE]^<540>Z Depth
;Token^<246>^RPLANE^[#RPLANE=!FT_RETRACTCYCLE]^<247>R Plane
;Token^<248>^ZCLEAR^[#TMP=!FT_CLEARCYCLE]^<249>Z Clearance Plane
;Token^<1037>^ZLEVEL^[#ZLEVEL=!FT_ZCYCLE]^<1038>Z Level
;Token^<250>^PECKDEPTH^[#DEPTH=!FT_PECKCYCLE]^<251>Pecking Depth
;Token^<252>^COMMENT^[USERDEFINEDSTRING]^<253>Operator Message
;Token^<254>^PITCH^[#PITCH=!FT_PITCHCYCLE]^<255>Thread / Tap Pitch
;Token^<256>^DEGRESSION^[#DEGR=!FT_DEGCYCLE]^<541>Hole Cycle Degression
;Token^<542>^BORESTANDOFF^[#BOREOFFSET=!FT_OFFCYCLE]^<543>Bore Stand Off Distance
;Token^<1655>^BORESTANDOFF-X^[USERVAR2=!FT_OFFCYCLE]^<1656>Bore Stand Off X
;Token^<1657>^BORESTANDOFF-Y^[USERVAR3=!FT_OFFCYCLE2]^<1658>Bore Stand Off Y

* Added for Sinumerik840 & Fadal cycles
;Token^<1219>^REFPLANE^[#ZLEVEL=!FT_CYCLEPARAM]^<1220>Reference Plane (RFP)
;Token^<262>^ZSAFE^[ZSAFE=!FT_CYCLEPARAM]^<263>Z Safe Distance
;Token^<1221>^CYCLEFIRSTDWELL^[#FIRSTDWELL=!FT_CYCLEFIRSTDWELL]^<1222>Cycle First Peck Dwell Time
;Token^<1223>^FIRSTDEPTH^[#FIRSTDEPTH=!FT_FIRSTDEPTH]^<1224>First Depth
;Token^<1269>^LASTDEPTH^[#LASTDEPTH=!FT_LASTDEPTH]^<1270>Last Depth
;Token^<1225>^RDEPTH^[#RELDEPTH=!FT_CYCLEPARAM]^<1226>Relative Depth
;Token^<1227>^RETFEED^[#RETFEED=!FT_CYCLEPARAM]^<1228>Retract Feed
;Token^<1229>^CYCLESPINDIR^[#DIRECTION=!FT_CYCLESPINDIR]^<127>Spindle Direction
;Token^<1659>^CYCLENPECKS^[#NPECKS=!FT_CYCLENPECKS]^<1660>Number of Pecks

*	Heidenhain Only
;Token^<840>^M89/M99^[#MODALCYCLE=!FT_MCODE]^<841>Modal (M89) / Non Modal (M99)
*
*	Datum Shift : Translate / Index
;Token^<264>^XABSORIGIN^[#XSUB=!FT_XMOVE]^<265>Absolute X Origin
;Token^<266>^YABSORIGIN^[#YSUB=!FT_YMOVE]^<267>Absolute Y Origin
;Token^<268>^ZABSORIGIN^[#ZSUB=!FT_ZMOVE]^<269>Absolute Z Origin
;Token^<270>^XINC^[#XMOVE=!FT_XMOVE]^<271>Incremental X Origin
;Token^<272>^YINC^[#YMOVE=!FT_YMOVE]^<273>Incremental Y Origin
;Token^<274>^ZINC^[#ZMOVE=!FT_ZMOVE]^<275>Incremental Z Origin
;Token^<276>^CPLNAME^[$CPLNAME]^<277>CPL Name
*
*	Tooling Sheet / Program Information
;Token^<278>^HDR-TURRETNO^[POSITION=!FT_INTSETUP]^<544>Turret No.
;Token^<279>^TOOLDESCR^[$TOOLDESCRIPTION]^<280>Tool Description
;Token^<281>^HDR-TOOLDIAM^[#TOOLDIA=!FT_REALSETUP]^<196>Tool Diameter
;Token^<282>^TOOLTYPE^[$TYPE=10]^<283>Tool Type
;Token^<545>^HDR-TOOLGAUGE^[TOOLEN=!FT_REALSETUP]^<285>Tool Zgauge
;Token^<290>^TOOLUNITS^[$UNIT=5]^<291>Tool Units
;Token^<1792>^FLUTE^[FLUTELENGTH=!FT_REALSETUP]^<1793>Tool Flute Length
;Token^<292>^PROGID^[#PROGID=!FT_PROGID]^<546>Program Id
;Token^<1295>^TOOLOFFSETID^[#TMP1=!FT_OFFSETID]^<1296>Offset Program Id
;Token^<1297>^WORKOFFSETID^[#TMP2=!FT_OFFSETID]^<1296>Offset Program Id
;Token^<294>^SEQID^[$SEQID=23]^<295>Machining Sequence
;Token^<296>^MACHINENAME^[MACHINENAME]^<297>Machine Description
;Token^<298>^CYCLETIME^[MACHTIME1=!FT_REALSETUP]^<547>Cycle Time Including Toolchange
;Token^<300>^DATE^[DATE]^<301>Program creation Date
;Token^<2105>^UKDATE^[UKDATE]^<2106>Program creation Date (UK Format)
;Token^<2107>^DAY^[DAY=!FT_INTSETUP]^<2108>Program creation Day
;Token^<2109>^MONTH^[MONTH=!FT_INTSETUP]^<2110>Program creation Month
;Token^<2111>^YEAR^[YEAR=!FT_INTSETUP]^<2112>Program creation Year
;Token^<302>^TIME^[TIME]^<303>Program creation Time
;Token^<304>^PROGVERSION^[$PROGVER]^<548>Program Version No.
;Token^<306>^PROGRAMMER^[$ID]^<307>Programmer's Name
;Token^<308>^MANREADABLE^MANREADABLE=[$MANREADABLE]^<309>Manreadable (Punch Tape)
;Token^<310>^LEADER^LEADER=[#LEADER=!FT_REALSETUP]^<311>Leader (Punch Tape)
;Token^<312>^PARTNAME^[PARTNAME]^<313>EdgeCAM Part Name
;Token^<314>^SEQUENCENAME^[SEQUENCENAME]^<315>M/C Sequence Name
;Token^<2230>^CORNER^[CORNERRAD=!FT_REALSETUP]^<2231>Tool Corner radius
;Token^<2232>^REACH^[REACH=!FT_REALSETUP]^<2233>Tool Reach

*	Subroutines
;Token^<316>^SUBCALL^[#SUBSTARTMCODE=!FT_MCODE]^<317>Subroutine Call M-Code
;Token^<318>^SUBNO^[#SUBROUTINE=!FT_SUBID]^<319>Subroutine Program Number
;Token^<320>^SUBNOCALL^[#SUBROUTINE=!FT_SUBCALL]^<321>Call Subroutine Program Number
;Token^<322>^SUBEND^[#SUBENDMCODE=!FT_MCODE]^<323>Subroutine End M-Code

*	By block number
;Token^<324>^N-SUBSTART^[STARTSUB=!FT_SSNUM]^<325>Block Number Start
;Token^<326>^N-SUBEND^[ENDSUB=!FT_SENUM]^<327>Block Number End

*	Position : Before, after, in-line with main NC Program
;Token^<328>^SUBROUTINES^^<329>Subroutines position
;Token^<912>^ABS-INC^[#ABSINC=!FT_GCODE]^<913>Absolute/Incremental Coords Code

*	Datums
;Token^<330>^SETDATUMS^^<549>Set-Up Workdatums
;Token^<842>^WORKREGISTER^[#COORDNUM=!FT_LOOPTSET]^<843>Work Offset Register

*	Rotary Axes / Milling
;Token^<844>^PRIMARY ROT^[#ROT1=!FT_PRIMARYROT]^<845>Primary Rotary Axis
;Token^<846>^SECONDARY ROT^[#ROT2=!FT_SECONDARYROT]^<847>Secondary Rotary Axis

;Token^<848>^ROTARYGCODE^[#ROTARYGCODE=!FT_ROTARYGCODE]^<849>Rotary / Planar Code
;Token^<850>^WRAP HEIGHT^[#WRAPHEIGHT=!FT_WRAPHEIGHT]^<851>Wrap Height (Radius/Diameter)

;Token^<852>^ROTATE CLW/CCLW^[#ROTDIRMCODE=!FT_ROTDIRMCODE]^<853>Code for direction of Rotation

;Token^<2113>^T-CLAMP-ON^[#TCLAMP=!FT_MCODE]^<2114>Table Clamp On
;Token^<2115>^T-CLAMP-OFF^[#TCLAMP=!FT_MCODE]^<2116>Table Clamp Off
;Token^<2117>^TABLE-CLAMP^[#TCLAMP=!FT_MCODE]^<2118>Table Clamp Status

*   Spline Output
*   Fanuc specific
;Token^<1039>^ORDER^[#ORDER=!FT_ORDER]^<1040>NURB Order
;Token^<1041>^WEIGHT^[#WEIGHT=!FT_WEIGHT]^<1042>NURB Weight
;Token^<1043>^KNOT^[#KNOT=!FT_KNOT]^<1044>NURB Knot

*   Heidenhain specific
;Token^<1045>^AXIS^[$AXIS]^<1046>Active axis
;Token^<1047>^CONTINUATION^[$CONTINUE]^<1048>Continuation Character
;Token^<1049>^K1 COEFF^[#K1VALUE=!FT_COEFF]^<1050>K1 Coefficient
;Token^<1051>^K2 COEFF^[#K2VALUE=!FT_COEFF]^<1052>K2 Coefficient
;Token^<1053>^K3 COEFF^[#K3VALUE=!FT_COEFF]^<1054>K3 Coefficient
;Token^<1055>^K1 EXPONENT^[#K1EXP=!FT_EXP]^<1056>K1 Exponent
;Token^<1057>^K2 EXPONENT^[#K2EXP=!FT_EXP]^<1058>K2 Exponent
;Token^<1059>^K3 EXPONENT^[#K3EXP=!FT_EXP]^<1060>K3 Exponent
;Token^<1061>^HIGHSPEED TOL^[#HIGHSPEEDTOL=!FT_HIGHSPEEDTOL]^<1062>High Speed M/c Tolerance
;Token^<1230>^MAXFEED^[#FEED=!FT_FEED]^<1231>Rapid Feed Value

*Siemens Spline (Polynomial)
;Token^<1232>^POLY-X^[#EX=!FT_SPLINEX]^<1233>Polynomial X End Point
;Token^<1234>^POLY-Y^[#EY=!FT_SPLINEY]^<1235>Polynomial Y End Point
;Token^<1236>^POLY-Z^[#EZ=!FT_SPLINEZ]^<1237>Polynomial Z End Point
;Token^<1238>^COEFF-XA^[#AX=!FT_SPLINEPARAM]^<1239>Polynomial Xa Coefficient
;Token^<1240>^COEFF-XB^[#BX=!FT_SPLINEPARAM]^<1241>Polynomial Xb Coefficient
;Token^<1242>^COEFF-YA^[#AY=!FT_SPLINEPARAM]^<1243>Polynomial Ya Coefficient
;Token^<1244>^COEFF-YB^[#BY=!FT_SPLINEPARAM]^<1245>Polynomial Yb Coefficient
;Token^<1246>^COEFF-ZA^[#AZ=!FT_SPLINEPARAM]^<1247>Polynomial Za Coefficient
;Token^<1248>^COEFF-ZB^[#BZ=!FT_SPLINEPARAM]^<1249>Polynomial Zb Coefficient

*Siemens Home (For null addresses)
;Token^<1250>^XHOME840^[#XMOVE=!FT_XHOME840]^<155>X Home Position
;Token^<1251>^YHOME840^[#YMOVE=!FT_YHOME840]^<157>Y Home Position
;Token^<1252>^ZHOME840^[#ZMOVE=!FT_ZHOME840]^<159>Z Home Position


*	M-Functions (Used to create default Code Constructor)
;Token^<381>^MCODE^[$MCODE]^<382>M-Code from list
;Define User Macro^$MCODE
;Use Tokens^DELETE^BLKNUM^MCODE
;Default Sequence^[DELETE]^[BLKNUM]^[MCODE]

*	Machine Specific Tokens
*	Deckel
;Token^<550>^G45^[$G45]^<551>G45 Cutter Compensation
;Token^<552>^A0^[$A0]^<553>A0 Cutter Compensation
;Token^<554>^G60^[$G60]^<555>G60 Cutter Compensation
;Token^<556>^M62^[$M62]^<557>M62 Cutter Compensation
*
*   G28 blocks  Mori Seiki  & Fanuc types
;Token^<1298>^G28ZBlock^^<1299>G28 Z movement block
;Token^<1300>^G28XYBlock^^<1301>G28 XY movement block

* Formatting tokens, ECS27xx (Semi colon without training spaces)
;Token^<1661>^S-COLON^[$TEMP]^<1582>Semi Colon character
;Token^<1662>^LCHEV^[$TEMP1]^<1663>Left Chevron character
;Token^<1664>^RCHEV^[$TEMP2]^<1665>Right Chevron character
;Token^<1666>^COLON^[$TEMP3]^<1667>Colon character
;Token^<1668>^LBRKT^[$TEMP1]^<1669>Left Bracket character
;Token^<1670>^RBRKT^[$TEMP2]^<1671>Right Bracket character

***********************************************************
* Job Record Tokens
***********************************************************
;Token^<1637>^JM-DESC^[JOBDESC]^<1638>Job Manager Description
;Token^<1639>^JM-COM^[JOBCOM]^<1640>Job Manager Comment
;Token^<1641>^JM-FAM^[JOBFAM]^<1642>Job Manager Family
;Token^<1643>^JM-MACH^[JOBMACH]^<1644>Job Manager Machine
;Token^<1645>^JM-CUST^[JOBCUST]^<1646>Job Manager Customer
;Token^<1647>^JM-PROG^[JOBPROG]^<1648>Job Manager Programmer
;Token^<1649>^JM-MATL^[JOBMATL]^<1650>Job Manager Material
;Token^<1651>^JM-REV^[JOBREV]^<1652>Job Manager Revision

***********************************************************
* User tokens for ;CODE commands
***********************************************************
;Token^<1497>^USER-STRING^[$USER]^<1498>User String Token
;Token^<1597>^USER-STRING-1^[$USER1]^<1498>User String Token
;Token^<1598>^USER-STRING-2^[$USER2]^<1498>User String Token
;Token^<1599>^USER-STRING-3^[$USER3]^<1498>User String Token
;Token^<1600>^USER-STRING-4^[$USER4]^<1498>User String Token
;Token^<1601>^USER-STRING-5^[$USER5]^<1498>User String Token
;Token^<1499>^USER-1^[#USER1=!FT_USER-1]^<1602>User Numeric Token
;Token^<1501>^USER-2^[#USER2=!FT_USER-2]^<1602>User Numeric Token
;Token^<1503>^USER-3^[#USER3=!FT_USER-3]^<1602>User Numeric Token
;Token^<1603>^USER-4^[#USER4=!FT_USER-4]^<1602>User Numeric Token
;Token^<1604>^USER-5^[#USER5=!FT_USER-5]^<1602>User Numeric Token
;Token^<1605>^USER-6^[#USER6=!FT_USER-6]^<1602>User Numeric Token
;Token^<1606>^USER-7^[#USER7=!FT_USER-7]^<1602>User Numeric Token
;Token^<1607>^USER-8^[#USER8=!FT_USER-8]^<1602>User Numeric Token
;Token^<1608>^USER-9^[#USER9=!FT_USER-9]^<1602>User Numeric Token
;Token^<1609>^USER-10^[#USER10=!FT_USER-10]^<1602>User Numeric Token


*
*** End of include file B:\Pams\cam\machdef\template\MTOKEN.CGI ***
*** Start of include file MDECLARE.CGI ***
*************************************************************************
*   Machine independant Code Generator include file                     *
*                                                                       *
*   Filename:	MDECLARE.CGI                                            *
*	Author:		ADM (Derived from 3AXM-FAN.CGS -r1.41                   *
*          		and 3AXM-HH.CGS -r1.25)                                 *
*   Date:		6th December 1996                                       *
*                                                                       *
*************************************************************************
*   Change History                                                      *
*     Initial Version - Included fixes for db9831                       *
*   16/12/96 ADM -  implemented swapping of CLW/CCLW codes for YZ       *
*                   and XZ planes (db9725)                              *
*   27/01/97 ADM -  use NEXTZMOVE instead of ZMOVE in                   *
*                   RAPID_AFTER_TOOLCHANGE (db9822)                     *
*   03/02/97 ADM -  support incremental & absolute datum shift (db9008) *
*   05/02/97 ADM -  implemented token for absolute/incremental coords   *
*   21/04/97 ADM -  db10043 - allow cutter comp on thread milling       *
*   26/06/97 ADM -  New variable used in calculation of radius sign for *
*                   rotary radial arcs                                  *
*   11/11/97 ADM -  Variable used to determine whether Indexing or      *
*                   Rotary, so that Reverse Axis and Start At settings  *
*                   affect Rotary moves (db10246 and db10358)           *
*   13/11/97 ADM -  Add option for CRC register as Maxtools + tool      *
*                   count (db9633)                                      *
*   18/11/97 ADM -  Allow seperate code constructor for hole cycle      *
*                   points for Fanuc template (db10455 & db9616)        *
*   28/11/97 ADM -  Warn if no Rapid to Toolchange prior to Toolchange  *
*                   (db10589)                                           *
*   16/12/97 SME -  #HOLECYCLE declared                                 *
*   23/02/98 ADM -  Add option to allow combined rotary/multiplane      *
*                   angular output to prevent additional moves (db10683)*
*   02/03/98 ADM -  Implement TNC400 Q parameter hole cycles (db10347)  *
*                   Implement TNC400 rigid tapping (db10329)            *
*   09/03/98 ADM -  Implement spline output for Fanuc and TNC400 (C1&C2)*
*   30/03/98 ADM -  changes for new Warning code constructor            *
*   18/05/98 ADM -  Prevent 2 line output from rapid to home/toolchange *
*                   code constructor when using literals (db10858)      *
*   24/09/98 RHA -  Spline declarations moved to machine specific files *
*                   #highspeedtol                                       *
*                        (To allieviate variables limit problem)        *
*   25/09/98 RHA _  $G45,$A0,$G60,$M62 moved to Deckel 3m-mach.dek      *
*                                                                       *
*   14/10/98 RHA -  Removed disused variables (MPLM)                    *
*                   #ROTDIR #ROTREVERSE #INDEX #ROTINDEX                *
*   20/10/98 RHA -  #EMULATION flag added for G98/9 emulation in Cycles *
*   10/12/98 RHA -  #ROTVALS added - Used to flag index & rot rotate modes*
*   10/05/99 RHA -  #HIGHSPEED #RECORD & #TEMP removed to save var names *
*   17/06/99 RHA  Removed $MACRO, $DEBUG, #CONDEBUG, #ROTHOLD           *
*                 Added #PROCTRACE, $SPC, $PROCEDURE for procedure trace*
*                 Unused vars (previously commented out) removed        *
*                 $PROGUNIT, $COMP, moved to m/c file(s)                *
*                 #USER1,#USER2,#USER3,$USER added for CODE command     *
*   21/06/99 RHA  DB11095 Corrected RESET processing, remove #TRANSFLAG *
* 22/09/99  RHA  DB11654 #LIMIT360 declaration added                    *
* 07/03/00 RHA  DB11941 - Remove variable #WARNCRC90, add #CRCONZ       *
* 03/11/00 RHA DEV00001690 Add more user variables
* 09/11/00 RHA DEV00001683 Add #SUPPORTMDEPTH,#ZDEPTHHOLD,#CYCLEGCODESAVE,#DEPTHCHANGE
* 21/11/00 RHA DEV00001864 Add #ZLEVELHOLD,#ZCLEARINC for TNC426
* 13/12/00 RHA #TEMP, $TEMP declared
* 14/12/00 RHA DEV00002151 - Add #TOOLRAPWARN & #TOOLZWARN for toolchange position checks.
* 25/01/01 RHA DEV00002157 Additional variables for thread mill single block cycle
* 06/09/01 RHA Declarations for ECS27xx
* 25/09/01 RHA Declare #NCPROCESS
* 26/09/01 RHA DEV00002377 - Siemens840 Cycles, changes and additions
* 11/10/01 RHA DEV00002359 Add #WARNCRCARC
* 30/10/01 RHA DEV00003699 Add more variables for ECS2700
* 01/03/02 RHA DEV00004755 Add #FORCEXYZ
* 01/03/02 RHA DEV00004482 Add #SETUPHEAD
* 30/04/02 RHA DEV00005006 Add #HIGHSPEEDTOL
* 15/05/02 RHA DEV00005454 Add #ROTINCR
* 16/05/02 RHA DEV00005448 Add #LIMIT180
* 30/05/02 RHA DEV00003830 Add control for incremental in rotary mode
* 27/11/02 RHA DEV00006442 Add expand controls for hole cycles
* 02/12/02 RHA DEV00006698 Add #CURRENTCPL
* 21/02/03 RHA DEV00007249 Add hole cycle control switches
* 12/08/03 RHA DEV00007046 Add #DIRHOLD
* 13/08/03 RHA DEV00007955 Force feedrate at start of subroutine #FORCEFEED
* 13/08/03 RHA DEV00007537 TLO options as for CRC
* 10/08/03 RHA DEV00008012 Correct Z reverse - Heidenhain hole cycles
* 22/08/03 RHA DEV00008536 Improve CRC warnings
* 26/08/03 RHA DEV00008539 Add warning counter
* 27/08/03 RHA DEV00007609 Add #REFSHIFT and #TEMPREF variables
* 28/11/03 RHA DEV00008695 Improve processing speed for surface milling
* 05/12/03 RHA DEV00007400 Option to force XYZ on full circle
* 05/12/03 RHA DEV00007045 Table clamp codes and tokens
* 05/12/03 RHA DEV00007835 Allow R word on 360 arcs (TNC426 only)
* 16/06/04 RHA DEV00010879 Thread Mill Cycle parameters
* 19/07/04 RHA DEV00011202 Removed #ARCTOL
* Version 9.5
* 18/11/04 RHA DEV00012253 Make workshift warning optional
* 22/11/04 RHA DEV00012250 Option to suppress move to Retract before cycles
* 10/01/05 RHA DEV00012570 Correct TNC Helix
* Version 10
* 08/07/05 RHA DEV00014063 Add #MAXTMP for max block setting
* Version 10.5
* 08/07/05 RHA DEV00015560 Declare #COUNT
* Version 12.25
* 03/12/07 RHA DEV00021534 Enable longhand tapping
* Version 12.50
* 18/01/08 RHA DEV00021841, DEV00021908 New optional warnings
*************************************************************************
*
*
*	Startup / Initialisation / General
*
%DECLARE=#TAPERWARN,#SUBWARN
%DECLARE=#COUNT
%DECLARE=#MAXTMP
%DECLARE=#IZMOVE
%DECLARE=#MVRETRACT
%DECLARE=#SHIFTWARN
%DECLARE=#RWORD360
%DECLARE=#TCLAMPON,#TCLAMPOFF,#TCLAMP
%DECLARE=#SPEEDUP,#FULLARCXYZ
%DECLARE=#XTEMPREF,#YTEMPREF,#ZTEMPREF,#REFSHIFT
%DECLARE=#WARNCOUNT
%DECLARE=#TEMPREVERSE,#COMPMODE
%DECLARE=#FORCEFEED,#AUTOTLO
%DECLARE=#CURRENTCPL
%DECLARE=#SETUPHEAD
%DECLARE=#TOOLRAPWARN,#TOOLZWARN
%DECLARE=#ZLEVELHOLD,#ZCLEARINC
%DECLARE=$CONDEBUG,#PROCTRACE,$SPC,$PROCEDURE
%DECLARE=#LEADER,#PROGID,#USEDTOKEN
%DECLARE=#INCHINCR,#MMINCR,$MODEL
%DECLARE=#TMP1,#TMP2,#TMP3,$MACHINE,#MACRO,$TOOLDESCRIPTION,$PROGVER,$MANREADABLE
*   NC Output control for PCIs (ECS2700)
%DECLARE=#NCPROCESS
*	Block Numbering
%DECLARE=#BNUM,#BNUMINC,#USEBNUM,#BNUMVAR,#SBNUM,#ONLYSBNUM,#RESTARTSUBSBNUM,#BNUMHOLD
%DECLARE=#SBNUMPOSITION
*	G (preparatory) codes
%DECLARE=#PLANEGCODE,#GCODE,#UNITSGCODE,#FEEDMODEGCODE
*		Circular Interpolation
%DECLARE=#JVALUE,#KVALUE,#BEARING1,#BEARING2,#OUTPUTRADS,#INCR,#IVALUE,#RADIUS,#CONARC
%DECLARE=#ADJARCFEED,#XCENTRE,#YCENTRE,#ZCENTRE,#STARTRAD,#ENDRAD,#ARCTYPE,#USERADS
%DECLARE=#BEARING,#G18SWAP,#G19SWAP
*	Spindle / Gears
%DECLARE=#NUMGEARS,#STEPS,#AUTOGEAR,#GEAR,#GEARMCODE,#SPEED,#DIRECTION
%DECLARE=#SPEEDPTR,#STEPSPTR,#RPMMATCH,#MINRPM,#MAXRPM,#MAXRPMPTR,#USRMAXPTR,#USRMAXRPM,#SCODE,#SCODEINCR
%DECLARE=#MINSCODE,#MAXSCODE,#RPMINC,#TESTRPM,#SPINCOUNTER,#RPMDIFF,#HOLDRANGE,#HOLDSPINCOUNTER
*	General Coordinate Systems
%DECLARE=#XMOVE,#YMOVE,#ZMOVE,#XHOLD,#YHOLD,#ZHOLD
%DECLARE=#INCRXYZ,#INCRXYZHOLD,#INCRSUBS,#XREVERSE,#YREVERSE,#ZREVERSE
%DECLARE=#INCROTARY
%DECLARE=#XSTOREABS,#YSTOREABS,#ZSTOREABS,#AXISREVERSE
*	Rapid Traverse
%DECLARE=#FEEDRAPIDS,#RAPDIST,#RAPIDFEEDRATE
*	Hole Cycles
%DECLARE=#EMULATION
%DECLARE=#G81CYCLE
%DECLARE=#CYCLEGCODE,#ZRABSINCR,$CYCLETYPE,#BOREOFFSET,#RETRACTGCODE,#ZDEPTH,#RPLANE,#ZLEVEL,#DEGR
%DECLARE=#DEPTH,#HANDOFTHREAD,#BOREOFFSETMM,#BOREOFFSETINCH,#SUPPORTG98G99
%DECLARE=#PECKREVERSE,#MULTILEVEL,#THREADMOVE,#BOREOFFSETHOLD,#DWELLGCODE
%DECLARE=#FEEDMODEGCODEHOLD,#HCODEHOLD,#DIRECTIONHOLD,#DIRHOLD,#HOLECYCLE,#PITCH,#MODALCYCLE
%DECLARE=#SUPPORTMDEPTH,#ZDEPTHHOLD,#CYCLEGCODESAVE,#DEPTHCHANGE
%DECLARE=#NPECKS
%DECLARE=#EXPANDG81,#EXPANDG82,#EXPANDG83,#EXPANDG84,#EXPANDG85,#EXPANDG86,#EXPANDG87
%DECLARE=#PREPOSITION,#CYCLEPOINTS
*	Toolchange / Tooling
%DECLARE=#TLOCOMP,#ADJZMOVE,#NEXTTOOL,#FIRSTTOOL,#TOOLCHANGE,#TOOLDIA,#HCODE
%DECLARE=#ZGAUGE,#MAXTOOLS1,#SETTOOLGCODE,#REMOVEDUPLICATES,#FIRSTRAPIDZ
%DECLARE=#ZTOOLSUB,#TOOLCOUNT,#RAPIDTOOL
*	Subroutines
%DECLARE=#SUBSTARTMCODE,#SUBENDMCODE,#SUBNOSTART,#SUBROUTINE
%DECLARE=#INCRSUBNUMBER
*	Cutter Radius Compensation
%DECLARE=#COMPGCODE,#COMPDCODE,#COMPON,#COMPGCODEHOLD,#COMPDCODEHOLD,#CANCELCOMP,#WARNCRC,#WARNCRC90,#CRCONZ1,#CRCONZ2,#AUTOREG
%DECLARE=#REGOFFSET,#ABSINC
%DECLARE=$DECKELCOMP
%DECLARE=#WARNCRCARC
*
%DECLARE=$TYPE,$UNIT,$ID,$DESCR,$NAME,$OUTPUTSUBS
%DECLARE=#ABS,#TMP,#MINFEEDADJ,#MAXFEEDADJ,$WARNING
%DECLARE=#CURPLANE,#DELETE,#FEED,#FIRSTIME,#FUNNY,#COOL
%DECLARE=#TOOLSHEET,#HEADER,#LOOP,#MCODE,#STOPMCODE
%DECLARE=#MIRROR,#MOVE,#NEGINCR
%DECLARE=#SIGN
%DECLARE=#TEMP,$TEMP,$TEMP1,$TEMP2,$TEMP3
*	Datum Shifting
%DECLARE=#PRESETGCODE,#WORKGCODE,#XINC,#XABSORIGIN,#COORDNUM,#G54,#G55,#G56,#G57,#G58,#G59,#SYSIDHOLD
%DECLARE=#XABSORIGINHOLD,#XTEMP,#YINC,#YABSORIGIN,#YABSORIGINHOLD,#YTEMP
%DECLARE=#ZABSORIGIN,#ZINC,#ABSZINC,#ZABSORIGINHOLD
%DECLARE=#EXACTSTOP
%DECLARE=#INCANGLE,#ABSXINC,#ABSYINC,#TRUE,#FALSE,#LEFT,#RIGHT,#PI,#SKIP
%DECLARE=#COOLHOLD,#XSUB,#YSUB,#ZSUB
* #RECORD
*	Multi-plane / Rotary
%DECLARE=#ROTARYGCODE,#ROT1DIR,#ROT2DIR
%DECLARE=#ROT1,#ROT2,#ROT1HOLD,#ROT2HOLD,#ROT1REVERSE,#ROT2REVERSE,#ROTTYPE
%DECLARE=#ROT,#ROTINCR
%DECLARE=#WRAPTYPE,#WRAPHEIGHT
%DECLARE=#G54FROMHOME,#UNIQUEDATUMS,#SYSID
%DECLARE=#ROTDIRMCODE,#ROT1OFFSET,#ROT2OFFSET,#ROTARYAXES,#WRAPHOLD
%DECLARE=$PLANAR,$ORIENTATION,$LINEARAXIS,$ACTIVEROTAXIS
%DECLARE=$ROT1,$ROT2,#SKIPROT
%DECLARE=$COMPOUTPUT,#ROTARYTYPE,#XSTART,#XEND,#YSTART,#YEND
%DECLARE=#LEADOUTCOUNT,#COMPFACTOR,#PRECISION,#EXACTGCODE
%DECLARE=#ROTVALS,#LIMIT360,#LIMIT180
%DECLARE=#FORCEXYZ

*	M-FUNCTIONS
%DECLARE=$MCODE
%DECLARE=#HIGHSPEEDTOL

*Thread Mill
%DECLARE=#THRDLEAD,#KVALSAVE,#BLOCKSMISSED,#THREADSINGLE,#NEXTTYPE
%DECLARE=#NEXTLOOP,#NEXTRADIUS,#OUTPUTHELIX,#ARCRADIUS,#TYPE,#THISRAD

*User variables for ;CODE command - extended for EC5.5
%DECLARE=#USER1,#USER2,#USER3,#USER4,#USER5,#USER6,#USER7,#USER8,#USER9,#USER10,#USER11,#USER12,#USER13,#USER14,#USER15,#USER16,#USER17,#USER18,#USER19,#USER20
%DECLARE=$USER1,$USER2,$USER3,$USER4,$USER5,$USER6,$USER7,$USER8,$USER9,$USER10,$USER11,$USER12,$USER13,$USER14,$USER15,$USER16,$USER17,$USER18,$USER19,$USER20,$USER

* Variables for ECS2700
%DECLARE=#XSWITCH,#YSWITCH,#ZSWITCH,#PLANESET,#PLANESWITCH
%DECLARE=$G16CODE,$CYCLEAXIS,$G16HOLD,$TOOLAXIS
%DECLARE=#ENDSUB
%DECLARE=#ECSHOLECYCLE
%DECLARE=#ZDRILL
%DECLARE=#XCPLINIT,#YCPLINIT,#ZCPLINIT

*Variables for expanded datum setting (ECS2700)
%DECLARE=#G5401,#G5402,#G5403,#G5404,#G5405,#G5406,#G5407,#G5408,#G5409,#G5410
%DECLARE=#G5411,#G5412,#G5413,#G5414,#G5415,#G5416,#G5417,#G5418,#G5419,#G5420
%DECLARE=#G5401CODE,#G5402CODE,#G5403CODE,#G5404CODE,#G5405CODE
%DECLARE=#G5406CODE,#G5407CODE,#G5408CODE,#G5409CODE,#G5410CODE
%DECLARE=#G5411CODE,#G5412CODE,#G5413CODE,#G5414CODE,#G5415CODE
%DECLARE=#G5416CODE,#G5417CODE,#G5418CODE,#G5419CODE,#G5420CODE

* Variables for Thread Mill canned cycle
%DECLARE=#THREADDIA,#THRDPLUNGE,#THRDSTARTZ,#THRDENDZ,#THRDCLEAR
%DECLARE=#THRDXPLUNGE,#THRDYPLUNGE,#THRDX,#THRDY,#THRDINOUT,#THRDOUTCODE,#THRDINCODE
%DECLARE=#PLUNGERAD,#THRDFEED,#THRDPOSFEED,#THRDCLIMB,#THRDARCDIR
*** End of include file B:\Pams\cam\machdef\template\MDECLARE.CGI ***
*** Start of include file MMFANUC.CGI ***
*************************************************************************
*   Machine independant Code Generator include file                     *
*                                                                       *
*   Filename:	MMACRO.CGI                                              *
*	Author:		ADM (Derived from 3AXM-FAN.CGS -r1.41                   *
*          		and 3AXM-HH.CGS -r1.25)                                 *
*   Date:		6th December 1996                                       *
*                                                                       *
*************************************************************************
*   Change History                                                      *
*     Initial Version - Included fixes for db9831 and db9843            *
*   16/12/96 ADM -  Allow user to specify workshift user var if 3AXMILL *
*                   only (db9739)                                       *
*   27/01/97 ADM -  use NEXTZMOVE instead of ZMOVE in                   *
*                   RAPID_AFTER_TOOLCHANGE (db9822)                     *
*                   fix logic problems with X_REVERSE and option repeat *
*					machining (db8921 & db8923)                         *
*   03/02/97 ADM -  Moved NEXTTOOL logic from token to the toolchange   *
*                   macro                                               *
*   05/02/97 ADM -  fixed incorrect block numbers and comp code on      *
*                   mirror. Also fixed reseting of incremental datum    *
*                   shifts.                                             *
*   10/02/97 ADM -  added logic to set NEXTTOOL token to the first tool *
*                   if last toolchange                                  *
*   11/02/97 ADM -  added logic to prevent workshift override on TL     *
*                   when DS has been used (db9739:1)                    *
*   21/04/97 ADM -  db10043 - allow cutter comp on thread milling       *
*                   db10098 - remove speed modifier from toolchange     *
*   03/06/97 ADM -  db10191 - redirect drill macro via nocycle if       *
*                   rotary rotate used                                  *
*	06/10/97 SME -  FEED system variable used instead on XYFEED ZFEED   *
*					See \\sprog\projects\plc\surfmach\fspec\fsfeedrate.doc
*   03/11/97 ADM -  Suppress 3 axis rapid move when using Transform -   *
*                   Repeat (db10323)                                    *
*   04/11/97 ADM -  Prevent output of Z values in sub-routine for       *
*                   Heidenhain template (db10328).                      *
*   07/11/97 ADM -  allow DWELL token in Heidenhain hole cycles(db10327)*
*   13/11/97 ADM -  Add option for CRC register as Maxtools + tool      *
*                   count (db9633)                                      *
*   18/11/97 ADM -  Allow seperate code constructor for hole cycle      *
*                   points for Fanuc template (db10455 & db9616)        *
*   21/11/97 ADM -  Axis Reverse option now affects home and toolchange *
*                   positions (spotted when fixing db10578)             *
*   28/11/97 ADM -  Warn if no Rapid to Toolchange prior to Toolchange  *
*                   (db10589)                                           *
*   02/03/98 ADM -  Implement TNC400 Q parameter hole cycles (db10347)  *
*                   Implement TNC400 rigid tapping (db10329)            *
*                   Fixed feedrate output for angular moves (db10684)   *
*   09/03/98 ADM -  Implement spline output for Fanuc and TNC400 (C1&C2)*
*   23/03/98 ADM -  Move to Toolchange/Home now obeys setting of        *
*                   First/Fixed modifiers (db10770)                     *
*   23/03/98 ADM -  Properly fixed feedrate for angular moves (db10684) *
*   30/03/98 ADM -  Changes to warning messages for new Warning codecon *
*   17/06/98 ADM    db10854/db10857 implement language independance     *
*   17/08/98 ADM -  Heidenhain now uses #EXACTGCODE not #EXACTSTOP      *
*                   (db10822)                                           *
*   22/09/98 RHA -  $COMP settings removed from macro 29 - new procedure*
*                   Spline procedures renamed (and now in m/c specific files)
*                   Deckel specific comp settings removed               *
*                   $CONTINUE made local to TNC400                      *
*   19/10/98 RHA -  Corrections to Subroutine call positioning in       *
*                   Macros 32/59.  NB does not apply to Heidenhain      *
*                   Force #TOOLCHANGE=#FALSE in macros 2/3/4/5          *
*                   (corrects speeds problem if no rapid after toolchange)
*   21/10/98 RHA -  Macro 59 modified to allow subcall in cycles to work*
*                     (Moved @END above %CALL=PT......)                 *
*   08/12/98 RHA _  Remove #TOOLCHANGE=#FALSE in macros 4/5             *
*                   Set #ROT angles in macros 1/2/3 only if not planar  *
*                   set #ROT angles in macro 38                         *
*   10/12/98 RHA    Use of #ROTVALS for INDEX ROT-ROTATE differentiation*
*                     see note/comment in macro 15                      *
*   18/12/98 RHA -  DB11147  DB11151  DB11154 (Non-Heidenhain types)    *
*                   Use of MASK in Subroutine macros corrected          *
*                   Use of MASK in HOLD corrected                       *
*                   G92 datum resets corrected for abs subroutines      *
*************************************************************************
*   17/06/99 RHA    Processing moved to Mproceed.cgi for long macros    *
*                   PMACRO-2 PMACRO-15 PMACRO-29 PMACRO-32 PMACRO-35 PMACRO-RESET*
*                   Hole cycle procedures moved to mproceed.cgi         *
*                   Mmacro file copied to create m/c specific files     *
*                   Macro specific debug removed, Proc trace reset added*
*                   Hole cycle macros moved in from m/c file            *
* 03/09/99  RHA  DB11325 - Thread mill macro modifiers corrected        *
* 07/01/00  RHA  DB11691 - Order of procedure calls standardised, macros 40/1 & Spline
* 11/07/00 RHA DEV00000290 Ensure #MACRO is set by all standard macros
* 08/02/01 RHA DEV00002467 Suppress CRC in macro=5 until subfunct is set
* 25/05/01 RHA DEV00003177 Set #XTOOL etc correctly for fixed axes. Macros 40/41
* 20/02/03 RHA DEV00007049 Make Exact stop properly switchable
* 21/02/03 RHA DEV00007249 Suppress hole cycle subroutine with no points
* 27/08/03 RHA DEV00007609 Add PMACRO calls to Macros 40 and 41
* 03/12/03 RHA DEV00009395 Correct TLO with HPCC
* 11/08/04 RHA DEV00011656 Set #HOLECYCLE2=0 in macro 55 for subroutine appraoach control
* Version 10.5
* 11/11/05 RHA DEV00011656 Activate planar rotate with subroutines
* Version 12.25
* 03/12/07 RHA DEV00021534 Enable longhand tapping
*************************************************************************

;
;                                                           Ŀ
;Ĵ Macro = 1   
;                                                           
%MACRO=1=RA=Rapid move=1,2,3,
$SPC=" "; Reset trace spacing
#MACRO=1


#XMOVE=XMOVE:#YMOVE=YMOVE:#ZMOVE=ZMOVE
%CALL=PT_OUTPUT_RAPID
@END
%ENDM

;                                                           Ŀ
;Ĵ Macro = 2   
;                                                           
%MACRO=2=FE=Feed move=1,2,3,5,6,7,
$SPC=" "; Reset trace spacing
#MACRO=2

%CALL=PMACRO-2

%ENDM

;                                                           Ŀ
;Ĵ Macro = 3   
;                                                           
%MACRO=3=CI=Circular feed move=1,2,5,7,
$SPC=" "; Reset trace spacing
#MACRO=3

* Force #TOOLCHANGE=#FALSE to prevent SPEEDS lookahead
#TOOLCHANGE=#FALSE


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 4   
;                                                           
%MACRO=4=FM=Face milling cycle=1,2,9,5,6,7,
$SPC=" "; Reset trace spacing
#MACRO=4


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 5   
;                                                           
%MACRO=5=PR=Profiling cycle=4,5,6,7,9,12,13,21[$Y],22[$N],24,25,
$SPC=" "; Reset trace spacing
#MACRO=5


* Suppress CRC calls until Subfunct is set
$COMPOUTPUT=TRUE
#COMPGCODE=#FUNNY

%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 6   
;                                                           
%MACRO=6=AC=Area clearance cycle=4,5,6,7,9,12,16,22[$N],
$SPC=" "; Reset trace spacing
#MACRO=6


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 7   
;                                                           
%MACRO=7=SL=Slot profiling cycle=4,5,6,7,9,
$SPC=" "; Reset trace spacing
#MACRO=7


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 8   
;                                                           
%MACRO=8=XH=Xhatch area clearance=4,5,6,7,9,12,16,49,
$SPC=" "; Reset trace spacing
#MACRO=8


%NOCYCLE
%ENDM

***********************************************************************************
*  COPY DRILL MACROS HERE  $SPC=" "; Reset trace spacing
***********************************************************************************


%MACRO=14=MR=Move relative to profile=4,9,12,13,59,60,5,6,7,
$SPC=" "; Reset trace spacing
#MACRO=14


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 15  
;                                                           
%MACRO=15=TL=Toolchange=8,47,48,68,69,70,
$SPC=" "; Reset trace spacing
#MACRO=15

%CALL=PMACRO-15

%ENDM
;                                                           Ŀ
;Ĵ Macro = 21  
;                                                           
%MACRO=21=FR/FM=Feed per rev / Feed per min=
$SPC=" "; Reset trace spacing
#MACRO=21

%IF SUBFUNCT=1 %THEN #FEEDMODEGCODE=DATA1(46)		;	Feed / rev (G95)
%IF SUBFUNCT=2 %THEN #FEEDMODEGCODE=DATA1(45)		;	Feed / min (G94)
%CALL=CODECON_FEED-MIN-REV
%ENDM
;                                                           Ŀ
;Ĵ Macro = 22  
;                                                           
%MACRO=22=DW=Dwell=27,
$SPC=" "; Reset trace spacing
%IF #SKIPTAP=1 %THEN #SKIPTAP=#FUNNY:%GOTO @END
#MACRO=22

#DWELLGCODE=DATA1(5)
%CALL=CODECON_DWELL
@END
%ENDM
;                                                           Ŀ
;Ĵ Macro = 29  
;                                                           
%MACRO=29=NC/CL/CR=Compensation off/left/right=67,=  COMP OFF/ COMP LEFT/COMP RIGHT
$SPC=" "; Reset trace spacing
#MACRO=29

%CALL=PMACRO-29

%ENDM

;                                                           Ŀ
;Ĵ Macro = 30  
;                                                           
%MACRO=30=MS=Matrix mode on=43,44,38,39,40,41,21[$Y],82,
$SPC=" "; Reset trace spacing
#MACRO=30

%ENDM
;                                                           Ŀ
;Ĵ Macro = 31  
;                                                           
%MACRO=31=MO=Matrix mode off=
$SPC=" "; Reset trace spacing
#MACRO=31

%ENDM
;                                                           Ŀ
;Ĵ Macro = 32  
;                                                           
%MACRO=32=TR=Translate=43,44,45,14,26,37,21,
%IF MASK=1 @END
$SPC=" "; Reset trace spacing
#MACRO=32

%CALL=PMACRO-32

@END
%ENDM
;                                                           Ŀ
;Ĵ Macro = 33  
;                                                           
%MACRO=33=RO=Rotate=1,2,14,26,24,37,21[$N],
$SPC=" "; Reset trace spacing
#MACRO=33

%IF PATHTRACE=1 %THEN %NOCYCLE ; Longhand

%IF #COUNT=#FUNNY %THEN #COUNT=0
#COUNT=#COUNT+1
#ROT1=ANGLE*#COUNT

%CALL=PMACRO-32

%ENDM

;                                                           Ŀ
;Ĵ Macro = 34  
;                                                           
%MACRO=34=MI=Mirror=1,2,14,26,-21[$Y],
$SPC=" "; Reset trace spacing
#MACRO=34

#MIRROR=1
%NOCYCLE	;	Longhand only
%ENDM
;                                                           Ŀ
;Ĵ Macro = 35  
;                                                           
%MACRO=35=PE=Peck=14,26,45,9,29,21,58,
$SPC=" "; Reset trace spacing
#MACRO=35

%CALL=PMACRO-35

%ENDM

;                                                           Ŀ
;Ĵ Macro = 36  
;                                                           
%MACRO=36=TC/TM/TF=SELECT CUT TYPE OVERRIDE=
$SPC=" "; Reset trace spacing
#MACRO=36

%ENDM
;                                                           Ŀ
;Ĵ Macro = 37  
;                                                           
%MACRO=37=th=THREAD MILL=7,
$SPC=" "; Reset trace spacing
#MACRO=37

%CALL=PMACRO-37

%ENDM

;                                                           Ŀ
;Ĵ Macro = 40  
;                                                           
%MACRO=40=RH=Rapid to home=
$SPC=" "; Reset trace spacing
#MACRO=40

%CALL=PMACRO-40

%CALL=PT_RAPID_TO_HOME_TOOLCHANGE

%CANCEL=#GCODE,#XMOVE,#YMOVE,#ZMOVE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 41  
;                                                           
%MACRO=41=RT=Rapid to tool change=
$SPC=" "; Reset trace spacing
#MACRO=41

%CALL=PMACRO-41

%CALL=PT_RAPID_TO_HOME_TOOLCHANGE

%CANCEL=#GCODE,#XMOVE,#YMOVE,#ZMOVE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 42  
;                                                           
%MACRO=42=RI=Rapid to initial plane=
$SPC=" "; Reset trace spacing
#MACRO=42

%NOCYCLE				;	Process through rapid macro
%ENDM
;                                                           Ŀ
;Ĵ Macro = 43  
;                                                           
%MACRO=43=IP=Index pallet=57,
$SPC=" "; Reset trace spacing
#MACRO=43

%GETCPL=SUBFUNCT
#ZTOOLSUB=ZSUB

* #ROTVALS controls use of ROT1/ROT2 values for rotary positioning
#ROTVALS=#FALSE

%CALL=SELECT_WORK_DATUMS

%ENDM
;                                                           Ŀ
;Ĵ Macro = 46  
;                                                           
%MACRO=46=MR=Move relative2=4,59,7,5,
$SPC=" "; Reset trace spacing
#MACRO=46


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 47  
;                                                           
%MACRO=47=MR=Move Constrain=4,59,7,5,
$SPC=" "; Reset trace spacing
#MACRO=47


%NOCYCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 48  
;                                                           
%MACRO=48=DS=DATUM SHIFT=
$SPC=" "; Reset trace spacing
#MACRO=48

%GETCPL=SUBFUNCT
#ZTOOLSUB=ZSUB
%CALL=SELECT_WORK_DATUMS
%ENDM
;                                                           Ŀ
;Ĵ Macro = 53  
;                                                           
%MACRO=CLW
$SPC=" "; Reset trace spacing
#MACRO=53

#GCODE=DATA1(3)
%CALL=CIRCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 54  
;                                                           
%MACRO=CCLW
$SPC=" "; Reset trace spacing
#MACRO=54

#GCODE=DATA1(4)
%CALL=CIRCLE
%ENDM
;                                                           Ŀ
;Ĵ Macro = 55  
;                                                           
%MACRO=SUBSTART
$SPC=" "; Reset trace spacing
#MACRO=55
#HOLECYCLE2=0 ; Initialise for cyclesub identification

*				Only applies to Subprogram style NOT inline block number reference.
%IF MASK=1 @END

*Set HOLD values
#XHOLD=XSUB
#YHOLD=YSUB
#ZHOLD=ZSUB

%CALL=PT_OUTPUT_SUBSTART

@END
%ENDM
;                                                           Ŀ
;Ĵ Macro = 56  
;                                                           
%MACRO=SUBEND
$SPC=" "; Reset trace spacing
#MACRO=56

%CALL=PT_OUTPUT_SUBEND

%ENDM
;                                                           Ŀ
;Ĵ Macro = 59  
;                                                           
%MACRO=SUBCALL
$SPC=" "; Reset trace spacing
#MACRO=59

%CALL=PT_OUTPUT_SUBCALL

%ENDM
;                                                           Ŀ
;Ĵ Macro = 60  
;                                                           
%MACRO=RESET
$SPC=" "; Reset trace spacing
#MACRO=60

%CALL=P-RESET

%ENDM
;                                                           Ŀ
;Ĵ Macro = 61  
;                                                           
%MACRO=CYCLSUB
$SPC=" "; Reset trace spacing
#MACRO=61


%IF LAST<2 @SKIP

$OUTPUTSUBS=TRUE

%CALL=PT_OUTPUT_SUBSTART;	Subroutine start
%CALL=PT_HOLE_CYCLES	;	Output hole cycle
%CALL=PT_OUTPUT_SUBEND  ;	Subroutine end

$OUTPUTSUBS=FALSE

@SKIP
%ENDM
;                                                           Ŀ
;Ĵ Macro = 71  
;                                                           
%MACRO=71=..=ATTRIBUTE=
$SPC=" "; Reset trace spacing
#MACRO=71

* SF201 Reverse spindle in longhand tapping
%IF SUBFUNCT=201 %THEN %CALL=PT_TAPPING_REVERSE

%ENDM
;
;                                                           Ŀ
;Ĵ Macro = SPLINE   
;                                                           
%MACRO=SPLINES
$SPC=" "; Reset trace spacing
#MACRO=72
;	Parameter		Variable
;
;	X point			XMOVE
;	Y point			YMOVE
;	Z point			ZMOVE
;	Feedrate		FEED
;	Speed			SPEED
;	Order of curve	FIELD1
;	Knott value		FIELD2
;	Weight			FIELD3
;	First point		SUBFUNCT=1
;	Last point 		SUBFUNCT=2
;	Tolerance		TOLERANCE
;Note:- SUBFUNCT will be set to 0 except for the first and last point

#XMOVE=XMOVE:#YMOVE=YMOVE:#ZMOVE=ZMOVE
#FEED=XYFEED:#SPEED=SPEED
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
%CANCEL=#XMOVE,#YMOVE,#ZMOVE

*%IF $MACHINE="HEIDENHAIN" %THEN %CALL=TNCSPLINE %ELSE %CALL=FANUCSPLINE
* procedure is now always called SPLINE and is in machine specific .cgi
%CALL=SPLINE

%IF SUBFUNCT<>2 @END

%CALL=HOLD
@END
%ENDM


*************************************************************
*	Miscellaneous "User Defined" Macros : Reserved			*
*	==============================================			*
*															*
*************************************************************
*	101		Spindle				Stop/ CLW/ CCLW/ CLW+Coolant/ CCLW+Coolant
*	102		Reserved (Used by software?)
*	103		Stop Type			Program/ Optional
*	104		Coolant				Flood/ Mist/ Off
*	105		Block Skip			Off/ On
*	106		Exact Stop/Smooth	Off/On
*	107		Reserved (Used by software?)
*	108		Comment				Text string input
*	109		Insert NC Code		NC code literal input
*	110		High Speed M/C		Off/On  ;Located in 3m-START.xxx since its machine specific
*	111		Reserved
*	112		Reserved
*	113		Reserved
*	114		Reserved
*	115		Reserved
*	116		Length Offset		Tool Length Offset
*	117		Reserved
*	118		Reserved
*	119		Reserved
*	120		Reserved
*	121		Reserved
*	122		Reserved
*	123		Reserved
*	124		Reserved
;                                                           Ŀ
;Ĵ Macro = 101 
;                                                           
%MACRO=101=../../..=Spindle==   Stop/CLW/CCLW/CLW + Coolant/CCLW + Coolant
$SPC=" "; Reset trace spacing

%IF SUBFUNCT=1 %THEN #DIRECTION=DATA2(6)			;	Stop					(M05)
%IF SUBFUNCT=2 %THEN #DIRECTION=DATA2(4)			;	Forward					(M03)
%IF SUBFUNCT=3 %THEN #DIRECTION=DATA2(5)			;	Reverse					(M04)
%IF SUBFUNCT=4 %THEN #DIRECTION=DATA2(14)		;	Forward + Coolant		(M13)
%IF SUBFUNCT=5 %THEN #DIRECTION=DATA2(15)		;	Reverse + Coolant		(M14)

%CALL=CODECON_SPINDLE
@END
%ENDM
;
;                                                           Ŀ
;Ĵ Macro = 103 
;                                                           
%MACRO=103=..=Stop Type==Program/Optional
$SPC=" "; Reset trace spacing

%IF SUBFUNCT=1 %THEN #STOPMCODE=DATA2(1)			;	M00
%IF SUBFUNCT=2 %THEN #STOPMCODE=DATA2(2)			;	M01
%IF $MACHINE="HEIDENHAIN" %THEN #STOPMCODE=DATA2(1)

%CALL=CODECON_PROGRAM-STOP

%CANCEL=#XMOVE,#YMOVE,#ZMOVE,#SPEED,#FEED
%ENDM
;                                                           Ŀ
;Ĵ Macro = 104 
;                                                           
%MACRO=104=../..=Coolant==Flood/Mist/Off
$SPC=" "; Reset trace spacing

%IF SUBFUNCT=1 %THEN #COOL=DATA2(8)		;	Flood
%IF SUBFUNCT=2 %THEN #COOL=DATA2(9)		;	Mist
%IF SUBFUNCT=3 %THEN #COOL=DATA2(10)		;	Off

%CALL=CODECON_COOLANT

@END
%ENDM
;                                                           Ŀ
;Ĵ Macro = 105 
;                                                           
%MACRO=105=../..=Block Skip==Off/On
$SPC=" "; Reset trace spacing

%IF SUBFUNCT=2 %THEN #DELETE=0 %ELSE #DELETE=#FUNNY
%ENDM
;                                                           Ŀ
;Ĵ Macro = 106 
;                                                           
;
%MACRO=106=../..=Exact Stop/Smooth==Off/On
#MACRO=106

#EXACTSTOP=SUBFUNCT

%IF #EXACTSTOP=2 %THEN #EXACTGCODE=DATA1(10) %ELSE #EXACTGCODE=DATA1(9)
%IF #EXACTGCODE<0 %THEN #EXACTGCODE=#FUNNY ; Null setting

%CALL=CODECON_EXACT-STOP

%ENDM
;                                                           Ŀ
;Ĵ Macro = 108 
;                                                           
%MACRO=108=..=Comment=15,
$SPC=" "; Reset trace spacing

%CALL=CODECON_COMMENT

@END
%ENDM
*
;                                                           Ŀ
;Ĵ Macro = 109 
;                                                           
;
%MACRO=109=..=Insert Nc Code=15[ ],
$SPC=" "; Reset trace spacing

%CALL=CODECON_INSERT-NC-CODE
%ENDM
*
*
;                                                           Ŀ
;Ĵ Macro = 116 
;                                                           
%MACRO=116=..=Length Offset=69[0],
$SPC=" "; Reset trace spacing

%CALL=PT_SET_TLO

%CALL=CODECON_SELECT-LENGTH-OFFSET
%ENDM
*** End of include file B:\Pams\cam\machdef\template\MMFANUC.CGI ***
*** Start of include file MPROCEED.CGI ***
**************************************************************************
*   Machine independant Code Generator include file                      *
*                                                                        *
*   Filename:	MPROCEED.CGI                                             *
*	Author:		ADM (Derived from 3AXM-FAN.CGS -r1.41                    *
*          		and 3AXM-HH.CGS -r1.25)                                  *
*   Date:		6th December 1996                                        *
*                                                                        *
**************************************************************************
*   Change History                                                       *
*     Initial Version - Included fixes for db9831                        *
*   16/12/96 ADM -  implemented swapping of CLW/CCLW codes for YZ        *
*                   and XZ planes (db9725)                               *
*   27/01/97 ADM -  use NEXTZMOVE instead of ZMOVE in                    *
*                   RAPID_AFTER_TOOLCHANGE (db9822)                      *
*                   fix logic problems with X_REVERSE and option repeat  *
*					machining (db8921 & db8923)                          *
*   03/02/97 ADM -  fix compensation applied on Z move-Heidenhain (9935) *
*                   support incremental/absolute datum shift (9008)      *
*                   fix calling nomotion to late                         *
*   05/02/97 ADM -  fixed incorrect block numbers and comp code on       *
*                   mirror. Also fixed reseting of incremental datum     *
*                   shifts.                                              *
*   10/02/97 ADM -  fixed calling nomotion to early                      *
*   11/02/97 ADM -  worshift reset on exit from SET_WORK_DATUMS          *
*   03/04/97 ADM -  logic for reverse ZX arcs corrected                  *
*   21/04/97 ADM -  db9954 - fix adjust feedrate on mirrored arcs        *
*                   db10043 - allow cutter comp on thread milling        *
*   16/06/97 ADM -  db10165 - IJK values for Thread Milling corrected    *
*                   Also - Compensate for TLO bug fixed and axis reverse *
*                   now works correctly for absolute arc centre, and     *
*                   has been implemented for thread milling              *
*   19/06/97 ADM -  db10232 - radius now signed correctly and radius     *
*                   now calculated correctly for rotary machined arcs    *
*   26/06/97 ADM -  db10240 - adjusted feedrate now handles case of      *
*                   external arc radius less than tool radius. Also now  *
*                   handles Pathtrace and Controller output correctly    *
*	06/10/97 SME -  FEED system variable used instead on XYFEED ZFEED    *
*					See \\sprog\projects\plc\surfmach\fspec\fsfeedrate.doc
*   04/11/97 ADM -  Prevent output of Z values in sub-routine for        *
*                   Heidenhain template (db10328). Cycle Z Depths option *
*                   now affects output of the ZDEPTH token (db10340)     *
*   04/11/97 ADM -  prevent output of static axis tokens for plane       *
*                   switched arcs (db10457)                              *
*   06/11/97 ADM -  Deckel specific logic added to CRC_HANDLER so that   *
*                   cutter compensation is correctly applied (db10245)   *
*   07/11/97 ADM -  Allow DWELL token on Heidenhain hole cycles (db10327)*
*   11/11/97 ADM -  Call PT_ROTARY_AXES and associated procedures        *
*                   so that Reverse Axis and Start At settings affect    *
*                   Rotary moves (db10246 and db10358)                   *
*   14/11/97 ADM -  Do not force output of rotary axes on first hole     *
*                   position when rotary drilling (db10542)              *
*   18/11/97 ADM -  Allow seperate code constructor for hole cycle       *
*                   points for Fanuc template (db10455 & db9616)         *
*   21/11/97 ADM -  Prevent X,Y, and Z from being reversed twice before  *
*                   hole cycledef when Axis Reverse option used (db10578)*
*   08/12/97 ADM -  Call PT_ROTARY_AXES in PT_CONVERT_COORDS for rotary  *
*                   and multiplane drilling                              *
*   11/12/97 ADM -  Prevent PT_CONVERT_COORDS from changing #ROT1 when   *
*                   axial drilling using the secondary rotary axis       *
*   16/12/97 SME -  #HOLECYCLE flag used to skip rotary assignment in    *
*                   PT_OUTPUT_RAPID                                      *
*   19/12/97 ADM -  Skip calls to PT_CONVERT_COORDS if not MPLMILL       *
*   13/02/98 ADM -  If #WORKGCODE is not changed then do not set to      *
*                   #FUNNY in SELECT_WORK_DATUMS (db10652)               *
*   18/02/98 ADM -  Set #BNUMVAR to 0 if run through MASK else set to    *
*                   #BNUMINC in PT_OUTPUT_SUBSTART. Do not skip          *
*                   assignment of ENDSUB during MASK run (db10673)       *
*   23/02/98 ADM -  Add option to allow combined rotary/multiplane       *
*                   angular output to prevent additional moves (db10683) *
*   02/03/98 ADM -  Implement TNC400 Q parameter hole cycles (db10347)   *
*                   Implement TNC400 rigid tapping (db10329)             *
*   09/03/98 ADM -  Implement spline output for Fanuc and TNC400 (C1&C2) *
*   20/03/98 ADM -  Fixed incorrect radius output in ZX plane (db10764)  *
*   23/03/98 ADM -  Move to Toolchange/Home now obeys setting of         *
*                   First/Fixed modifiers (db10770)                      *
*   30/03/98 ADM -  Changes to warning messages for new Warning codecon  *
*   18/05/98 ADM -  Prevent 2 line output from rapid to home/toolchange  *
*                   code constructor when using literals (db10858)       *
*   15/06/98 ADM -  IK values now calculated correctly for G18 (XZ) arcs *
*                   (db10891)                                            *
*   17/06/98 ADM -  db10854/db10857 implement language independance      *
*   18/06/98 ADM -  Corrected error in invalid gear selected warning     *
*   22/06/98 ADM -  Change test for complete arcs to <=0.000001 (B264)   *
*   09/07/98 SME -  Added check in PT_OUTPUT_RAPID for first move after  *
*                   toolchange when drilling (db10824)                   *
*   09/07/98 SME -  Indone change made for db10891. Nothing seems to be  *
*                   needed.                                              *
*   22/09/98 RHA _  Settings of $COMP removed from procedures			 *
*                   set by machine specific procedure SET_COMP_TO_STRING *
*                   Spline procedures moved to machine specific files    *
*                   Deckel specific comp settings removed                *
*   28/09/98 RHA -  DWELL=#FUNNY removed from G83 processing (Siemens)   *
*   08/10/98 RHA -  Recalculation of tapping ZFEED removed (db11030)     *
*   09/10/98 RHA -  Call hole-cycle-points added for CINCINNATI (db11017)*
*                                                                        *
*   23/10/98 RHA -  Unwanted words suppressed, Cincinnati holes in subroutines  *
*                                                                        *
*   29/10/98 RHA -  Changes resulting from Siemens840 testing            *
*                   Always set up IJK modes, even if R preferred         *
*                   #G18SWAP & #G19SWAP processing made independant      *
*   05/11/98 RHA -  Corrections to G98/9 emulation                       *
*                   1. Jump emulation if constant height pattern         *
*                   2. Call cycle codecon for each point if emulating G98/9
*                   3. Retract moves now call codecon_Rapid direct.      *
*                   4. FADAL added to hole cycle point processing options*
*                   Use of #INDEX variable removed                       *
*                   Changes to PT_CONVERT_COORDS (db11079)               *
*                   1.  Debug calls corrected (Procedure name)           *
*                   2.  Stationary axis set to 0 instead of FUNNY        *
*                   3.  Explanatory notes added at start                 *
*                   4.  %ENDM directive moved out of ;IF group           *
*   17/11/98  RHA   ROT_HOLD vars set to ROT1 ROT2 instead of #ROT1 #ROT2*
*   08/12/98  RHA   Correction to PT_CONVERT_COORDS to call PT_ROTARY_AXES*
*                   Correction to HOLD var checking in NOMOTION          *
*                   Remove #rot angles setting from PT_ROTARY_AXES calls *
*   10/12/98  RHA   Calls to PT_ROTARY_AXES controlled by #ROTVALS       *
*   18/12/98  RHA   DB11151  DB11147  DB11154                            *
*                   Use of MASK corrected in HOLD & Subroutine procedures*
*                   #ZHOLD corrected for holes in HOLD                   *
*   08/01/99  RHA   DB11027 - Suppress nomotion arcs (single quads only) *
*                   DB10886 - Set #HOLECYCLE in PT_HOLE_CYCLE_HH to      *
*                             control #ZHOLD setting in HOLD             *
*   11/03/99  RHA   Changes for controller compensation					 *
*                   Setting and use of #LEADOUTCOUNT changed for EC4.00  *
*					Range check of FIELD12 variable added                *
*   10/05/99  RHA   Use of #TEMP removed to save var name                *
*                   #RECORD                                              *
*   14/05/99  RHA   DB11332 $DESCR initialised "", ensures token requests value
*                   (Replaces previous (lost) change under DB10931)      *
*   14/06/99  RHA   DB11219 - Skip points when calling sub-prog corrected*
*                   & removed redundant @GOTO     (PT_HOLE_CYCLES_HH)    *
*   17/06/99  RHA   New procedures added to contain logic from macros    *
*                   PMACRO-2 PMACRO-15 PMACRO-29 PMACRO-32 PMACRO-35 PMACRO-RESET *
*                   (Generic macro file copied to m/c specific files)    *
*                   Procedure trace mechanism installed                  *
*  21/06/99 RHA DB11095 Correct RESET processing   Procedure=PMACRO-32   *
*                       Var content comments PMACRO-32 & PMACRO-RESET    *
*  24/06/99 RHA DB11377 Set HOLD values for hole cycles PT_HOLE_CYCLES   *
*  25/06/99 RHA DB11377 Set #ZMOVE to #ZDEPTH after incr calcs PT_HOLE_CYCLES   *
*  25/06/99 RHA DB11374 Removed angle precision calcs from NOMOTION      *
*                           (Prevented -0.0 output)                      *
*  29/06/99 RHA DB11458 %CALL=CODECON_CUTTER-COMPENSATION added for cancel comp
*  01/07/99 RHA DB11377 Branch on $OUTPUTSUBS corrected to allow for null *
*  06/07/99 RHA DB11261 3D Rapid to Home/Toolchange corrected            *
*  20/07/99 RHA DB11141 Block number reset added - PT_BINC               *
*  23/07/99 RHA         Modified PT_HOLE_CYCLES for Grundig532           *
*  09/08/99 RHA DB11551 Check for thread mill data added to PMACRO-37    *
*                       Array debug added to PMACRO-37 (& Commented out) *
*  10/08/99 RHA DB11566 Tool text data retrieval added, set_tooling_data *
*  22/09/99 RHA DB11657 Use of MASK in Procedure=HOLD corrected          *
*  12/10/99 RHA DB11697 XYZ Rounding added to PT_INCREMENTAL_XYZ for increased incremental accuracy     *
*  07/01/00 RHA DB11774 Corrections to PT_CONVERT_COORDS
*                           Make inactive rotary axis =#funny
*                           Correct #hold values for axial orientation
*                           Redundant ;IF ;ENDIF removed
*                           Some simplification of procedure structure
* 07/01/00 RHA DB11691 Call order of COMP_TLO, INCXYZ, REVERSE standardised throughout
*                      Precision rounding moved to PT_SET_PRECISION
*					   NOMOTION check moved from CIRCLE to PT_OUTPUT_ARC
*                      Stationary axis reset in Procedure=CIRCLE
* 24/01/00 RHA DB11691 Hole Cycle parameters Z Reverse added
*                      Thread milling Z reversal corrected.
* 09/02/00 RHA DB11930 Skip P-RESET processing if next macro is datum shift
*                      Prevent "null" G92 output from P-MACRO32
* 14/02/00 RHA DB11745 Use of absinc etc in SUBSTART corrected
* 07/03/00 RHA DB11941 All CRC warnings now controlled by #WARNCRC
*                      Cancel CRC allowed on Z move if required, #CRCONZ
* 08/03/00 RHA DB11952 Remove unwanted Z moves from single level hole cycles
*                      Add safety Z check to Rapid approach to cycles.
* 15/03/00 RHA         Further correction to P-RESET processing if next macro
*                      is datum shift to allow shifts to accumulate.
* 16/03/00 RHA DB12104 Correct NOMOTION check in incremental. Move to PT_INCREMENTAL_XYZ.
* 16/03/00 RHA DB12053 PT_CYCLE_DEPTHS - make R word abs/inc with Z depth
* 23/03/00 RHA         Correction to fixed axis in single block PT_RAPID_TO_HOME_TOOLCHANGE
* 16/05/00 RHA DB12120 DB10191 "fix" applied to all hole cycles to prevent output of cycle in rotary rotate.
* 19/05/00 RHA DB12190 Feed token set to nextfeed for rapid moves instead of #Funny PT_OUTPUT_RAPID
* 22/05/00 RHA DB11887 Change loop expansion in Hole_Cycle_Points for Maho/Grundig style
* 23/05/00 RHA DB12129 Removed #ZCLEAR=#FUNNY from suppression lines in PT_HOLE_CYCLE.
* 23/05/00 RHA DB10448 Implement Heidenhain bore cycle - remove restriction from REAM-CYCLE & BORE-CYCLE
* 24/05/00 RHA DB12073 Correct XY modality on arcs, remove force output from procedure CIRCLE
* 24/05/00 RHA DB11019/DB11341 Add PT_ARC_TURN_BRG_HH for TNC helical moves.
* 12/06/00 RHA         Correct codecon calls for loop=1 in pt_hole_cycles
* 10/07/00 RHA         Correct debug name for PROCEDURE=CIRCLE
*              DEV00000276 Correct null axis setting in CIRCLE to HOLD values
* 16/10/00 RHA DEV00000907 Suppress null legs on return to home & tool change
* 16/10/00 RHA DEV00000156 Set #ZHOLD at end of hole cycle
* 17/10/00 RHA DEV00001619 Correct M13/14 processing by tapping cycle
*                          Remove PT_TAPPING_TYPE, modify TAP-CYCLE
*              DEV00001101 Arc feed adjustment, incorrect divide by zero test removed
*              DEV00001024 Reset processing corrected P-RESET
*              DEV00001617 Correct direction for rapid/feed angular moves
* 23/10/00 RHA DEV00001648 Speed setting for token moved to PT_SPEED_SET and corrected
* 07/11/00 RHA DEV00000907 PT_RAPID_TO_HOME_TOOLCHANGE Reverse storeabs position if needed
* 09/11/00 RHA DEV00001683 Add multidepth drilling
* 13/11/00 RHA DEV00001683 modify PT_MULTI_LEVEL to read MRPLANE(#LOOP)
* 20/11/00 RHA DEV00001864 New procedures for TNC hole positions, multilevel/depth
*                          TNC426 has $MODEL set to "TNC426"
* 22/11/00 RHA DEV00001683 Suppress G98/9 emulation reset when multidepth not supported
* 23/11/00 RHA DEV00001864 Minor corrections PT_HOLE_CYCLES_TNC
* 14/12/00 RHA DEV00002128 Procedure=CIRCLE, Use #XSTOREABS etc for old position instead of #XHOLD etc
* 14/12/00 RHA DEV00002151 Toolchange position warnings expanded
* 19/12/00 RHA DEV00002154 Remove coolant from hole cycle points suppression list
* 19/12/00 RHA DEV00002152 Add SET_TOOL_TYPE procedure
* 11/01/01 RHA DEV00002249 Correct selection of Rigid tapping for Heidenhain, Procedure=Tap-Cycle
* 12/01/01 RHA DEV00002212 Correct XY modality for hole cycle definition following a tool change
* 15/01/01 RHA DEV00002142 Place %ASK for tokens PROGVERSION & PROGRAMMER in procedures
* 22/01/01 RHA DEV00002303 Correct call to CODECON_CANCEL-CUTTER-COMP for lead out in CRC Handler
* 23/01/01 RHA DEV00002321 Additional check for 360deg circle added in PT_ARC_TURN_BRG
* 25/01/01 RHA DEV00002157 Single helical block option added for thread mill
* 						   Thread mill array printout added to PMACRO-37
* 26/01/01 RHA DEV00002212 Additional correction to hole cycle procedures for XY modality
* 29/01/01 RHA DEV00000702 Corrections to CRC processing for feed moves
*              DEV00001790 Corrections to CRC cancel in thread mill
* 30/01/01 RHA             Correct CRC call for lead out in procedure=CIRCLE
* 31/01/01 RHA             Correct CRC call, thread mill lead in and warn for Z move CRC
* 08/02/01 RHA DEV00002467 Call PT_Check_lead from CRC handler, lead in
*                          Set $COMPOUTPUT=FALSE for subfunct settings 1&2 in PMACRO-2
* 13/02/01 RHA             Skip CRC checks if no CRC, PT_OUTPUT_FEED
* 27/02/01 RHA DEV00001790 Remove unwanted G40 when comp not used
* 01/03/01 RHA             Further CRC corrections, PT_OUTPUT_FEED & CIRCLE
* 08/03/01 RHA DEV00001790 further fix for thread mill lead out in pt_output_feed
* 30/05/01 RHA DEV00002318 *-1 removed from RETRACT calcs in PT_HOLE_CYCLES_HH
* 22/06/01 RHA DEV00003172 Set rotary values for SET_WORK_DATUMS
* 25/06/01 RHA DEV00003177 Correct HOLD calls, Rapid to Home / TC.
*                          Nested IFs removed from PT_RAPID_TO_HOME_TOOLCHANGE
* 28/06/01 RHA DEV00003177 Initialise rotary angles at zero for first datum setting
* 12/09/01 RHA DEV00003014 Dword only output with G41/2  PT_OUTPUT_FEED
* 12/09/01 RHA DEV00003693 Correct NOMOTION for angular moves
* 24/09/01 RHA DEV00003699 Add "ECS2700" options to hole cycles
* 26/09/01 RHA DEV00002377 Add PT_COUNT_PECKS
* 26/09/01 RHA DEV00003754 Correct rotary HOLD for Hole Positions
* 10/10/01 RHA             Set HOLD values from hole data array
* 11/10/01 RHA DEV00002359 Add switchable arc check to PT_CHECK_LEAD
* 29/10/01 RHA DEV00003699 Add 20 datum settings procedures for ECS2700
* 30/10/01 RHA DEV00003388 Implement longhand hole cycle option
* 18/03/02 RHA DEV00004875 Correct liftout position for peck Clear  PMACRO-35
* 19/03/02 RHA DEV00004819 Output CRC codes for multiple thread mill cycles
* 16/04/02 RHA DEV00005368 hole cycles, Longhand test made "=2" instead of "<>1" for safety
* 29/04/02 RHA DEV00005285 Suppress unwanted COMPDCODEs in Arcs
* 15/05/02 RHA DEV00005443 Set #HOLECYCLE=1 in PT_HOLE_POSITION_HH
* 23/05/02 RHA DEV00005526 Prevent divide by zero in PT_COMP_ARC_FEED
* 18/06/02 RHA DEV00005640 Improve G01 processing, streamline code, reduce number of %IFs
* 02/09/02 RHA DEV00006218 Changes to subroutine start points in line with EdgeCAM graphics changes
* 14/11/02 RHA DEV00006176 Correction to drill first hole in cycle array
* 18/11/02 RHA DEV00006587 Correct S Code spindle control (PT_SPINDLE)
* 21/11/02 RHA DEV00006690 Prevent Subcall approach move for repeat machining
* 27/11/02 RHA DEV00006442 Add switchable %NOCYCLE to hole cycle procedures
* 02/12/02 RHA DEV00006698 Save CPL name for use in Rapid after ToolChange
* 05/12/02 RHA DEV00006799 Feed approach move in Subcall
* 07/01/03 RHA DEV00007000 Improve divide by zero check in PT_COMP_ARC_FEED
* 21/02/03 RHA DEV00007249 Add hole cycle control switches
* 25/02/03 RHA DEV00006881 PT_COMP_ARC_FEED - remove feedrate integer conversion
* 07/03/03 RHA DEV00007249 Correct blanking of unwanted points parameters in hole cycles
* 13/03/03 RHA DEV00007462 Correct subroutine approach avoidance for holes
* 19/06/03 RHA DEV00007915 (&7983) Prevent output of uninitialised move at start of sequence (Nomotion)
* 19/06/03 RHA DEV00007757 Protect Scode from divide by zero
* 20/06/03 RHA DEV00008003 Switch thread mill cycles on PATHTRACE variable.
* 12/08/03 RHA DEV00008391 Over-ride DRILLSUB if only one hole when setting #HOLECYCLE
* 13/08/03 RHA DEV00000377 New procedure to set #HCODE
* 13/08/03 RHA DEV00007955 Force feedrate at start of subroutine #FORCEFEED
* 13/08/03 RHA DEV00007537 TLO options as for CRC
* 15/08/03 RHA DEV00008196 Correct Z Gauge adjustment for arcs
* 10/08/03 RHA DEV00008012 Correct Z reverse - Heidenhain hole cycles
* 22/08/03 RHA DEV00008536 Improve CRC warnings
* 26/08/03 RHA DEV00008539 Add warning counter
* 27/08/03 RHA DEV00007609 ToolChange & Home setting Option
* 17/09/03 RHA DEV00008761 Corrections to CRC Cancel
* 24/09/03 RHA DEV00008897 TNC Regressions - knock on from various other fixes.
*                          #ZHOLD=#ZMOVE ; Explicit set because #HOLECYCLE=1
* 02/10/03 RHA DEV00008897 Remove Z set where ZMOVE=#FUNNY
*						   Fix to multilevel - PT_GET_NEXT_HOLE
* 09/10/03 RHA DEV00008984 Lift to clearance for drill cycle
*                          Allow for reversed Z in moves to ZCLEAR (PT_HOLE_CYCLES)
*                          Correct output with Z reversal
* 21/10/03 RHA DEV00009158 Correct CRC output for multi-pass profiles
* 28/11/03 RHA DEV00008695 Improve processing speed for surface milling
* 02/12/03 RHA DEV00009316 Corrections to Hole Cycle Subroutine calls
* 03/12/03 RHA DEV00009396 Corrections to Thread Mill CRC
* 05/12/03 RHA DEV00007400 Option to force XYZ on full circle
* Version 8.75
* 03/03/04 RHA DEV00009979 Helical arc implementation, Procedure CIRCLE
* 25/03/04 RHA DEV00010662 Correct single block speed call
* 30/03/04 RHA DEV00010662 Call spindle if direction changes
* Version 9.0
* 14/06/04 RHA DEV00011132 Correct datum for first tool, G54 setting forced in SET_WORK_DATUMS to compensate
* 16/06/04 RHA DEV00010879 Thread Mill Cycle parameters
* 17/06/04 RHA DEV00011068 Correct hole cycle flag settings, use #HOLECYCLE2
* 29/06/04 RHA DEV00010879 Hole cycle processing for TNC430
* 02/07/04 RHA DEV00011313 Work round for incorrect YEND on G18 arc Procedure=Circle
* 28/07/04 RHA DEV00011203 Correct helical parameters for TNC
* 11/08/04 RHA DEV00011656 Use UARRAY1 to store hole cycle flag settings (DEV00011068)
* Version 9.5
* 18/11/04 RHA DEV00012253 Make workshift warning optional
* 18/11/04 RHA DEV00011306 Correct PT_HOLE_POSITION_HH to allow rapid after toolchange
* 22/11/04 RHA DEV00012250 Option to suppress move to Retract before cycles
* 02/12/04 RHA DEV00012570 Correct thread mill regression (linked to DEV00011203 above)
* 23/12/04 RHA DEV00012565 Remove duplicate CRC cancel
* 05/01/05 RHA DEV00012613 Correct TNC Helix
* 05/01/05 RHA DEV00012845 Add new tool types
* 10/01/05 RHA DEV00012971 Procedure CIRCLE, tidy subfunct branching and add optional pitch suppression
* 12/01/05 RHA DEV00013014 CRC processing correction in CIRCLE
* 12/01/05 RHA DEV00012616 Correct rapid after toolchange. #ZTEMPREF setting
* 17/01/05 RHA DEV00012616 Corrections
* 17/01/05 RHA DEV00012616 Corrections for incremental moves
* 20/01/05 RHA DEV00012290 Helical arc processing
* 21/01/05 RHA DEV00012290 TNC Thread mill arc INCANGLE fix
* Version 9.75
* 25/01/05 RHA DEV00011662 Correct thread plunge point extraction
* 16/02/05 RHA DEV00013267 Use SUBROUTINE (not #SUBROUTINE) as array index
* 16/02/05 RHA DEV00010860 Remove unwanted G40 PT_OUTPUT_FEED
* 17/02/05 RHA DEV00010860 Correction for thread milling
* 17/02/05 RHA DEV00013267 Correct #SUBROUTINE setting at end of sub.
* 18/02/05 RHA DEV00010860 Correct plunge move identification in thread mill
* 18/02/05 RHA DEV00011662 Correct thread mill cycle diameter with helical leads
* 25/02/05 RHA DEV00013132 Correct output of angular move with rotary arcs
* 28/02/05 RHA DEV00010643 Improve subroutine approach moves
* 03/03/05 RHA DEV00007742 Correct full canned cycle, multiple locations.
* 04/03/05 RHA DEV00011310 Set sign of R for 180degrees to +ve
* 09/03/05 RHA DEV00012923 Correct position initialisation for offset initial CPL
* 10/03/05 RHA DEV00012923 Do not use XSUB etc for tool change position offset
* 11/03/05 RHA DEV00012923 Set HOLD vars to HOME in START macro so remove IF FIRST...
* 11/03/05 RHA DEV00013387 Circle centre accuracy improvements
* 11/03/05 RHA DEV00013251 Calculate IJK after precision rounding
* 14/03/05 RHA DEV00013387 Correct for Heidenhain TNC.
* 21/03/05 RHA DEV00013554 Correct TNC thread mill, regression caused by 13387, re-instate PT_TURN_ARC_BRG
* 21/03/05 RHA DEV00013586 Reset planar/rotary mode for hole cycle subroutines
* 29/03/05 RHA DEV00010643 Correct subroutine approach for incremental subs
* 30/03/05 RHA DEV00012923 Corrections
* 30/03/05 RHA DEV00011662 Thread mill cycle, position corrections
* 01/04/05 RHA DEV00010643 Force GCode at start of subroutine
* 06/04/05 RHA DEV00012923 Move to home & toolchnage positions fix
* 06/04/05 RHA DEV00013251 Correct arc centre point rounding
* 06/04/05 RHA DEV00013132 Angular output with radial arcs
* 06/04/05 RHA DEV00013721 Fix 3axm compilation error, CALL=PT_ROTARY_AXES
* 07/04/05 RHA DEV00013387 Correction to end point calcs
* 07/04/05 RHA DEV00013732 Correct TNC arc included angle and start angle
* 11/04/05 RHA DEV00011662 Thread mill cycle, position corrections
* Version 10
* 27/05/05 RHA DEV00014108 Correct direction evaluation for rotary rapid
* 28/06/05 RHA DEV00014268 Correct for TRUEARCOP in %PROCEDURE=RADIUS_ROUNDED_CENTRE
*                          Do not check arcs less than 300 degrees
* 29/06/05 RHA DEV00014268 Fix #OUTPUTRADS setting in RADIUS_ROUNDED_CENTRE
* 08/07/05 RHA DEV00014070 Correct rotary angles for arcs, use #ROTVALS
* 08/07/05 RHA DEV00014429 Correct #ZTEMPREF etc for moves after toolchange
* 09/08/05 RHA DEV00014699 Correct full arc output - force XY
* 15/09/05 RHA DEV00014670 GETCPL in first move after toolchange even if Feed
* 04/10/05 RHA DEV00012923 Correct rapid after toolchange setting
*                          Correct initial position setting  PT_INIT_POSITION
* Version 10
* 11/11/05 RHA DEV00015560 Reset #COUNT for planar rotate
* Version 10.5
* 15/02/06 RHA DEV00015578 Thread mill - G40 if G01 followed by G00
* 15/02/06 RHA DEV00014781 Set NEXTZMOVE in Thread Mill
* Version 10.75
* 11/04/06 RHA DEV00016863 Correct I value in thread mill for X reverse
*                          Fix planar lead arc reversals
* Version 11.5
* 13/10/06 RHA DEV00018390 PT_CONVERT_COORDS
* 17/11/06 RHA DEV00014536 remove spurious comp warning from arcs
* 24/11/06 RHA DEV00017338 Move CPLNAME to a template variable
* 19/12/06 RHA DEV00018593 Set #PLANEGCODE in Thread Milling
* 15/02/07 RHA DEV00017338 Correction to CPL name in Rapid after TC
* Version 11.75
* 13/04/07 RHA DEV00019720 Correct wrapped drill cycle approach
* Version 12.00
* 24/08/07 RHA DEV00020760 DEV00020742 DEV00019720 Fix approach coordinates
* Version 12.25
* 03/12/07 RHA DEV00021534 Enable longhand tapping
* 17/12/07 RHA DEV00021869 Correct Rapid after TC for longhand hole cycles
* Version 12.5
* 21/12/07 RHA DEV00021292 ASIN fails on taper thread
* 14/01/07 RHA DEV00021646 Correct multilevel drilling TNC
* 18/01/08 RHA DEV00021841, DEV00021908 New optional warnings
* 30/01/08 RHA DEV00021531 Remove Z0 from hole approach moves
* Version 2009R1
* 25/07/08 RHA DEV00023625 Fix the force longhnad drill option
* 28/07/08 RHA DEV00023625 Correct confusion between subroutines and canned cycle, drill only
**************************************************************************

%DECLARE=#RADIUS2
%DECLARE=$MOVETYPE,#COMPCYCLE
%DECLARE=#SPEEDHOLD,#SPEED99
%DECLARE=#HOLECYCLE2
%DECLARE=#NOPITCH,#TURNS
%DECLARE=#THRDCOMPCODE,#HELIXCOUNT
%DECLARE=#CYCOUT
%DECLARE=#XTOOLREF,#YTOOLREF,#ZTOOLREF
%DECLARE=#ZLINEAR
%DECLARE=#OUTPUTCYCLE,#OUTPUTPOINT
%DECLARE=#XSTART,#YSTART,#ZSTART
%DECLARE=#XAPP,#YAPP
*


*************************************************************************
*** INITIALISATION
*************************************************************************

%PROCEDURE=PT_INIT_POSITION
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_INIT_POSITION:%CALL=ENTER_PROCEDURE
* Called by all START macros to set initial position etc.


%IF #REFSHIFT=1 @REFSHIFT
* Current CPL output values
#XMOVE=XHOME+XSUB
#YMOVE=YHOME+YSUB
#ZMOVE=ZHOME+ZSUB
%CALL=PT_SET_PRECISION
#XHOLD=#XMOVE
#YHOLD=#YMOVE
#ZHOLD=#ZMOVE
%GOTO @REVERSE

@REFSHIFT
* Machine Datum output values
#XMOVE=XHOME
#YMOVE=YHOME
#ZMOVE=ZHOME
%CALL=PT_SET_PRECISION
#XHOLD=#XMOVE+XSUB
#YHOLD=#YMOVE+YSUB
#ZHOLD=#ZMOVE+ZSUB

@REVERSE
%IF #XREVERSE=#TRUE %THEN #XMOVE=#XMOVE*-1
%IF #YREVERSE=#TRUE %THEN #YMOVE=#YMOVE*-1
%IF #ZREVERSE=#TRUE %THEN #ZMOVE=#ZMOVE*-1
* Reset HOLD with reversals if not incremental
%IF #INCRXYZ=1 @TOOLREF
%IF #XREVERSE=#TRUE %THEN #XHOLD=#XHOLD*-1
%IF #YREVERSE=#TRUE %THEN #YHOLD=#YHOLD*-1
%IF #ZREVERSE=#TRUE %THEN #ZHOLD=#ZHOLD*-1

@TOOLREF
* Set CPL offset for moves to Home and TC
#XTOOLREF=XSUB*-1
#YTOOLREF=YSUB*-1
#ZTOOLREF=ZSUB*-1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*							*******************
*                         Macro support procedures
*							********************
;Token^<248>^ZCLEAR^[#TMP=!FT_CLEARCYCLE]^<1617>Z a Clearance Plane
*
%PROCEDURE=DRILL-CYCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=DRILL-CYCLE:%CALL=ENTER_PROCEDURE

* DB12120  Rotary Rotate outputs cycle and expanded equivalent. Suppress cycle to prevent duplicate moves
%IF NOCYCLE=1 %THEN $WARNING="Warning - Canned cycle not supported during Rotary Rotate - Longhand forced":%CALL=CODECON_WARNING
%IF NOCYCLE=1 %THEN %NOCYCLE

*Longhand if canned cycle not available
%IF DWELL=0 @NOTCBORE
%IF #EXPANDG82=1 @LONGHAND
%GOTO @SUBS
@NOTCBORE
%IF DEPTH=0 @NOTPECK
%IF #EXPANDG83=1 @LONGHAND
%GOTO @SUBS
@NOTPECK
%IF #EXPANDG81=1 @LONGHAND

@SUBS
*Set NOCYCLE if longhand selected with pathtrace subroutines
* Pathrace=0 for Controller subroutines
* USERVAR1=2 for Longhand selected
%IF USERVAR1=1 @SKIP  ; Canned cycle
@LONGHAND
%IF PATHTRACE=1 @SKIP1 ; Not Subroutines
%IF #SUBWARN=0 @SKIP1  ; No Warning set
$WARNING="Warning - Controller Subroutine Called for Longhand Hole Cycles":%CALL=CODECON_WARNING
@SKIP1
%NOCYCLE
@SKIP
*
*	NOTE! Re-instatement of the following variables is deemed good practice.
*	Not possible for the user to apply to the cycle line only via the Code Wizard i.e. Cancel since
*	this would be in the points expansion loop and would be applied to every location.
*
*  #XMOVE,#YMOVE,#ZMOVE removed from following line to restore modality control
%CANCEL=#CYCLEGCODE,#RETRACTGCODE,#GCODE,#ZDEPTH,#RPLANE,#FEED,#DEPTH,DWELL
%IF #G81CYCLE=#FALSE %THEN %NOCYCLE
%IF FIELD1=#FUNNY @NORMAL									;	Entry feed not set
%IF FIELD1>0 %THEN %NOCYCLE									;	Entry feed set - longhand output only
@NORMAL
%IF DEPTH>0 %THEN #CYCLEGCODE=DATA1(38):#DEPTH=DEPTH*#PECKREVERSE:#DWELLGCODE=#FUNNY:#DEGR=DEGR:PITCH=#FUNNY:#BOREOFFSET=#FUNNY:$CYCLETYPE=PECKDRILL:%GOTO @END		;G83
%IF DWELL>0 %THEN #CYCLEGCODE=DATA1(37):#DEPTH=#FUNNY:#DWELLGCODE=DATA1(5):#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY:$CYCLETYPE=COUNTERBORE:%GOTO @END2	;G82
#CYCLEGCODE=DATA1(36):#DEPTH=#FUNNY:DWELL=#FUNNY:#DWELLGCODE=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY:$CYCLETYPE=DRILL:%GOTO @END2	            		;G81
@END
%IF #ZREVERSE=1 %THEN #DEPTH=(#DEPTH*-1)  ; Reverse peck depth
@END2
%IF $MACHINE="HEIDENHAIN" %THEN %CALL=PT_HOLE_POSITION_HH %ELSE %CALL=PT_HOLE_CYCLES

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=CHIPBREAK-CYCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=CHIPBREAK-CYCLE:%CALL=ENTER_PROCEDURE

* DB12120  Rotary Rotate outputs cycle and expanded equivalent. Suppress cycle to prevent duplicate moves
%IF NOCYCLE=1 %THEN $WARNING="Warning - Canned cycle not supported during Rotary Rotate - Longhand forced":%CALL=CODECON_WARNING
%IF NOCYCLE=1 %THEN %NOCYCLE

*Longhand if canned cycle not available
%IF #EXPANDG87=1 %THEN %NOCYCLE

*Set NOCYCLE if longhand selected with pathtrace subroutines
%IF PATHTRACE=0 @SKIP
%IF USERVAR1=2 %THEN %NOCYCLE
@SKIP


$CYCLETYPE=CHIPBREAK
%IF $MODEL="TNC400" @CANNED
%IF $MODEL="TNC426" @CANNED
%IF $MODEL="TNC430" @CANNED
%IF $MACHINE="HEIDENHAIN" %THEN %NOCYCLE
@CANNED
*  #XMOVE,#YMOVE,#ZMOVE removed from following line to restore modality control
%CANCEL=#CYCLEGCODE,#RETRACTGCODE,#GCODE,#ZDEPTH,#RPLANE,#FEED,#DEPTH,DWELL
%IF FIELD1=#FUNNY @NORMAL
%IF FIELD1>0 %THEN %NOCYCLE
@NORMAL
#CYCLEGCODE=DATA1(34):#DWELLGCODE=#FUNNY:#DEGR=DEGR:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
%IF #ZREVERSE=1 %THEN #DEPTH=(DEPTH*-1) %ELSE #DEPTH=DEPTH
%IF $MACHINE="HEIDENHAIN" %THEN %CALL=PT_HOLE_POSITION_HH %ELSE %CALL=PT_HOLE_CYCLES

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


**************************************************************************
%PROCEDURE=REAM-CYCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=REAM-CYCLE:%CALL=ENTER_PROCEDURE

* DB12120  Rotary Rotate outputs cycle and expanded equivalent. Suppress cycle to prevent duplicate moves
%IF NOCYCLE=1 %THEN $WARNING="Warning - Canned cycle not supported during Rotary Rotate - Longhand forced":%CALL=CODECON_WARNING
%IF NOCYCLE=1 %THEN %NOCYCLE

*Longhand if canned cycle not available
%IF #EXPANDG85=1 %THEN %NOCYCLE

*Set NOCYCLE if longhand selected with pathtrace subroutines
%IF PATHTRACE=0 @SKIP
%IF USERVAR1=2 %THEN %NOCYCLE
@SKIP


$CYCLETYPE=REAMBORE
* %IF $MODEL="TNC400" @CANNED
* %IF $MACHINE="HEIDENHAIN" %THEN %NOCYCLE
@CANNED
*  #XMOVE,#YMOVE,#ZMOVE removed from following line to restore modality control
%CANCEL=#CYCLEGCODE,#RETRACTGCODE,#GCODE,#ZDEPTH,#RPLANE,#FEED,DEPTH,DWELL
;%IF FIELD1<>#FUNNY %THEN <*** Entry feed rate = [FIELD1=29] ***>
%IF FIELD1=#FUNNY @NORMAL
%IF FIELD1>0 %THEN %NOCYCLE
@NORMAL
#CYCLEGCODE=DATA1(40):#DEPTH=#FUNNY:#DWELLGCODE=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
%IF $MACHINE="HEIDENHAIN" %THEN %CALL=PT_HOLE_POSITION_HH %ELSE %CALL=PT_HOLE_CYCLES

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=BORE-CYCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=BORE-CYCLE:%CALL=ENTER_PROCEDURE

* DB12120  Rotary Rotate outputs cycle and expanded equivalent. Suppress cycle to prevent duplicate moves
%IF NOCYCLE=1 %THEN $WARNING="Warning - Canned cycle not supported during Rotary Rotate - Longhand forced":%CALL=CODECON_WARNING
%IF NOCYCLE=1 %THEN %NOCYCLE

*Longhand if canned cycle not available
%IF #EXPANDG86=1 %THEN %NOCYCLE

* Set NOCYCLE if longhand selected with pathtrace subroutines
* Not applied with bore offset
%IF PATHTRACE=0 @SKIP
%IF #BOREOFFSETHOLD=#FUNNY @EXPAND
%IF #BOREOFFSETHOLD<>0 @SKIP
@EXPAND
%IF USERVAR1=2 %THEN %NOCYCLE
@SKIP


$CYCLETYPE=BORE
* %IF $MODEL="TNC400" @CANNED
* %IF $MACHINE="HEIDENHAIN" %THEN %NOCYCLE
@CANNED
*  #XMOVE,#YMOVE,#ZMOVE removed from following line to restore modality control
%CANCEL=#CYCLEGCODE,#RETRACTGCODE,#GCODE,#ZDEPTH,#RPLANE,#FEED,DEPTH,DWELL

*%IF PATHTRACE=1 %THEN %NOCYCLE									;	User selected longhand emulation

;%IF FIELD1<>#FUNNY %THEN <*** Entry feed rate = [FIELD1=29] ***>
%IF FIELD1=#FUNNY @NORMAL
%IF FIELD1>0 %THEN %NOCYCLE
@NORMAL
#CYCLEGCODE=DATA1(41):#DEPTH=#FUNNY:#DWELLGCODE=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#BOREOFFSETHOLD
%IF $MACHINE="HEIDENHAIN" %THEN %CALL=PT_HOLE_POSITION_HH %ELSE %CALL=PT_HOLE_CYCLES

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


**************************************************************************
%PROCEDURE=TAP-CYCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=TAP-CYCLE:%CALL=ENTER_PROCEDURE

* DB12120  Rotary Rotate outputs cycle and expanded equivalent. Suppress cycle to prevent duplicate moves
%IF NOCYCLE=1 %THEN $WARNING="Warning - Canned cycle not supported during Rotary Rotate - Longhand forced":%CALL=CODECON_WARNING
%IF NOCYCLE=1 %THEN %NOCYCLE

*Set NOCYCLE if longhand selected with pathtrace subroutines
%IF PATHTRACE=0 @SKIP
%IF USERVAR1=2 %THEN %NOCYCLE
@SKIP


$CYCLETYPE=TAPPING
#PITCH=PITCH
%IF $MODEL="TNC400" @RIGID
%IF $MODEL="TNC426" @RIGID
%IF $MODEL="TNC430" @RIGID
%GOTO @NOTRIGID

@RIGID
%IF USERVAR3=2 %THEN $CYCLETYPE=RIGIDTAPPING
@NOTRIGID

#HANDOFTHREAD=USERVAR4
%IF #HANDOFTHREAD=0 %THEN #CYCLEGCODE=DATA1(39)	;	Unset ie. assume default Floating
%IF #HANDOFTHREAD=1 %THEN #CYCLEGCODE=DATA1(39) ;	Selected Right Hand Threadcycle
%IF #HANDOFTHREAD=2 %THEN #CYCLEGCODE=DATA1(42)	;	Selected Left Hand Thread
*
* Check and reset direction
#TMP1=#DIRECTION
%IF #HANDOFTHREAD=2 @LEFT
* Right hand threads
#TMP=DATA2(5)
%IF #DIRECTION=#TMP %THEN #DIRECTION=DATA2(4)
#TMP=DATA2(15)
%IF #DIRECTION=#TMP %THEN #DIRECTION=DATA2(14)
%GOTO @END

@LEFT
* Left hand threads
#TMP=DATA2(4)
%IF #DIRECTION=#TMP %THEN #DIRECTION=DATA2(5)
#TMP=DATA2(14)
%IF #DIRECTION=#TMP %THEN #DIRECTION=DATA2(15)
*

@END


*  #XMOVE,#YMOVE,#ZMOVE removed from following line to restore modality control
%CANCEL=#CYCLEGCODE,#RETRACTGCODE,#GCODE,#ZDEPTH,#RPLANE,#FEED,DEPTH,DWELL
#DEPTH=#FUNNY:#DWELLGCODE=#FUNNY:#DEGR=#FUNNY:#BOREOFFSET=#FUNNY
%IF $MACHINE="HEIDENHAIN" %THEN %CALL=PT_HOLE_POSITION_HH %ELSE %CALL=PT_HOLE_CYCLES

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-2
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-2:%CALL=ENTER_PROCEDURE

* Set CPL if first move after ToolChange
%IF #TOOLCHANGE=1 %THEN %GETCPL=#CURRENTCPL

* Force #TOOLCHANGE=#FALSE to prevent SPEEDS lookahead
#TOOLCHANGE=#FALSE

* Set CRC output control for profile lead in/out
%IF SUBFUNCT=0 @SKIP
$COMPOUTPUT=FALSE

@SKIP

#XMOVE=XMOVE:#YMOVE=YMOVE:#ZMOVE=ZMOVE
#FEED=FEED
%IF FEED=#FUNNY %THEN #FEED=XYFEED
%CALL=PT_OUTPUT_FEED
@END

$DECKELCOMP=0

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-15
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-15:%CALL=ENTER_PROCEDURE

* Set #SPEEDUP to improve surface milling
#SPEEDUP=#INCRXYZ+#TLOCOMP+#XREVERSE+#YREVERSE+#ZREVERSE


#TOOLCHANGE=#TRUE
%LOAD=SUBFUNCT                        			 		; load current tooling values

@CONTINUE
#XTEMPREF=#XHOLD
#YTEMPREF=#YHOLD
#ZTEMPREF=#ZHOLD

%IF #INCRXYZ=1 @CONTINUE2
* Hold values are not reversed in incremental mode
%IF #XREVERSE=1 %THEN #XTEMPREF=#XTEMPREF*-1
%IF #YREVERSE=1 %THEN #YTEMPREF=#YTEMPREF*-1
%IF #ZREVERSE=1 %THEN #ZTEMPREF=#ZTEMPREF*-1
@CONTINUE2
*New variable #ROTVAL introduced Dec98. RHA
* Used to control rotary angle setting in Feed and Rapid macros because the
* system vars ROT1 and ROT2 are not always set correctly by EdgeCAM in Index mode.
* #ROTVALS set #FALSE by the INDEX macro so ROT1 ROT2 will be ignored in Feed & Rapid
* #ROTVALS set #TRUE by the ROTARY-ROTATE macro so ROT1/ROT2 will be used.
* #ROTVALS set according to mode by ROTARY/PLANAR macro (#FALSE for PLANAR Mode).
* If ROT1/ROT2 are ignored then reprocessing of angles through PT_ROTARY_AXES is skipped

*  Initialise #ROTVALS if not already set. Done here to ensure setting before use for all templates.
%IF #ROTVALS=#TRUE @ROTVALS
%IF #ROTVALS=#FALSE @ROTVALS
#ROTVALS=#FALSE
@ROTVALS

%IF USERVAR2=1 %THEN %GOTO @NOTOOL_WORKSHIFT
%IF #SHIFTWARN=0 @NOWARN
%IF #G55<>0 %THEN $WARNING="Warning - Workshift in Toolchange not valid with Datum Shift - Option ignored":%CALL=CODECON_WARNING:%GOTO @NOTOOL_WORKSHIFT
@NOWARN
#TMP=USERVAR2-1
#TMP=#TMP+24
#WORKGCODE=DATA1(#TMP)
@NOTOOL_WORKSHIFT


%IF #TLOCOMP=#TRUE %THEN #ADJZMOVE=TOOLEN %ELSE #ADJZMOVE=0		;	If TLOCOMP=True output turret datum else output gauge point
%CANCEL=#DIRECTION,#COOL,#SPEED,#FEED,#GCODE,#HCODE

%IF #DIRECTION=DATA2(14)%THEN #COOL=#FUNNY
%IF #DIRECTION=DATA2(15)%THEN #COOL=#FUNNY			;	Coolant programmed with spindle - Macro 101
*
#FIRSTRAPIDZ=NEXTZMOVE+TOOLEN

#GEAR=USERVAR4													;	1=auto, 2=gear1, 3=gear2, 4=gear3, 5=gear4.
%IF #GEAR=#FUNNY %THEN #AUTOGEAR=#TRUE     						;	Unset, hence assume auto
%IF #GEAR=1 %THEN #AUTOGEAR=#TRUE %ELSE #AUTOGEAR=#FALSE		;	Automatic gear selection
%IF #GEAR>1 %THEN #GEAR=#GEAR-1									;	Not Auto : Subtract 1 for ease e.g. 2nd choice = Gear1

*	The Token Speed calls the procedure PT_SPINDLE to determine Gear (if auto) and Spindle speed / Spindle Code

#NEXTTOOL=SUBFUNCT+1:%LOAD=#NEXTTOOL:#NEXTTOOL=POSITION
%IF SUBFUNCT=NUMTOOLS %THEN #NEXTTOOL=1:%LOAD=#NEXTTOOL:#NEXTTOOL=POSITION
%LOAD=SUBFUNCT

#XMOVE=#XTEMPREF:#YMOVE=#YTEMPREF:#ZMOVE=#ZTEMPREF
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
* Position not move, therefore never incremental
* %IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

#TOOLCOUNT=#TOOLCOUNT+1
%CALL=PT_SET_TLO

%IF SUBFUNCT<>1 @GENERAL_TOOLCHANGE


%CALL=CODECON_FIRST-TOOLCHANGE

%GOTO @END


@GENERAL_TOOLCHANGE

* Check correct position
%IF #RAPIDTOOL=#TRUE @CHECKZ
%IF #TOOLRAPWARN=0 @CHECKZ

* No Rapid_to_ToolChange call
$WARNING="Warning - Rapid to Toolchange should be performed prior to a Toolchange":%CALL=CODECON_WARNING
$WARNING="          TLO may not be applied correctly & NC code may not reflect toolpaths":%CALL=CODECON_WARNING
%GOTO @CALL

@CHECKZ
%IF #TOOLZWARN=0 @CALL

* Check Z position only, allow for axis reversal
#TMP=#ZHOLD
%IF #ZREVERSE=1 %THEN #TMP=#TMP*-1
%IF #TMP=#ZTEMPREF @CALL

$WARNING="Warning - Toolchange not at specified Z height":%CALL=CODECON_WARNING

@CALL
%IF SUBFUNCT=NUMTOOLS @LAST_TOOLCHANGE

%CALL=CODECON_GENERAL-TOOLCHANGE

%GOTO @END

@LAST_TOOLCHANGE

%CALL=CODECON_LAST-TOOLCHANGE

@END
%LOAD=SUBFUNCT
#COMPON=#FALSE:#FIRSTIME=2:#ABS=DATA1(47)
%CANCEL=#XMOVE,#YMOVE,#ZMOVE,#GCODE
#WRAPHOLD=#FUNNY				;	Force Wrap Radius to be re-instated
#RAPIDTOOL=#FALSE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-29
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-29:%CALL=ENTER_PROCEDURE

*	Cutter compensation will ;
*	1.	Only be active during feedrate moves - not rapid
*	2.	Will not be active during a Z move.  (NOTE! G17=> Z/G18 => Y/G19 => X - but edgeCAM doesn't allow tool normal to these planes)
*	Only Feed Code Constructor has Cutter comp Tokens available.
*
*	NOTE! All output is processed is produced from a cut move : feed, clw, cclw
*
*	Subfunct 1=off, 2=left, 3=right
* #WarnCRC = 1  CRC Warn if Used
* #WARNCRC90 = 1  CRC warn if not 90
* #CRCONZ2   =1  Warn if applied with Z move
* #CRCONZ1   =1  Warn if removed with Z move

%IF #WARNCRC=1 %THEN $WARNING="Warning - Cutter Radius Compensation has been programmed":%CALL=CODECON_WARNING
%IF SUBFUNCT>1 %THEN #COMPON=#TRUE %ELSE #COMPON=#FALSE			;	Record if compensation is on.

$COMPOUTPUT=FALSE

#LEADOUTCOUNT=#FUNNY		;	Comp is cancelled when #LEADOUTCOUNT=1

%IF SUBFUNCT=1 %THEN #COMPGCODE=DATA1(20):#LEADOUTCOUNT=1	;	Off
%IF SUBFUNCT=2 %THEN #COMPGCODE=DATA1(21)					;	Left
%IF SUBFUNCT=3 %THEN #COMPGCODE=DATA1(22)					;	Right
*
*		Register number - If Uservar67 set then use else determine dependant on #AUTOREG

*
%IF USERVAR1<>0 %THEN #COMPDCODE=USERVAR1:%GOTO @REGISTER_SET

%IF #REGOFFSET<>#FUNNY %THEN #COMPDCODE=POSITION+#REGOFFSET:%GOTO @REGISTER_SET

%IF #AUTOREG=1 %THEN #COMPDCODE=POSITION+#MAXTOOLS1
%IF #AUTOREG=2 %THEN #COMPDCODE=POSITION
%IF #AUTOREG=3 %THEN #COMPDCODE=#MAXTOOLS1+#TOOLCOUNT
@REGISTER_SET
%IF $MACHINE="HEIDENHAIN" %THEN #COMPDCODE=POSITION
*
*		If mirror is active then need to reverse cutter comp
*
%IF #MIRROR=1 %THEN %CALL=PT_REVERSE_COMP_MIRROR

@END
*	Hold original settings
#COMPGCODEHOLD=#COMPGCODE
#COMPDCODEHOLD=#COMPDCODE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-32
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-32:%CALL=ENTER_PROCEDURE
* <*Move [XMOVE=0] [YMOVE=1] [Zmove=2] >  ; End pt of orig subroutine
* <*Inc  [XINC=0] [YINC=1] [ZINC=2] >     ; Tot increments this level of nesting
* <*Sub  [XSUB=0] [YSUB=1] [ZSUB=2] >     ; Start point of orig subroutine
* <*Hold [#XHOLD=0] [#YHOLD=1] [#ZHOLD=2] > ; Start point this level of nesting

%IF NOCYCLE=1 @ALLPASSES

* First pass only - Initialise start point
* First pass through translate is second call of subroutine.
#XSUB=XEND
#YSUB=YEND
#ZSUB=ZEND

@ALLPASSES
*
%IF PATHTRACE=1 %THEN %NOCYCLE

%IF $MACHINE="HEIDENHAIN" %THEN %GOTO @HH_TRANS
*	Rapid to position of next move

#GCODE=DATA1(1)

%IF #INCRSUBS=#FALSE @APPROACH1
* Incremental Subroutines
#XSUB=#XSUB+XINC
#YSUB=#YSUB+YINC
#ZSUB=#ZSUB+ZINC
#XMOVE=#XSUB
#YMOVE=#YSUB
#ZMOVE=#ZSUB
%IF #INCRXYZ=0 @APPROACH

#XMOVE=XINC+#XHOLD
#YMOVE=YINC+#YHOLD
#ZMOVE=ZINC+#ZHOLD
%GOTO @APPROACH

@APPROACH1
* Absolute approach
#XMOVE=XEND+XINC
#YMOVE=YEND+YINC
#ZMOVE=ZEND+ZINC

@APPROACH
%CALL=PT_OUTPUT_RAPID

* prevent output of null effect G92 block
%IF XEND<>#XHOLD @APPLY
%IF YEND<>#YHOLD @APPLY
%IF ZEND=#ZHOLD @SUBCALL

@APPLY
*	Apply translation - G92 will reset registers
#XMOVE=XEND
#YMOVE=YEND
#ZMOVE=ZEND
#PRESETGCODE=DATA1(23)
%GOTO @OUTPUT

@HH_TRANS
#XMOVE=XINC
#YMOVE=YINC
#ZMOVE=ZINC

@OUTPUT
%IF #INCRSUBS=#FALSE %THEN %CALL=CODECON_TRANSLATE

@SUBCALL
*	Call Subroutine
%CALL=PT_OUTPUT_SUBCALL

@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-35
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-35:%CALL=ENTER_PROCEDURE

#XMOVE=XSUB:#YMOVE=YSUB
%IF PATHTRACE=1 %THEN %NOCYCLE
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
%IF #XMOVE<>#XHOLD @SKIP         ;IF CPX,CPY<>XSUB,YSUB THEN FEED THERE
%IF #YMOVE<>#YHOLD @SKIP
%GOTO @THERE
@SKIP
%IF PECKRETRACT=0 @SKIPZCLEAR       ;	Test for rapid plane required
#XMOVE=#FUNNY
#YMOVE=#FUNNY
#ZMOVE=RPLANE			   			;	Rapid to Rplane
%CALL=PT_OUTPUT_RAPID
@SKIPZCLEAR
#XMOVE=XSUB:#YMOVE=YSUB
%CALL=PT_OUTPUT_RAPID
@THERE
#XMOVE=XSUB:#YMOVE=YSUB:#ZMOVE=ZSUB+ZINC
%IF FEED=#FUNNY %THEN #FEED=XYFEED %ELSE #FEED=ZFEED
%CALL=PT_OUTPUT_FEED
%CALL=PT_OUTPUT_SUBCALL

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
%PROCEDURE=PMACRO-37
%IF #PROCTRACE=1 %THEN $PROCEDURE=PMACRO-37:%CALL=ENTER_PROCEDURE

%IF USERVAR8<>1 %THEN USERVAR8=0 ; Safety check - full canned cycle flag

*If no comp requested ensure output flag is true
%IF #COMPON=0 %THEN $COMPOUTPUT=TRUE
#COMPCYCLE=#COMPON ; Global and local control of CRC
#THRDCOMPCODE=#COMPGCODE
%IF #COMPGCODE<>DATA1(20) %THEN #COMPGCODE=#FUNNY
#HELIXCOUNT=0
#OUTPUTCYCLE=0
#OUTPUTPOINT=1
* Check for helical interpolation
* %IF PATHTRACE=1 %THEN %NOCYCLE

*Check for array data.
%IF LAST<5 @END

************  Diagnostic printout
%GOTO @JUMP  ;Comment out to print thread mill array data
<* Thread Mill Array Content>
#LOOP=1
@NEXT1
< >
%IF #LOOP>LAST @JUMP
#TYPE=XPOINT(#LOOP)
#TMP1=2
%IF #TYPE>1 %THEN #TMP1=#TMP1+1
%IF #TYPE>3 %THEN #TMP1=#TMP1+1
@NEXT2
#USER1=XPOINT(#LOOP):#USER2=YPOINT(#LOOP):#USER3=RADIUS(#LOOP)
<* [#LOOP=0] [#USER1=0] [#USER2=1] [#USER3=2]>
#LOOP=#LOOP+1
#TMP1=#TMP1-1
%IF #TMP1>0 @NEXT2
%GOTO @NEXT1
************

@JUMP
#PLANEGCODE=DATA1(13)
%IF XYPLANE=1 %THEN #PLANEGCODE=DATA1(14)
%IF XYPLANE=2 %THEN #PLANEGCODE=DATA1(15)

#BLOCKSMISSED=0 ;Initialise helical block count
#SPEED=SPEED
#THREADMOVE=1
#LOOP=1
@LOOP
* #TMP=XPOINT(#LOOP):#TMP1=YPOINT(#LOOP):#TMP2=RADIUS(#LOOP)
* <Loop [#LOOP=0] . [#TMP=0] [#TMP1=1] [#TMP2=2] >

%IF #LOOP>LAST @ELOOP

*look for lift out on NEXT move
%IF XPOINT(#LOOP)<=1 %THEN #NEXTLOOP=#LOOP+2:%GOTO @CHECK
%IF XPOINT(#LOOP)<=3 %THEN #NEXTLOOP=#LOOP+3:%GOTO @CHECK
%IF XPOINT(#LOOP)<=5 %THEN #NEXTLOOP=#LOOP+4:%GOTO @CHECK
@CHECK
#TMP=XPOINT(#NEXTLOOP)
%IF #TMP<>0 @NOT-LIFT

* <* Loop [#LOOP=0] Next [#NEXTLOOP=0]>
#TMP=#LOOP+1
#TMP1=ZPOINT(#TMP) ; This Z

#NEXTLOOP=#NEXTLOOP+1
#TMP2=ZPOINT(#NEXTLOOP) ; next Z

%IF #TMP1>=#TMP2 @NOT-LIFT

* <Lift Next From [#TMP1=2] To [#TMP2=2]>
#COMPGCODE=DATA1(20)
%IF #COMPON=1 %THEN $COMPOUTPUT=FALSE
#COMPON=0
#THREADMOVE=2
@NOT-LIFT


* Look for last leg and cancel compensation
%IF #TYPE>3 %THEN #TMP=#LOOP+4 %ELSE #TMP=#LOOP+3
%IF #TMP>LAST %THEN %GOTO @LAST %ELSE %GOTO @NOT-LAST

@LAST
%IF #COMPON=1 %THEN $COMPOUTPUT=FALSE
#COMPON=0
#THREADMOVE=2

@NOT-LAST
%IF XPOINT(#LOOP)<=1 %THEN %CALL=PT_THRD_MOVE:%GOTO @LOOP
%IF XPOINT(#LOOP)<=3 %THEN %CALL=PT_THRD_ARC:%GOTO @LOOP
%IF XPOINT(#LOOP)<=5 %THEN %CALL=PT_THRD_ARC_HELICAL:%GOTO @LOOP
%IF XPOINT(#LOOP)>5  %THEN %CALL=PT_SKIP_RECORD:%GOTO @LOOP
@ELOOP
#THREADMOVE=0

@END
#COMPON=#COMPCYCLE ; Reset to original condition
#COMPGCODE=#THRDCOMPCODE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************

%PROCEDURE=PMACRO-40
%IF #PROCTRACE=1 %THEN $PROCEDURE=P-RESET:%CALL=ENTER_PROCEDURE

* Adjust tool/home position to current CPL if required
%IF #REFSHIFT=0 @SHIFT
%IF FIELD1=0 %THEN #XMOVE=XHOME
%IF FIELD2=0 %THEN #YMOVE=YHOME
%IF FIELD3=0 %THEN #ZMOVE=ZHOME
%GOTO @CONTINUE

@SHIFT
%IF FIELD1=0 %THEN #XMOVE=XHOME-#XTOOLREF
%IF FIELD2=0 %THEN #YMOVE=YHOME-#YTOOLREF
%IF FIELD3=0 %THEN #ZMOVE=ZHOME-#ZTOOLREF

@CONTINUE
#XTEMPREF=#XHOLD+#XTOOLREF
#YTEMPREF=#YHOLD+#YTOOLREF
#ZTEMPREF=#ZHOLD+#ZTOOLREF

%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************

%PROCEDURE=PMACRO-41
%IF #PROCTRACE=1 %THEN $PROCEDURE=P-RESET:%CALL=ENTER_PROCEDURE

* Adjust tool/home position to current CPL if required
%IF #REFSHIFT=0 @SHIFT
%IF FIELD1=0 %THEN #XMOVE=XTOOL
%IF FIELD2=0 %THEN #YMOVE=YTOOL
%IF FIELD3=0 %THEN #ZMOVE=ZTOOL
%GOTO @CONTINUE

@SHIFT
%IF FIELD1=0 %THEN #XMOVE=XTOOL-#XTOOLREF
%IF FIELD2=0 %THEN #YMOVE=YTOOL-#YTOOLREF
%IF FIELD3=0 %THEN #ZMOVE=ZTOOL-#ZTOOLREF

@CONTINUE
#XTEMPREF=#XHOLD+#XTOOLREF
#YTEMPREF=#YHOLD+#YTOOLREF
#ZTEMPREF=#ZHOLD+#ZTOOLREF

#RAPIDTOOL=#TRUE
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


**************************************************************************
%PROCEDURE=P-RESET
%IF #PROCTRACE=1 %THEN $PROCEDURE=P-RESET:%CALL=ENTER_PROCEDURE
* <*Move [XMOVE=0] [YMOVE=1] [Zmove=2] >  ; End pt of orig subroutine
* <*Inc  [XINC=0] [YINC=1] [ZINC=2] >     ; Tot increments this level of nesting
* <*Sub  [XSUB=0] [YSUB=1] [ZSUB=2] >     ; Start point of orig subroutine
* <*Hold [#XHOLD=0] [#YHOLD=1] [#ZHOLD=2] > ; Start point this level of nesting

#COUNT=0 ; For Planar Rotate

%IF SUBFUNCT=3 %THEN #MIRROR=0:%CALL=PT_REVERSE_COMP_MIRROR:%GOTO @END
%IF SUBFUNCT=2 %THEN %GOTO @END

%IF PATHTRACE=1 @END			;	Skip Datum Reset if processing longhand

*	Translate Reset
%IF $MACHINE="HEIDENHAIN" %THEN %GOTO @HH_RESET
#GCODE=DATA1(1)

* Reset is only needed if absolute subroutines have been used with G92 datum setting
%IF #INCRSUBS=#TRUE @END

* Update stored end point (XINC etc in Reset are TOTAL increments for this level)
#XHOLD=#XHOLD+XINC
#YHOLD=#YHOLD+YINC
#ZHOLD=#ZHOLD+ZINC
*<*HOLD2 [#XHOLD=0] [#YHOLD=1] [#ZHOLD=2] >

* Final G92 position.
#XMOVE=#XHOLD ;+(XMOVE-XSUB)
#YMOVE=#YHOLD ;+(YMOVE-YSUB)
#ZMOVE=#ZHOLD ;+(ZMOVE-ZSUB)
%IF NEXTMACRO=48 @END ;Skip Datum Reset if next macro is Shift Datum
#GCODE=DATA1(23)
%CALL=CODECON_TRANSLATE
%GOTO @END

@HH_RESET
* Heidenhain type machines
%IF NEXTMACRO=48 @END ;Skip Datum Reset if next macro is Shift Datum
%CANCEL=#XMOVE,#YMOVE,#ZMOVE
%CALL=CODECON_TRANSLATE_RESET

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

**************************************************************************
*							*******************
*							  Debug Trace Procedures
*							*******************
;                                      Ŀ
;Ĵ ENTER_PROCEDURE                  
;                                      
%PROCEDURE=ENTER_PROCEDURE

%IF $SPC="              " %THEN $SPC="               "     ;1
%IF $SPC="             "  %THEN $SPC="              "	   ;2
%IF $SPC="            "   %THEN $SPC="             "	   ;3
%IF $SPC="           "    %THEN $SPC="            "		   ;4
%IF $SPC="          "     %THEN $SPC="           "		   ;5
%IF $SPC="         "      %THEN $SPC="          "		   ;6
%IF $SPC="        "       %THEN $SPC="         "		   ;7
%IF $SPC="       "        %THEN $SPC="        "			   ;8
%IF $SPC="      "         %THEN $SPC="       "			   ;9
%IF $SPC="     "          %THEN $SPC="      "			   ;10
%IF $SPC="    "           %THEN $SPC="     "			   ;11
%IF $SPC="   "            %THEN $SPC="    "				   ;12
%IF $SPC="  "             %THEN $SPC="   "				   ;13
%IF $SPC=" "              %THEN $SPC="  "				   ;14
%IF $SPC=""               %THEN $SPC=" "				   ;15
<* [$SPC][$SPC]{62} [$PROCEDURE]>
@END
%ENDM
;                                      Ŀ
;Ĵ EXIT_PROCEDURE                   
;                                      
%PROCEDURE=EXIT_PROCEDURE

<* [$SPC][$SPC]{60} >
%IF $SPC=" "               %THEN $SPC=""	      			;1
%IF $SPC="  "              %THEN $SPC=" "		  			;2
%IF $SPC="   "             %THEN $SPC="  "		  			;3
%IF $SPC="    "            %THEN $SPC="   "		  			;4
%IF $SPC="     "           %THEN $SPC="    "	  			;5
%IF $SPC="      "          %THEN $SPC="     "	  			;6
%IF $SPC="       "         %THEN $SPC="      "	  			;7
%IF $SPC="        "        %THEN $SPC="       "	  			;8
%IF $SPC="         "       %THEN $SPC="        "	  		;9
%IF $SPC="          "      %THEN $SPC="         "			;10
%IF $SPC="           "     %THEN $SPC="          "			;11
%IF $SPC="            "    %THEN $SPC="           "			;12
%IF $SPC="             "   %THEN $SPC="            "		;13
%IF $SPC="              "  %THEN $SPC="             "		;14
%IF $SPC="               " %THEN $SPC="              "		;15
@END
%ENDM


%PROCEDURE=SET_TOOL_TYPE
%IF #PROCTRACE=1 %THEN $PROCEDURE=SET_TOOL_TYPE:%CALL=ENTER_PROCEDURE

* Called from token TOOLTYPE

%IF TOOLTYPE=0 %THEN $TYPE=ENDMILL
%IF TOOLTYPE=1 %THEN $TYPE=BALLNOSE
%IF TOOLTYPE=2 %THEN $TYPE=TAP
%IF TOOLTYPE=3 %THEN $TYPE=DRILL
%IF TOOLTYPE=4 %THEN $TYPE=TAPER
%IF TOOLTYPE=5 %THEN $TYPE=OTHER
%IF TOOLTYPE=6 %THEN $TYPE=T-SLOT
%IF TOOLTYPE=7 %THEN $TYPE=LOLLIPOP


@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


*							*******************
*							  Program Defaults
*							*******************
*
*	Used in rotary but tested in procedure hence must be declared for 3axis also.
*
%PROCEDURE=PT_DEFAULTS
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_DEFAULTS:%CALL=ENTER_PROCEDURE

$DESCR=""
#SPEEDHOLD=-99

*	Processes the Program Defaults Tab to allow spindle direction, coolant etc. to be set by the user.
*	Spindle Direction
%IF #DIRECTION=1 %THEN #DIRECTION=DATA2(4):%GOTO @COOLANT				;	Forward	(M03)
%IF #DIRECTION=2 %THEN #DIRECTION=DATA2(5):%GOTO @COOLANT			;	Reverse	(M04)
%IF #DIRECTION=3 %THEN #DIRECTION=DATA2(6):%GOTO @COOLANT			;	Stop	(M05)
%IF #DIRECTION=4 %THEN #DIRECTION=DATA2(14):%GOTO @COOLANT			;	CLW + Coolant (M13)
%IF #DIRECTION=5 %THEN #DIRECTION=DATA2(15):%GOTO @COOLANT		;	CCLW + Coolant (M14)

@COOLANT
*	Coolant
%IF #COOL=1 %THEN #COOL=DATA2(8):%GOTO @END			;	Default coolant = Flood (M07)
%IF #COOL=2 %THEN #COOL=DATA2(9):%GOTO @END			;	Default coolant = Mist	(M08)
%IF #COOL=3 %THEN #COOL=DATA2(10):%GOTO @END			;	Default coolant = Off	(M09)

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_ASK_PROGVERSION
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ASKPROG_VERSION:%CALL=ENTER_PROCEDURE

*	Handle User Input when Token PROGDESCR used
%IF $PROGVER<>"" @ALEADY_SET	;	If Token used twice (Heidenhain) or in Loop (Deckel)

%ASK=Program Version Number=$PROGVER

@ALEADY_SET
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_ASK_PROGRAMMER
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ASK_PROGRAMMER:%CALL=ENTER_PROCEDURE

*	Handle User Input when Token PROGDESCR used
%IF $ID<>"" @ALEADY_SET	;	If Token used twice (Heidenhain) or in Loop (Deckel)

%ASK=Programmer's Name=$ID

@ALEADY_SET
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_ASK_PROGID
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ASK_PROGID:%CALL=ENTER_PROCEDURE

*	Handle User Input when Token PROGID used
%IF #PROGID<>#FUNNY @PROGID_ALEADY_SET	;	If Token used twice (Heidenhain) or in Loop (Deckel)

%ASK=Enter program ID number=#PROGID
%IF #PROGID=#FUNNY %THEN #PROGID=1

@PROGID_ALEADY_SET
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_ASK_PROGDESCR
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ASK_PROGDESCR:%CALL=ENTER_PROCEDURE

*	Handle User Input when Token PROGDESCR used
%IF $DESCR<>"" @PROGDESCR_ALEADY_SET	;	If Token used twice (Heidenhain) or in Loop (Deckel)

%ASK=Program Description=$DESCR
%IF $DESCR="" %THEN $DESCR=PARTNAME

@PROGDESCR_ALEADY_SET
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*	*****************************************
*	*	Test Profile Lead conditions		*
*	*****************************************
*
%PROCEDURE=PT_CHECK_LEAD
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CHECK_LEAD:%CALL=ENTER_PROCEDURE
* Check for arc move
%IF #WARNCRCARC=0 @LINEAR
%IF #MACRO=53 @ARCMOVE
%IF #MACRO=54 @ARCMOVE
%IF #MACRO<>37 @LINEAR
* Thread Milling
%IF #GCODE=DATA1(3) @ARCMOVE
%IF #GCODE=DATA1(4) @ARCMOVE
%GOTO @LINEAR

@ARCMOVE
$WARNING="Warning - Cutter Compensation changed on arc move":%CALL=CODECON_WARNING

@LINEAR

* #WarnCRC = 0  No warnings
*            1  CRC Warn if Used only
*            2  CRC warn if not 90 only
*            3  Both above warnings

%IF #WARNCRC90=0 @CHECKZ				;	If Code Wizard option to warn not set then miss warning message
%IF FIELD1=#FUNNY @LEAD_NOT_90
%IF FIELD1<>90 @LEAD_NOT_90
%GOTO @CHECKZ
@LEAD_NOT_90
$WARNING="Warning - Cutter Compensation active - Lead move not 90 degree":%CALL=CODECON_WARNING

@CHECKZ
%IF #MOVE<4 @END			; Move doesn't include Z axis
*
%IF #COMPMODE=1 @LEADIN
%IF #CRCONZ1=0 @END       ; Check for CRC on Z allowed
* Warn for CRC application on Z move
$WARNING="Warning - Cutter Compensation removed with Z component":%CALL=CODECON_WARNING

%GOTO @END

@LEADIN
%IF #CRCONZ2=0 @END       ; Check for CRC on Z allowed
* Warn for CRC cancellation on Z move
$WARNING="Warning - Cutter Compensation applied with Z component":%CALL=CODECON_WARNING

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*
%PROCEDURE=PT_OUTPUT_RAPID			;	Called for all rapid motion - single code constructor
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_RAPID:%CALL=ENTER_PROCEDURE

*
*		Global output Rapids as high feedrates if #FEEDRAPIDS set to Yes - use #FEED to force re-instate of cut feed
*

#GCODE=DATA1(1)
#FEED=NEXTFEED

%IF #TOOLCHANGE=#FALSE @NOTOOL
*  #FIRSTRAPIDZ=#FIRSTRAPIDZ+#ZTOOLSUB ; take tool length into account.
* if the first move after is in xy only then z should be next z
%IF #HOLECYCLE=#TRUE %THEN #ZMOVE=ZCLEAR:%GOTO @NOTOOL ; NEXTZMOVE cannot be used when using a hole cycle
* Don't use NEXTZ if FEED move follows
%IF NEXTMACRO=2 %THEN #ZMOVE=ZMOVE:%GOTO @NOTOOL
*
%IF #FIRSTRAPIDZ=#ZTEMPREF %THEN #ZMOVE=NEXTZMOVE %ELSE #ZMOVE=ZMOVE
@NOTOOL

%IF #FEEDRAPIDS=#TRUE %THEN #GCODE=DATA1(2):#FEED=#RAPIDFEEDRATE:%GOTO @ALL_RAPIDS_TO_FEEDS			;	All Rapids are being converted to feed

%IF #RAPDIST<>0 %THEN %CALL=PT_CALC_VECTOR_DISTANCE	;	Convert small moves to Rapid - calc vector distance

@ALL_RAPIDS_TO_FEEDS

%CALL=PT_SET_PRECISION

%IF #SPEEDUP=0 @JUMP
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO

%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ

%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
@JUMP



%CALL=NOMOTION
%IF #MOVE=0 @END
*$COMP=0

%IF #TOOLCHANGE=#TRUE %THEN %CALL=PT_RAPID_AFTER_TOOLCHANGE:%GOTO @END		; Call if first move after toolchange

%CALL=CODECON_RAPID-MOVE
@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_RAPID_AFTER_TOOLCHANGE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_RAPID_AFTER_TOOLCHANGE:%CALL=ENTER_PROCEDURE

*Set CPL Parameters
%GETCPL=#CURRENTCPL
*		First Rapid move after Toolchange - Called from Hole cycles
%CALL=CODECON_RA-AFTER-TOOLCHANGE

@END
#TOOLCHANGE=#FALSE
;#CANCELCOMP=#TRUE
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
%PROCEDURE=PT_SPEED_SET
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SPEED_SET:%CALL=ENTER_PROCEDURE

* procedure to set and check spindle speed whenever the token is used.
#SPEED99=SPEED
%IF #TOOLCHANGE=#TRUE %THEN #SPEED99=NEXTSPEED

* Only process when speed changes for efficiency
%IF #SPEED99<>#SPEEDHOLD @CHANGE
%IF #DIRECTION=#DIRECTIONHOLD @END

@CHANGE
#SPEED=#SPEED99
* #SPEEDHOLD=#SPEED99

%CALL=PT_SPINDLE

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
%PROCEDURE=PT_OUTPUT_FEED				;	Called for all feedrate motion.
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_FEED:%CALL=ENTER_PROCEDURE
#GCODE=DATA1(2)

* Fix for thread mill lead out
%IF #MACRO=37 @THREAD_MILL
%IF SUBFUNCT=0 @CONTINUE ; Not Set

%IF SUBFUNCT=2 @OFF
* Comp On
$COMPOUTPUT=FALSE
%IF #COMPON=0 %THEN $COMPOUTPUT=TRUE
%GOTO @CONTINUE

@OFF
* Comp Off
%IF #COMPON=0 %THEN $COMPOUTPUT=TRUE
%GOTO @CONTINUE

* Fix for thread mill lead out, Thread mill always sets SUBFUNCT to 1
@THREAD_MILL
%IF #THREADMOVE<>2 @CONTINUE
%IF #COMPON=1 %THEN $COMPOUTPUT=FALSE

@CONTINUE
;%IF #EXACTSTOP=1 %THEN #GCODE=DATA1(2) %ELSE #GCODE=DATA1(10)		;	G01 or G09 - exact stop off / on
%CALL=PT_SET_PRECISION

%IF #SPEEDUP=0 @JUMP
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
@JUMP


%CALL=NOMOTION
%IF #MOVE=0 @END

* Checks for CRC
%IF $COMPOUTPUT=TRUE @NO_COMP

%IF #MOVE<>4 @CALL
* Next line commented out for DEV00010860 - check before final removal
* #COMPGCODE=#FUNNY
#COMPDCODE=#FUNNY
%GOTO @NO_COMP  ;Never on Z only move, hold for next move

@CALL
%CALL=CRC_HANDLER

@NO_COMP

*	Output Feed move
#TMP=#COMPDCODE
%IF #COMPGCODE=DATA1(21) @OUTPUT
%IF #COMPGCODE=DATA1(22) @OUTPUT
#COMPDCODE=#FUNNY

@OUTPUT
%CALL=CODECON_LINEAR-INTERPOLATION
%IF #MOVE=4 %THEN #COMPDCODE=#TMP

*	Cancel cutter compensation via CodeCon_cancel-cutter-comp
*	Code Constructor must be empty if output is with move otherwise blank block will be produced

@END
#LEADOUTCOUNT=#LEADOUTCOUNT-1	;	countdown to cancel comp move for profile cycle
* Next line removed to prevent duplicate calls DEV00012565
* %IF #LEADOUTCOUNT=1 %THEN %CALL=CODECON_CANCEL-CUTTER-COMP

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*

%PROCEDURE=CRC_HANDLER
%IF #PROCTRACE=1 %THEN $PROCEDURE=CRC_HANDLER:%CALL=ENTER_PROCEDURE

*	Handles the applying and cancellation of cutter compensation in all situations						*

*****************************
*	Profile Cycle			*
*****************************

$DECKELCOMP=0
%IF #THREADMOVE=1 @LEAD_IN			;	Apply cutter comp during first valid thread mill move
%IF #THREADMOVE=2 @LEAD_OUT			;	Cancel cutter comp during last valid thread mill move
%IF #MACRO=37 @END

%IF SUBFUNCT=1 @LEAD_IN				;	Apply cutter comp during 90 degree lead in move
%IF SUBFUNCT=2 %THEN %CALL=PT_LEAD_OUT	;	Start count down to cancel cutter compensation during lead out
%IF #LEADOUTCOUNT=1 @LEAD_OUT			;	Processing 90 degree (last) move in lead out sequence
%IF #LEADOUTCOUNT=#FUNNY @LEAD_IN
%IF #LEADOUTCOUNT>1 @END

%IF #COMPGCODE=DATA1(20) @LEAD_OUT	;	Cancel comp (G40)
%IF $COMPOUTPUT=TRUE @END
%IF #COMPON=0 @LEAD_OUT

@LEAD_IN

*********************************************
*	Handles apply compensation in all cases	*
*********************************************
#COMPMODE=1
%CALL=PT_CHECK_LEAD

$DECKELCOMP=1 									;Deckel machine specific
%IF $MACHINE="DECKEL" %THEN #FEED=NEXTFEED   ;Deckel outputs feed prior to applying comp

*	Retrieve original compensation Gcode
#COMPGCODE=#COMPGCODEHOLD

*	Retrieve current compensation Dcode (register)
#COMPDCODE=#COMPDCODEHOLD
%CANCEL=#COMPDCODE

%IF $COMPOUTPUT=FALSE %THEN %CALL=CODECON_CUTTER-COMPENSATION

%IF $MACHINE="DECKEL" %THEN %DONT-OUTPUT=#FEED    ;Deckel has no feeds output when comp is active

$COMPOUTPUT=TRUE			;	Avoid multiple output calls until Comp Cancelled / Suspended
#THREADMOVE=0
%GOTO @END


@LEAD_OUT

*************************************************
*	Handles cancel compensation in all cases	*
*************************************************
#COMPMODE=0
%CALL=PT_CHECK_LEAD
%IF #COMPON=0 %THEN $COMPOUTPUT=TRUE

*	Set Cancel GCode
%IF $MACHINE="DECKEL" %THEN #COMPGCODE=#FUNNY %ELSE #COMPGCODE=DATA1(20)

*		Output is from motion procedure since is either with or after move
* Call codecon for machines needing separate G40 block
%IF $COMPOUTPUT=FALSE %THEN %CALL=CODECON_CANCEL-CUTTER-COMP
* #COMPON=0
$COMPOUTPUT=TRUE

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*
*	Reverse G41/G42 if processing mirror image longhand
*
%PROCEDURE=PT_REVERSE_COMP_MIRROR
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_REVERSE_COMP_MIRROR:%CALL=ENTER_PROCEDURE

*	After Mirror, Compensation may be cancelled due to final Rapid.  Need to retrieve last
*	active Comp GCode.

;%IF #CANCELCOMP=#TRUE %THEN #COMPGCODE=#COMPGCODEHOLD
*
*	reverse G41/G42 is processing mirror image
*
%IF #COMPGCODE=DATA1(21) %THEN #COMPGCODE=DATA1(22):%GOTO @FINISH
%IF #COMPGCODE=DATA1(22) %THEN #COMPGCODE=DATA1(21)

@FINISH
#COMPGCODEHOLD=#COMPGCODE


%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;
;                                      Ŀ
;Ĵ Procedure = ARC_NEG_ZERO         
;                                      
%PROCEDURE=ARC_NEG_ZERO
%IF #PROCTRACE=1 %THEN $PROCEDURE=ARC_NEG_ZERO:%CALL=ENTER_PROCEDURE

* This procedure is to trap variables which when formatted are output as -0
%IF UNIT=0 %THEN #NEGINCR=-.00009 %ELSE #NEGINCR=-.0009
%IF #IVALUE>0 @J
%IF #IVALUE>#NEGINCR %THEN #IVALUE=0
@J
%IF #JVALUE>0 @K
%IF #JVALUE>#NEGINCR %THEN #JVALUE=0
@K
%IF #KVALUE>0 @END
%IF #KVALUE>#NEGINCR %THEN #KVALUE=0
@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = PT_OUTPUT_ARC        
;                                      
%PROCEDURE=PT_OUTPUT_ARC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_ARC:%CALL=ENTER_PROCEDURE

%CALL=ARC_NEG_ZERO
%CALL=PT_SET_PRECISION

%IF #SPEEDUP=0 @JUMP
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
@JUMP
* Suppress COMPDCODE if no COMPGCODE
#TMP=#COMPDCODE
%IF #COMPGCODE=DATA1(21) @DCODE
%IF #COMPGCODE=DATA1(22) @DCODE
#COMPDCODE=#FUNNY
@DCODE

* Suppress too small moves in single quad case only
%CALL=NOMOTION
%IF CIRCLE<>1 %THEN %GOTO @CARRY-ON
%IF #MOVE=0 @END

@CARRY-ON
*	Radial Rotary Arcs output via Procedure=Radial_circle
%IF #ROTARYTYPE=2 @PLANAR		;	Rotary machine which requires unwrapped output
%IF $PLANAR=NO @END				;	Processing rotary arc
*	Process planar arc
@PLANAR
*
%IF #GCODE=DATA1(4) @OUTPUT_CCLW
*
@OUTPUT_CLW

%CALL=CODECON_CIRCULAR-INT-CLW

%GOTO @END
@OUTPUT_CCLW
%CALL=CODECON_CIRCULAR-INT-CCLW

@END
* Reset CRC Register
#COMPDCODE=#TMP
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;
;

;                                      Ŀ
;Ĵ Procedure = CIRCLE               
;                                      
%PROCEDURE=CIRCLE
%IF #PROCTRACE=1 %THEN $PROCEDURE="CIRCLE":%CALL=ENTER_PROCEDURE

* Check CRC lead conditions
%IF SUBFUNCT=0 @CRC2
%IF SUBFUNCT=1 @SF1

@SF2
$COMPOUTPUT=FALSE
#LEADOUTCOUNT=FIELD12
%IF #COMPON=0 %THEN $COMPOUTPUT=TRUE
%GOTO @CRC

@SF1
%IF #COMPON=1 %THEN $COMPOUTPUT=FALSE
@CRC
%IF $COMPOUTPUT=FALSE %THEN %CALL=CRC_HANDLER
@CRC2

* Adjust Feedrate if required
#FEED=FEED
%IF #ADJARCFEED=#TRUE %THEN %CALL=PT_COMP_ARC_FEED

* Set plane G code
#PLANEGCODE=13+XYPLANE
#PLANEGCODE=DATA1(#PLANEGCODE)

%IF XYPLANE=0 %THEN %GOTO @OUTPUT
%IF XYPLANE=2 @G19

%IF #G18SWAP=#FALSE %THEN %GOTO @OUTPUT
%GOTO @ARCSWAP
@G19
%IF #G19SWAP=#FALSE %THEN %GOTO @OUTPUT

@ARCSWAP
%IF #GCODE=DATA1(3) %THEN #GCODE=DATA1(4) %ELSE #GCODE=DATA1(3)	;Reverse G02/G03

@OUTPUT
#INCANGLE=INCANGLE


* Set IJK
%CALL=PT_ARC_CENTRE

%IF PITCH=0 %THEN PITCH=#FUNNY
#TMP=PITCH
%IF #NOPITCH=1 %THEN #TMP=#FUNNY
* ZEND set for G17 helical arcs. G18/9 not set because of DEV00011313
* <XYPLANE= [XYPLANE=0]>
%IF XYPLANE=0 %THEN #KVALUE=#TMP:#ZCENTRE=#FUNNY:#XMOVE=XEND:#YMOVE=YEND:#ZMOVE=ZEND ;XY
%IF XYPLANE=1 %THEN #JVALUE=#TMP:#YCENTRE=#FUNNY:#XMOVE=XEND:#ZMOVE=ZEND:#YMOVE=#YHOLD ;XZ
%IF XYPLANE=2 %THEN #IVALUE=#TMP:#XCENTRE=#FUNNY:#YMOVE=YEND:#ZMOVE=ZEND:#XMOVE=#XHOLD ;YZ

* Check arc centre accuracy.  Set precision before radius checks
%CALL=PT_SET_PRECISION
%IF #USERADS=1 %THEN %CALL=RADIUS_ROUNDED_CENTRE

%IF $MACHINE="HEIDENHAIN" @TNC

* Set arc type - Radius or IJK
* <Inc [#INCANGLE=0]>
%IF #USERADS=#FALSE %THEN #RADIUS=#FUNNY:%GOTO @OUTPUTARC ;User selected to use I&J
%IF $MACHINE="HEIDENHAIN" @OUTPUTARC					  ;TNC Controller always Radius

* Check for full circle (0 or 360)
%IF #INCANGLE=360 %THEN #RADIUS=#FUNNY:%GOTO @OUTPUTARC	;I&J forced 360 arc move
%IF #INCANGLE=0 %THEN #RADIUS=#FUNNY:%GOTO @OUTPUTARC	;I&J forced 360 arc move
* <AA PITCH [PITCH=2]>
%IF PITCH<>#FUNNY %THEN #RADIUS=#FUNNY:%GOTO @OUTPUTARC      ;I&J forced for helix


%IF #OUTPUTRADS=#FALSE %THEN #RADIUS=#FUNNY:%GOTO @OUTPUTARC ;I&J forced by logic e.g. 360 arc move
* Set Radius Sign
%IF #INCANGLE>180 %THEN #RADIUS=#RADIUS*-1	 ;Negate Radius
#IVALUE=#FUNNY:#JVALUE=#FUNNY:#KVALUE=#FUNNY ;Radius output
%GOTO @OUTPUTARC

@TNC
* Always Centre and Radius output
* Set Radius and precision
#RADIUS=ABS(RADIUS)
#RADIUS=#RADIUS/RESOLUTION
#RADIUS=#RADIUS+0.5
#RADIUS=INT(#RADIUS)
#RADIUS=#RADIUS*RESOLUTION
#IVALUE=#FUNNY:#JVALUE=#FUNNY:#KVALUE=#FUNNY

@OUTPUTARC
%IF #FULLARCXYZ=0 @OUTPUTARC2
%IF #INCANGLE=360 @FULLARC
%IF #INCANGLE=0 @FULLARC
%GOTO @OUTPUTARC2

@FULLARC
* XYPLANE is set as 0, 1 and 2 for XY, ZX and ZY respectively
%IF XYPLANE=0 %THEN %CANCEL=#XMOVE,#YMOVE
%IF XYPLANE=1 %THEN %CANCEL=#XMOVE,#ZMOVE
%IF XYPLANE=2 %THEN %CANCEL=#YMOVE,#ZMOVE

@OUTPUTARC2
%CALL=PT_OUTPUT_ARC

*	Cancel cutter compensation via CodeCon_cancel-cutter-comp
*	Code Constructor must be empty if output is with move otherwise blank block will be produced
%IF #LEADOUTCOUNT=1 %THEN %CALL=CODECON_CANCEL-CUTTER-COMP

#OUTPUTRADS=#USERADS				;Reset
#LEADOUTCOUNT=#LEADOUTCOUNT-1		;Countdown to cancel crc for profile
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

***************************************************************************
%DECLARE=#XROUNDCENTRE,#YROUNDCENTRE,#LEN,#ANG1,#XDIST2,#YDIST2
%DECLARE=#XCENTREERROR,#YCENTREERROR,#TEMPXCENTRE,#TEMPYCENTRE
%DECLARE=#XTEMP1,#XTEMP2,#YTEMP1,#YTEMP2,#XDIST,#YDIST,#CHORD
***************************************************************************

%PROCEDURE=RADIUS_ROUNDED_CENTRE
%IF #PROCTRACE=1 %THEN $PROCEDURE="RADIUS_ROUNDED_CENTRE":%CALL=ENTER_PROCEDURE

%IF INCANGLE=0 @END
%IF INCANGLE=360 @END
#OUTPUTRADS=1

* Set Radius and precision
#RADIUS=ABS(RADIUS)
#RADIUS=#RADIUS/RESOLUTION
#RADIUS=#RADIUS+0.5
#RADIUS=INT(#RADIUS)
#RADIUS=#RADIUS*RESOLUTION

%IF INCANGLE<300 @END

* Check accuracy of centre point
%IF XYPLANE=0 @G17
%IF XYPLANE=1 @G18
@G19
#XTEMP1=#YSTART
#XTEMP2=#YMOVE
#YTEMP1=#ZSTART
#YTEMP2=#ZMOVE
#TEMPXCENTRE=#YCENTRE
#TEMPYCENTRE=#ZCENTRE
%GOTO @READY

@G18
#XTEMP1=#XSTART
#XTEMP2=#XMOVE
#YTEMP1=#ZSTART
#YTEMP2=#ZMOVE
#TEMPXCENTRE=#XCENTRE
#TEMPYCENTRE=#ZCENTRE
%GOTO @READY

@G17
#XTEMP1=#XSTART
#XTEMP2=#XMOVE
#YTEMP1=#YSTART
#YTEMP2=#YMOVE
#TEMPXCENTRE=#XCENTRE
#TEMPYCENTRE=#YCENTRE

@READY

#XDIST=#XTEMP2-#XTEMP1
#TMP1=#XDIST*#XDIST
#YDIST=#YTEMP2-#YTEMP1
#TMP2=#YDIST*#YDIST

#CHORD=#TMP1+#TMP2
#CHORD=SQR(#CHORD)
#CHORD=#CHORD/2

* <* 1/2CHORD = [#CHORD=0] Rad [#RADIUS=0]>
#TMP1=#RADIUS*#RADIUS
#TMP2=#CHORD*#CHORD

%IF #YDIST=0 %THEN #ANG1=90 %ELSE #ANG1=#XDIST/#YDIST:#ANG1=ATAN(#ANG1)
#ANG1=90+#ANG1

#LEN=#TMP1-#TMP2
#LEN=ABS(#LEN):#LEN=SQR(#LEN)

#XDIST2=SIN(#ANG1):#XDIST2=#XDIST2*#LEN
#YDIST2=COS(#ANG1):#YDIST2=#YDIST2*#LEN
#XDIST=#XDIST/2
#YDIST=#YDIST/2

#XDIST=ABS(#XDIST):#XDIST2=ABS(#XDIST2)
#YDIST=ABS(#YDIST):#YDIST2=ABS(#YDIST2)

%IF #XTEMP1>#XTEMP2 %THEN #XDIST=#XDIST*-1
%IF #YTEMP1>#YTEMP2 %THEN #YDIST=#YDIST*-1

#XROUNDCENTRE=#XTEMP1+#XDIST
#YROUNDCENTRE=#YTEMP1+#YDIST

%IF #XROUNDCENTRE>#TEMPXCENTRE %THEN #XDIST2=#XDIST2*-1
%IF #YROUNDCENTRE>#TEMPYCENTRE %THEN #YDIST2=#YDIST2*-1

#XROUNDCENTRE=#XROUNDCENTRE+#XDIST2
#YROUNDCENTRE=#YROUNDCENTRE+#YDIST2
#XCENTREERROR=#TEMPXCENTRE-#XROUNDCENTRE:#XCENTREERROR=ABS(#XCENTREERROR)
#YCENTREERROR=#TEMPYCENTRE-#YROUNDCENTRE:#YCENTREERROR=ABS(#YCENTREERROR)

* Force IJK if calculated centre out of position
%IF #XCENTREERROR>RESOLUTION %THEN #OUTPUTRADS=0
* <******  RADIUS AXIS CENTRE ERROR [#XCENTREERROR=0]   - TRUE CENTRE [#TEMPXCENTRE=0] ROUNDED CENTRE [#XROUNDCENTRE=0]>
%IF #YCENTREERROR>RESOLUTION %THEN #OUTPUTRADS=0
*<******  RADIUS AXIS CENTRE ERROR [#YCENTREERROR=1]   - TRUE CENTRE [#TEMPYCENTRE=1] ROUNDED CENTRE [#YROUNDCENTRE=1]>

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM



***************************************************************************

%PROCEDURE=PT_ARC_TURN_BRG_HH
*Set up parameters and call standard procedure to
*calculate angle bearings for TNC helical arc moves
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ARC_TURN_BRG_HH:%CALL=ENTER_PROCEDURE

XSTART=#XHOLD
YSTART=#YHOLD
ZSTART=#ZHOLD
XCENTRE=#XCENTRE
YCENTRE=#YCENTRE
ZCENTRE=#ZCENTRE
XEND=#XMOVE
YEND=#YMOVE
ZEND=#ZMOVE

* DEV00012570 undo previous change to correct thread mill regression
%IF #MACRO=37 @THREADMILL
#RADIUS=ABS(RADIUS)
#INCANGLE=ABS(INCANGLE)
%GOTO @TURNS

@THREADMILL
#RADIUS=ABS(#STARTRAD)

@TURNS
%CALL=PT_ARC_TURN_BRG; Sets start angle and possibly other values
* Multiple turns
* Note that complete circle can have included angle of 0 or 360
* Note that multiple turn arc has only 0-360 included angle, derive from pitch and Z move
#TURNS=0
%IF #INCANGLE=0 %THEN #INCANGLE=360
#TURNS=ZEND-ZSTART
#TURNS=#TURNS/PITCH
* Round result of division
#TURNS=#TURNS*100+0.5
#TURNS=INT(#TURNS)
#TURNS=#TURNS/100

#TMP=ABS(#TURNS)
#TURNS=INT(#TMP)
%IF #TURNS=#TMP %THEN #TURNS=#TURNS-1

%IF #TURNS=0 @END
#TURNS=#TURNS*360
#INCANGLE=#INCANGLE+#TURNS

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_ARC_TURN_BRG			;	Calculate the angle between start and end positions.
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ARC_TURN_BRG:%CALL=ENTER_PROCEDURE
* Still needed for thread milling
*
%IF XYPLANE=0 %THEN #XINC=XSTART-XCENTRE:#YINC=YSTART-YCENTRE
%IF XYPLANE=1 %THEN #XINC=XSTART-XCENTRE:#YINC=ZSTART-ZCENTRE
%IF XYPLANE=2 %THEN #XINC=YSTART-YCENTRE:#YINC=ZSTART-ZCENTRE
#BEARING=#YINC
#RADIUS2=#RADIUS
************* NEED TO USE XINC.YINC IN ASIN_BEARING
%CALL=ASIN_BEARING:#BEARING1=#BEARING
%IF XYPLANE=0 %THEN #XINC=XEND-XCENTRE:#YINC=YEND-YCENTRE
%IF XYPLANE=1 %THEN #XINC=XEND-XCENTRE:#YINC=ZEND-ZCENTRE
%IF XYPLANE=2 %THEN #XINC=YEND-YCENTRE:#YINC=ZEND-ZCENTRE
#BEARING=#YINC
#RADIUS2=#ENDRAD
%CALL=ASIN_BEARING:#BEARING2=#BEARING
@CALC_ANGLE

%IF XYPLANE<>1 @NORMAL
%IF #GCODE=DATA1(3) %THEN #INCANGLE=#BEARING2-#BEARING1 %ELSE #INCANGLE=#BEARING1-#BEARING2
%GOTO @FIN_INCLUDE
@NORMAL
%IF #GCODE=DATA1(4) %THEN #INCANGLE=#BEARING2-#BEARING1 %ELSE #INCANGLE=#BEARING1-#BEARING2
@FIN_INCLUDE

%IF #INCANGLE<=0.000001 %THEN #INCANGLE=#INCANGLE+360  		;If less than zero then add 360 degrees
#BEARING=#INCANGLE

*Double check for 360 case
%IF #INCANGLE<359 @END
%IF XSTART<>XEND @END
%IF YSTART<>YEND @END
%IF ZSTART<>ZEND @END
* Full circle
#INCANGLE=360

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=ASIN_BEARING
%IF #PROCTRACE=1 %THEN $PROCEDURE=ASIN_BEARING:%CALL=ENTER_PROCEDURE

#BEARING=#BEARING/#RADIUS2
#BEARING=ASIN(#BEARING)
%IF #YINC=>0 @QUAD_CHECK_X
%IF #XINC>0 %THEN #BEARING=360+#BEARING;:<* QUAD 4>
%IF #XINC=<0%THEN #BEARING=180-#BEARING;:<* QUAD 3>
%GOTO @QUAD_CHECK_OVER
@QUAD_CHECK_X
%IF #XINC<0 %THEN #BEARING=180-#BEARING;:<* QUAD 2> %ELSE <* QUAD 1>
@QUAD_CHECK_OVER

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM



;                                      Ŀ
;Ĵ Procedure = PT_COMP_ARC_FEED     
;                                      
%PROCEDURE=PT_COMP_ARC_FEED
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_COMP_ARC_FEED:%CALL=ENTER_PROCEDURE

*	*************************************************
*	Compensate feedrates for arcs if option selected
*	*************************************************
*
%IF LEFTRIGHT=#FUNNY @END
#FEED=FEED
%IF XYPLANE<>0 @END ; Don't adjust arc in the XZ / YZ planes
*  #TMP=ABS(RADIUS):%IF #TMP=TOOLRAD @END				;	Avoid division by zero for Faster

%IF #MIRROR=1 %THEN #RADIUS=RADIUS*-1 %ELSE #RADIUS=RADIUS
%IF #RADIUS<0 @CLW
%IF LEFTRIGHT=0 %THEN %GOTO @FASTER %ELSE %GOTO @SLOWER
@CLW
%IF LEFTRIGHT=1 %THEN %GOTO @FASTER %ELSE %GOTO @SLOWER

*	External Corners
@FASTER
#TMP=XYFEED*#MAXFEEDADJ
#TMP1=ABS(RADIUS)
#TMP2=#TMP1
%IF PATHTRACE=1 %THEN #TMP1=#TMP1-TOOLRAD:%GOTO @CONTROL_FASTER
%IF #COMPON=#FALSE %THEN #TMP1=#TMP1-TOOLRAD:%GOTO @CONTROL_FASTER
#TMP2=#TMP2+TOOLRAD
@CONTROL_FASTER
* Following check safer in two lines because of precision checking
%IF #TMP1=0 %THEN #FEED=XYFEED:%GOTO @END		;Check to see if machining small arc with large tool i.e. calc results in -ve value
%IF #TMP1<0 %THEN #FEED=XYFEED:%GOTO @END		;Check to see if machining small arc with large tool i.e. calc results in -ve value
#FEED=(#TMP2/#TMP1)*XYFEED

%IF #FEED>#TMP %THEN #FEED=#TMP	;	If result is outside adjustment percentage then use upper limit
%GOTO @END

*	Internal Corners
@SLOWER
#TMP=XYFEED*#MINFEEDADJ
#TMP1=ABS(RADIUS)
#TMP2=#TMP1
%IF PATHTRACE=1 %THEN #TMP1=#TMP1+TOOLRAD:%GOTO @CONTROL_SLOWER
%IF #COMPON=#FALSE %THEN #TMP1=#TMP1+TOOLRAD:%GOTO @CONTROL_SLOWER
#TMP2=#TMP2-TOOLRAD
@CONTROL_SLOWER
#FEED=(#TMP2/#TMP1)*XYFEED

%IF #FEED<#TMP %THEN #FEED=#TMP   ;	If result is outside adjustment percentage then use upper limit

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = PT_HOLE_CYCLES       
;                                      
%PROCEDURE=PT_HOLE_CYCLES
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_HOLE_CYCLES:%CALL=ENTER_PROCEDURE

*	Output all Hole cycles Drill, Chipbreak, Ream and Bore as Canned Cycles - coords are held in the XYZPOINT array
*   Called from each cycle macro and cyclsub for subroutines
*	Code Wizard will present the cycle definition line which will be in the loop expand and thus output-if-changed
*	will, typically, produce the XY points list previously seperated into PROCEDURE=LOOPEXPAND
*   If called from CYCLSUB, points are expanded from 2nd point (Loop=2)- cycle line is outside subroutine.
*	This inhibits the ability to support the format whereby the cycle parameters are variables e.g. Seimens
*

#HOLECYCLE=#TRUE
#EMULATION=#FALSE
%IF ZCLEAR=RPLANE %THEN #RETRACTGCODE=DATA1(50) %ELSE #RETRACTGCODE=DATA1(49)	;	G99 / G98

%IF #SUPPORTG98G99=#FALSE %THEN #RETRACTGCODE=#FUNNY					;	Suppress from output if not supported
#FEEDMODEGCODEHOLD=#FEEDMODEGCODE:#HCODEHOLD=#HCODE:#COOLHOLD=#COOL:#DIRECTIONHOLD=#DIRECTION
*  %IF #ZREVERSE=1 %THEN #ZMOVE=ZCLEAR*-1 %ELSE #ZMOVE=ZCLEAR
#ZMOVE=ZCLEAR
*	Rapid to first XY position then to Zclear with Tool Length Offset.  Call procedure for single Code Constructor
*	Could put this on a switch e.g. Call Rapid After toolchange ?
#XMOVE=XPOINT(1):#YMOVE=YPOINT(1)					;	First Hole position, store cycle Gcode, set to Rapid
#LOOP=1


%IF $OUTPUTSUBS=TRUE @SKIPRAP

* Siemens 840 drills at current location. Rapid to first position before calling cycle
%IF #TOOLCHANGE=#TRUE @SKIP840; Usual method
* Not Rapid After TC
#XAPP=#XMOVE
#YAPP=#YMOVE
#XMOVE=#XSTOREABS
#YMOVE=#YSTOREABS
%IF #ZREVERSE=1 %THEN #TEMP=#ZHOLD*-1 %ELSE #TEMP=#ZHOLD ; Allow for Z reversal
%IF #TEMP<ZCLEAR %THEN %CALL=PT_OUTPUT_RAPID; Lift Up

#ZMOVE=#ZSTOREABS
#XMOVE=#XAPP
#YMOVE=#YAPP; Saved approach position

%IF #PREPOSITION=0 @SKIP840

%CALL=PT_OUTPUT_RAPID
* %IF #ZREVERSE=1 %THEN #ZMOVE=ZCLEAR*-1 %ELSE #ZMOVE=ZCLEAR
#ZMOVE=ZCLEAR
%IF #ZREVERSE=1 %THEN #TEMP=#ZHOLD*-1 %ELSE #TEMP=#ZHOLD ; Allow for Z reversal
%IF #TEMP>ZCLEAR %THEN %CALL=PT_OUTPUT_RAPID; Z to Clearance
%GOTO @SKIPRAP

@SKIP840
* Output move to first position (Rapid after tool change)
%IF #TOOLCHANGE=#TRUE %THEN %CALL=PT_OUTPUT_RAPID

@SKIPRAP
* %CANCEL=#XMOVE,#YMOVE	- Removed to correct XY modality in cycle definition
*%IF #CYCLEGCODE=DATA1(39) %THEN #FEED=SPEED*PITCH %ELSE

#FEED=ZFEED		;	If tapping then Feed = revs*pitch

#LOOP=1
* Branch on $OUTPUTSUBS.  =null if PATHTRACE expansion
%IF $OUTPUTSUBS<>TRUE @LOOP

* Set HOLD values for incremental calculations in subroutines
#XHOLD=XPOINT(#LOOP)
#YHOLD=YPOINT(#LOOP)
#ZHOLD=ZPOINT(#LOOP)
#LOOP=2 		;	If subroutines, expand from 2nd point

%IF #CYCLEPOINTS<>3 @LOOP

*Include first position in expansion
%IF DRILLSUB<>1 @LOOP
#LOOP=1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)
#ZMOVE=ZPOINT(#LOOP)
%CALL=PT_MULTI_LEVEL
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
%IF #ZREVERSE=1 %THEN #ZMOVE=#ZDEPTH*-1 %ELSE #ZMOVE=#ZDEPTH	;	Assign ready for output
%IF #ZREVERSE=1 %THEN #ZLEVEL=(#ZLEVEL*-1)
%IF #ZREVERSE=1 %THEN #RPLANE=(#RPLANE*-1)

%CALL=PT_CYCLEPOINTS

#LOOP=2


@LOOP
*<*	#LOOP =[#LOOP=23] LAST =[LAST=23]>
%IF #LOOP>LAST @ELOOP

#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)
#ZMOVE=ZPOINT(#LOOP)
*<*	Xpoint =[#XMOVE=24]	#Ypoint =[#YMOVE=24]>:%CANCEL=#XMOVE,#YMOVE


%CALL=PT_MULTI_LEVEL

*Check for Zdepth change and respecify cycle
#DEPTHCHANGE=#FALSE
#CYCLEGCODESAVE=#CYCLEGCODE
%IF #SUPPORTMDEPTH=1 @NOCHANGE
%IF #LOOP=1 @NOCHANGE
%IF #ZDEPTH=#ZDEPTHHOLD @NOCHANGE

#DEPTHCHANGE=#TRUE
%CALL=CODECON_CANCEL-CANNED-CYCLE
@NOCHANGE
#ZDEPTHHOLD=#ZDEPTH ; Save z Depth

*
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ

%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

%IF #ZREVERSE=1 %THEN #ZMOVE=#ZDEPTH*-1 %ELSE #ZMOVE=#ZDEPTH	;	Assign ready for output

%IF #ZREVERSE=1 %THEN #ZLEVEL=(#ZLEVEL*-1)
%IF #ZREVERSE=1 %THEN #RPLANE=(#RPLANE*-1)

*
*		Each cycle will use a different output line but needs to be here to centralise loop expansion.  Could
*		be in each macro but G81, G82 and G83 all use macro 9 and subroutines use same array.
*		Must present different Code Constructors for each cycle otherwise user will be confused - will have
*		to understand that some parameters are not used e.g. DWELL,DEPTH + ALL GCODETYPES i.e G81, G82 etc in one line etc.
*
*  This loop has "growed" and really needs a total restructure. That would take time and carry a high risk
*  of regression problems. Maybe once more strenuous regression testing is in place?
*  In the meantime I have made it even more spaghetti-like by adding the %IF #EMulation...
*  lines to get G98 emulation working for Fanuc etc.  Richard Halton Oct98
*
%IF #EMULATION=#TRUE @NORESET
%IF #SUPPORTMDEPTH=#FALSE @NORESET
%IF #LOOP=1 @NORESET
%IF $OUTPUTSUBS=FALSE @NORESET
* DB12129  Removed #ZCLEAR=#FUNNY from following suppression lines.
* DEV00002154 #COOL also removed
* DEV00007249 - Next lines considered redundant - remove ?
*%IF $MACHINE="FANUC" %THEN #CYCLEGCODE=#FUNNY:#GCODE=#FUNNY:#FEED=#FUNNY:#FEEDMODEGCODE=#FUNNY:#HCODE=#FUNNY:#SPEED=#FUNNY:#DIRECTION=#FUNNY:DWELL=#FUNNY:#DEPTH=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
*%IF $MACHINE="SIEMENS840" %THEN #CYCLEGCODE=#FUNNY:#GCODE=#FUNNY:#FEED=#FUNNY:#FEEDMODEGCODE=#FUNNY:#HCODE=#FUNNY:#SPEED=#FUNNY:#DIRECTION=#FUNNY:DWELL=#FUNNY:#DEPTH=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
*%IF $MACHINE="CINCINNATI" %THEN #CYCLEGCODE=#FUNNY:#GCODE=#FUNNY:#FEED=#FUNNY:#FEEDMODEGCODE=#FUNNY:#HCODE=#FUNNY:#SPEED=#FUNNY:#DIRECTION=#FUNNY:DWELL=#FUNNY:#DEPTH=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
*%IF $MACHINE="FADAL" %THEN #CYCLEGCODE=#FUNNY:#GCODE=#FUNNY:#FEED=#FUNNY:#FEEDMODEGCODE=#FUNNY:#HCODE=#FUNNY:#SPEED=#FUNNY:#DIRECTION=#FUNNY:DWELL=#FUNNY:#DEPTH=#FUNNY:#DEGR=#FUNNY:PITCH=#FUNNY:#BOREOFFSET=#FUNNY
@NORESET

%IF $CYCLETYPE=COUNTERBORE @G82CYCLE
%IF $CYCLETYPE=PECKDRILL @G83CYCLE
%IF $CYCLETYPE=TAPPING @G84CYCLE
%IF $CYCLETYPE=REAMBORE @G85CYCLE
%IF $CYCLETYPE=BORE @G86CYCLE
%IF $CYCLETYPE=CHIPBREAK @G73CYCLE

*	G81 Drill Cycle
@G81CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG81
%IF #LOOP>1 @G81-2
*First point only
@ForceG81
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_DRILL-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G81-2
%IF #LOOP=1 %THEN %CALL=CODECON_DRILL-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_DRILL-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_DRILL-CYCLE:%GOTO @LOOPEXPAND

*	G82 CounterBore (Dwell) Cycle
@G82CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG82
%IF #LOOP>1 @G82-2
*First point only
@ForceG82
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_COUNTERBORE-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G82-2
%IF #LOOP=1 %THEN %CALL=CODECON_COUNTERBORE-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_COUNTERBORE-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_COUNTERBORE-CYCLE:%GOTO @LOOPEXPAND

*	G83 Peck Drill Cycle
@G83CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG83
%IF #LOOP>1 @G83-2
*First point only
@ForceG83
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_PECK-DRILL-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G83-2
%IF #LOOP=1 %THEN %CALL=CODECON_PECK-DRILL-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_PECK-DRILL-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_PECK-DRILL-CYCLE:%GOTO @LOOPEXPAND

*	G84 Tapping Cycle
@G84CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG84
%IF #LOOP>1 @G84-2
*First point only
@ForceG84
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_TAPPING-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G84-2
%IF #LOOP=1 %THEN %CALL=CODECON_TAPPING-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_TAPPING-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_TAPPING-CYCLE:%GOTO @LOOPEXPAND

*	G85 Ream / Bore Cycle
@G85CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG85
%IF #LOOP>1 @G85-2
*First point only
@ForceG85
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_REAM-BORE-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G85-2
%IF #LOOP=1 %THEN %CALL=CODECON_REAM-BORE-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_REAM-BORE-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_REAM-BORE-CYCLE:%GOTO @LOOPEXPAND

*	G86 Bore Cycle (note #BOREOFFSET is entered in machine's default units)
@G86CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG86
%IF #LOOP>1 @G86-2
*First point only
@ForceG86
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_BORE-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G86-2
%IF #LOOP=1 %THEN %CALL=CODECON_BORE-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_BORE-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_BORE-CYCLE:%GOTO @LOOPEXPAND

*	G73 Chipbreak Drill Cycle
@G73CYCLE
%IF #DEPTHCHANGE=#TRUE @ForceG73
%IF #LOOP>1 @G73-2
*First point only
@ForceG73
#CYCLEGCODE=#CYCLEGCODESAVE
%CALL=CODECON_CHIPBREAK-CYCLE
%IF DRILLSUB=1 @LOOPEXPAND
%IF #CYCLEPOINTS=3 %THEN %CALL=PT_CYCLEPOINTS
%GOTO @LOOPEXPAND

@G73-2
%IF #LOOP=1 %THEN %CALL=CODECON_CHIPBREAK-CYCLE:%GOTO @LOOPEXPAND
%IF #EMULATION=#TRUE %THEN %CANCEL=#CYCLEGCODE,#ZMOVE
%IF #EMULATION=#TRUE %THEN %CALL=CODECON_CHIPBREAK-CYCLE:%GOTO @LOOPEXPAND
%IF #CYCLEPOINTS>1 %THEN %CALL=PT_CYCLEPOINTS:%GOTO @LOOPEXPAND
%CALL=CODECON_CHIPBREAK-CYCLE:%GOTO @LOOPEXPAND

@LOOPEXPAND
%IF DRILLSUB<>1 @NEXTPOINT		; Output points if not in a subroutine
%IF LAST=1 @ELOOP				; Output G80 if only 1 point
%IF $OUTPUTSUBS=TRUE @NEXTPOINT
%GOTO @END
@NEXTPOINT


%IF #SUPPORTG98G99=#TRUE @JUMP_EMULATION
%IF ZLEVEL<>#FUNNY @JUMP_EMULATION          ;   Not needed for constant height
%IF ZCLEAR=RPLANE @JUMP_EMULATION			;	Not using return to Initial Level

*		Emulate return to Initial level : G98/G99 not supported
*	Cancel Canned Cycle
#EMULATION=#TRUE
#TMP=#CYCLEGCODE
#CYCLEGCODE=DATA1(35)
%CALL=CODECON_CANCEL-CANNED-CYCLE
#CYCLEGCODE=#TMP

%IF #LOOP=LAST @END		; G80 & G00 not required after last retract to zclear

*	Rapid to clearance height
#GCODE=DATA1(1)
%IF #ZREVERSE=1 %THEN #ZMOVE=ZCLEAR*-1 %ELSE #ZMOVE=ZCLEAR
%CANCEL=#GCODE,#ZMOVE
%CALL=CODECON_RAPID-MOVE

@JUMP_EMULATION

#LOOP=#LOOP+1
%GOTO @LOOP             ;	Load next point

@ELOOP                  ;	End canned cycle output

*	G80 Cancel Canned Cycle

%CALL=CODECON_CANCEL-CANNED-CYCLE
#FEEDMODEGCODE=#FEEDMODEGCODEHOLD:#HCODE=#HCODEHOLD:#COOL=#COOLHOLD:#DIRECTION=#DIRECTIONHOLD
*Cycle finishes at ZCLEAR
%IF #ZREVERSE=1 %THEN #ZMOVE=ZCLEAR*-1 %ELSE #ZMOVE=ZCLEAR
#ZHOLD=#ZMOVE

@END
* #HOLECYCLE2 is now used to suppress sub call approach moves
* Set 0 if not using drill subroutines
%IF #MACRO=61 %THEN #HOLECYCLE2=1
#HOLECYCLE=#FALSE
@END99
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = PT_CYCLEPOINTS      
;

%PROCEDURE=PT_CYCLEPOINTS
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CYCLEPOINTS:%CALL=ENTER_PROCEDURE

* Blank null values - not required
%IF DWELL=0 %THEN DWELL=#FUNNY
%IF #BOREOFFSET=0 %THEN #BOREOFFSET=#FUNNY
%IF #PITCH=0 %THEN #PITCH=#FUNNY
%IF #DEGR=0 %THEN #DEGR=#FUNNY

%CALL=CODECON_HOLE-CYCLEPOINTS

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                      Ŀ
;Ĵ Procedure = PT_MULTI_LEVEL      
;                                      
%PROCEDURE=PT_MULTI_LEVEL
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_MULTI_LEVEL:%CALL=ENTER_PROCEDURE

%IF ZLEVEL=#FUNNY @MULTI
@SINGLE
#ZLEVEL=ZLEVEL
#ZDEPTH=ZDEPTH
#RPLANE=RPLANE
%GOTO @END
@MULTI
#ZLEVEL=ZPOINT(#LOOP)
#ZDEPTH=MZDEPTH(#LOOP)
#RPLANE=MRPLANE(#LOOP)
@END


%IF #ZRABSINCR<>1 %THEN %CALL=PT_CYCLE_DEPTHS		;	If Z depths are Incremental
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = PT_CYCLE_DEPTHS 	  
;                                      
%PROCEDURE=PT_CYCLE_DEPTHS
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CYCLE_DEPTHS:%CALL=ENTER_PROCEDURE

*	To calculate Incremental & Unsigned Incremental	Z Depth
*	Incremental is measured from the Rplane
#ZDEPTH=#ZDEPTH-#RPLANE
%IF #ZRABSINCR=3 %THEN #ZDEPTH=ABS(#ZDEPTH)			;	Incremental, Unsigned
#RPLANE=#RPLANE-ZCLEAR
%IF #ZRABSINCR=3 %THEN #RPLANE=ABS(#RPLANE)

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = DATUM_HOLD           
;                                      
%PROCEDURE=DATUM_HOLD
%IF #PROCTRACE=1 %THEN $PROCEDURE=DATUM_HOLD:%CALL=ENTER_PROCEDURE

#XABSORIGINHOLD=XSUB
#YABSORIGINHOLD=YSUB
#ZABSORIGINHOLD=ZSUB
#SYSIDHOLD=SYSID

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = SET_TOOLING_DATA      
;                                      
%PROCEDURE=SET_TOOLING_DATA
%IF #PROCTRACE=1 %THEN $PROCEDURE=SET_TOOLING_DATA:%CALL=ENTER_PROCEDURE

#HEADER=1
@STARTLOOP
%LOAD=#HEADER

*	Remove duplicate tools from NC Code tool list
%IF #REMOVEDUPLICATES=#FALSE @MISS_REMOVE_DUPLICATES
#TMP1=#FALSE:%CALL=PT_REMOVE_DUPLICATE_TOOLS:%IF #TMP1=#TRUE @SKIP
@MISS_REMOVE_DUPLICATES

%LOAD=#HEADER
%IF TOOLNUM=0 %THEN $TOOLDESCRIPTION=USERDEFINEDSTRING %ELSE $TOOLDESCRIPTION=TOOLDESCRIPTION

%CALL=CODECON_SET-TOOLING-DATA

@SKIP
#HEADER=#HEADER+1:%IF #HEADER>NUMTOOLS @END

%GOTO @STARTLOOP

@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = SET_WORK_DATUMS      
;                                      
%PROCEDURE=SET_WORK_DATUMS
%IF #PROCTRACE=1 %THEN $PROCEDURE=SET_WORK_DATUMS:%CALL=ENTER_PROCEDURE

* ECS27xx uses 20 settings
%IF $MACHINE="ECS2700" %THEN %CALL=SET_WORK_DATUMS_20
%IF $MACHINE="ECS2700" @END2

;
;  List of variables effected :-
;
;  INDEX            = Pallet angle position
;  GROUPDESCRIPTION = CPL name
;  STYPE            = Coord shift type  ABS = 1  INC = 0
;  ROT1             = Absolute primary angle
;  ROT2             = Absolute secondary angle
;  XSUB             = Absolute X datum origin
;  YSUB             = Absolute Y datum origin
;  ZSUB             = Absolute Z datum origin
;  SYSID            = Unique coord system identifier
;  DIRECTION        = Index direction
;  SUBFUNCT         = current CPL pointer ( used with %GETCPL )
;
;
; This procedure will capture all Absolute datum shifts and assign them
; against the standard work coord codes.
;
#LOOP=0:#COORDNUM=1:#G54=0:#G55=0:#G56=0:#G57=0:#G58=0:#G59=0:#SYSIDHOLD=0
@STARTLOOP

#LOOP=#LOOP+1
%GETCPL=#LOOP
$CPLNAME=GROUPDESCRIPTION
%IF SYSID=#FUNNY @END ; All datums have been loaded.

;< STYPE=[STYPE=0]>
;< XSUB=[XSUB=0]>
;< YSUB=[YSUB=1]>
;< ZSUB=[ZSUB=2]>
;< #XSUB=[#XSUB=0]>
;< #YSUB=[#YSUB=1]>
;< #ZSUB=[#YSUB=2]>
;< XINC=[XINC=2]>
;< YINC=[YINC=2]>
;< ZINC=[ZINC=2]>

%IF #LOOP=1 @FORCE ; Always assign first datum to ensure G54 setting
%IF STYPE<>1 %THEN %GOTO @STARTLOOP		; Datum type is incremental, skip assignment.

@FORCE
#SYSID=SYSID*1000000:%IF #UNIQUEDATUMS=#TRUE %THEN #SYSID=(#SYSID+(ROT1*1000)+ROT2) ; Make Datum unique by XYZ and Rotation
;<Sysid = [#SYSID=23]>
;<Uniquedatum = [#UNIQUEDATUMS=24]>

%IF #SYSID=#G54 @STARTLOOP  								; Skip if datum is already assigned.
%IF #SYSID=#G55 @STARTLOOP
%IF #SYSID=#G56 @STARTLOOP
%IF #SYSID=#G57 @STARTLOOP
%IF #SYSID=#G58 @STARTLOOP
%IF #SYSID=#G59 @STARTLOOP

@UNIQUE-MPL

%IF #COORDNUM=1 %THEN #G54=#SYSID:#WORKGCODE=DATA1(25)		;	G54
%IF #COORDNUM=2 %THEN #G55=#SYSID:#WORKGCODE=DATA1(26)		;	G55
%IF #COORDNUM=3 %THEN #G56=#SYSID:#WORKGCODE=DATA1(27)		;	G56
%IF #COORDNUM=4 %THEN #G57=#SYSID:#WORKGCODE=DATA1(28)		;	G57
%IF #COORDNUM=5 %THEN #G58=#SYSID:#WORKGCODE=DATA1(29)		;	G58
%IF #COORDNUM=6 %THEN #G59=#SYSID:#WORKGCODE=DATA1(30)		;	G59
%IF #COORDNUM=7 %THEN $WARNING="Warning - More than 6 Work Co-ordinate Systems programmed":%CALL=CODECON_WARNING
%IF #COORDNUM=7 %THEN $WARNING="          Remaining Co-ordinate Systems will be output as incremental":%CALL=CODECON_WARNING:%GOTO @END

*	Option to output first Datum (G54) as XYZHOME location
%IF #COORDNUM=1 %THEN %CALL=PT_OUTPUT_G54_TO_TABLE_CENTRE



#XSUB=XSUB:#YSUB=YSUB:#ZSUB=ZSUB


%CALL=CODECON_SET-WORK-DATUMS

#COORDNUM=#COORDNUM+1

%GOTO @STARTLOOP
@END

#LOOP=1
%GETCPL=#LOOP
$CPLNAME=GROUPDESCRIPTION
%CALL=PT_ABS_DATUM_RECALL
%CALL=DATUM_HOLD

@END2
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM



;                                      Ŀ
;Ĵ Procedure = SET_WORK_DATUMS_20      
;                                      
%PROCEDURE=SET_WORK_DATUMS_20
%IF #PROCTRACE=1 %THEN $PROCEDURE=SET_WORK_DATUMS_20:%CALL=ENTER_PROCEDURE

* This procedure will capture all Absolute datum shifts and assign them
* against the standard work coord codes. Adapted from standard procedure for 20 settings

#LOOP=0
#SYSIDHOLD=0
#COORDNUM=1
#G54=0
#G5401=0:#G5402=0:#G5403=0:#G5404=0:#G5405=0
#G5406=0:#G5407=0:#G5408=0:#G5409=0:#G5410=0
#G5411=0:#G5412=0:#G5413=0:#G5414=0:#G5415=0
#G5416=0:#G5417=0:#G5418=0:#G5419=0:#G5420=0

@STARTLOOP

#LOOP=#LOOP+1
%GETCPL=#LOOP
$CPLNAME=GROUPDESCRIPTION
%IF SYSID=#FUNNY @END ; All datums have been loaded.


%IF STYPE<>1 %THEN %GOTO @STARTLOOP		; Datum type is incremental, skip assignment.

#SYSID=SYSID*1000000:%IF #UNIQUEDATUMS=#TRUE %THEN #SYSID=(#SYSID+(ROT1*1000)+ROT2) ; Make Datum unique by XYZ and Rotation

%IF #SYSID=#G5401 @STARTLOOP  								; Skip if datum is already assigned.
%IF #SYSID=#G5402 @STARTLOOP
%IF #SYSID=#G5403 @STARTLOOP
%IF #SYSID=#G5404 @STARTLOOP
%IF #SYSID=#G5405 @STARTLOOP
%IF #SYSID=#G5406 @STARTLOOP
%IF #SYSID=#G5407 @STARTLOOP
%IF #SYSID=#G5408 @STARTLOOP
%IF #SYSID=#G5409 @STARTLOOP
%IF #SYSID=#G5410 @STARTLOOP
%IF #SYSID=#G5411 @STARTLOOP
%IF #SYSID=#G5412 @STARTLOOP
%IF #SYSID=#G5413 @STARTLOOP
%IF #SYSID=#G5414 @STARTLOOP
%IF #SYSID=#G5415 @STARTLOOP
%IF #SYSID=#G5416 @STARTLOOP
%IF #SYSID=#G5417 @STARTLOOP
%IF #SYSID=#G5418 @STARTLOOP
%IF #SYSID=#G5419 @STARTLOOP
%IF #SYSID=#G5420 @STARTLOOP

@UNIQUE-MPL
* <Coordnum [#COORDNUM=0]>
%IF #COORDNUM=1 %THEN #G5401=#SYSID:#WORKGCODE=#G5401CODE
%IF #COORDNUM=2 %THEN #G5402=#SYSID:#WORKGCODE=#G5402CODE
%IF #COORDNUM=3 %THEN #G5403=#SYSID:#WORKGCODE=#G5403CODE
%IF #COORDNUM=4 %THEN #G5404=#SYSID:#WORKGCODE=#G5404CODE
%IF #COORDNUM=5 %THEN #G5405=#SYSID:#WORKGCODE=#G5405CODE
%IF #COORDNUM=6 %THEN #G5406=#SYSID:#WORKGCODE=#G5406CODE
%IF #COORDNUM=7 %THEN #G5407=#SYSID:#WORKGCODE=#G5407CODE
%IF #COORDNUM=8 %THEN #G5408=#SYSID:#WORKGCODE=#G5408CODE
%IF #COORDNUM=9 %THEN #G5409=#SYSID:#WORKGCODE=#G5409CODE
%IF #COORDNUM=10 %THEN #G5410=#SYSID:#WORKGCODE=#G5410CODE
%IF #COORDNUM=11 %THEN #G5411=#SYSID:#WORKGCODE=#G5411CODE
%IF #COORDNUM=12 %THEN #G5412=#SYSID:#WORKGCODE=#G5412CODE
%IF #COORDNUM=13 %THEN #G5413=#SYSID:#WORKGCODE=#G5413CODE
%IF #COORDNUM=14 %THEN #G5414=#SYSID:#WORKGCODE=#G5414CODE
%IF #COORDNUM=15 %THEN #G5415=#SYSID:#WORKGCODE=#G5415CODE
%IF #COORDNUM=16 %THEN #G5416=#SYSID:#WORKGCODE=#G5416CODE
%IF #COORDNUM=17 %THEN #G5417=#SYSID:#WORKGCODE=#G5417CODE
%IF #COORDNUM=18 %THEN #G5418=#SYSID:#WORKGCODE=#G5418CODE
%IF #COORDNUM=19 %THEN #G5419=#SYSID:#WORKGCODE=#G5419CODE
%IF #COORDNUM=20 %THEN #G5420=#SYSID:#WORKGCODE=#G5420CODE


%IF #COORDNUM=21 %THEN $WARNING="Warning - Too Many Work Co-ordinate Systems programmed":%CALL=CODECON_WARNING
%IF #COORDNUM=21 %THEN $WARNING="          Remaining Co-ordinate Systems will be output as incremental":%CALL=CODECON_WARNING:%GOTO @END

*	Option to output first Datum (G54) as XYZHOME location
%IF #COORDNUM=1 %THEN %CALL=PT_OUTPUT_G54_TO_TABLE_CENTRE



#XSUB=XSUB:#YSUB=YSUB:#ZSUB=ZSUB


%CALL=CODECON_SET-WORK-DATUMS

#COORDNUM=#COORDNUM+1

%GOTO @STARTLOOP
@END

#LOOP=1
%GETCPL=#LOOP
$CPLNAME=GROUPDESCRIPTION
%CALL=PT_ABS_DATUM_RECALL
%CALL=DATUM_HOLD

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                      Ŀ
;Ĵ Procedure = PT_ABS_DATUM_RECALL_20      
;                                      
%PROCEDURE=PT_ABS_DATUM_RECALL_20                                          ; Make Datum unique by XYZ and Rotation
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ABS_DATUM_RECALL_20:%CALL=ENTER_PROCEDURE

#WORKGCODE=#FUNNY
#SYSID=SYSID*1000000:%IF #UNIQUEDATUMS=#TRUE %THEN #SYSID=(#SYSID+(ROT1*1000)+ROT2)
%IF #SYSID=#G5401 %THEN #WORKGCODE=#G5401CODE
%IF #SYSID=#G5402 %THEN #WORKGCODE=#G5402CODE
%IF #SYSID=#G5403 %THEN #WORKGCODE=#G5403CODE
%IF #SYSID=#G5404 %THEN #WORKGCODE=#G5404CODE
%IF #SYSID=#G5405 %THEN #WORKGCODE=#G5405CODE
%IF #SYSID=#G5406 %THEN #WORKGCODE=#G5406CODE
%IF #SYSID=#G5407 %THEN #WORKGCODE=#G5407CODE
%IF #SYSID=#G5408 %THEN #WORKGCODE=#G5408CODE
%IF #SYSID=#G5409 %THEN #WORKGCODE=#G5409CODE
%IF #SYSID=#G5410 %THEN #WORKGCODE=#G5410CODE
%IF #SYSID=#G5411 %THEN #WORKGCODE=#G5411CODE
%IF #SYSID=#G5412 %THEN #WORKGCODE=#G5412CODE
%IF #SYSID=#G5413 %THEN #WORKGCODE=#G5413CODE
%IF #SYSID=#G5414 %THEN #WORKGCODE=#G5414CODE
%IF #SYSID=#G5415 %THEN #WORKGCODE=#G5415CODE
%IF #SYSID=#G5416 %THEN #WORKGCODE=#G5416CODE
%IF #SYSID=#G5417 %THEN #WORKGCODE=#G5417CODE
%IF #SYSID=#G5418 %THEN #WORKGCODE=#G5418CODE
%IF #SYSID=#G5419 %THEN #WORKGCODE=#G5419CODE
%IF #SYSID=#G5420 %THEN #WORKGCODE=#G5420CODE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                      Ŀ
;Ĵ Procedure = SELECT_WORK_DATUMS	  
;                                      
%PROCEDURE=SELECT_WORK_DATUMS
%IF #PROCTRACE=1 %THEN $PROCEDURE=SELECT_WORK_DATUMS:%CALL=ENTER_PROCEDURE

$CPLNAME=GROUPDESCRIPTION
* Set CPL offset for moves to Home and TC
#XTOOLREF=XSUB
#YTOOLREF=YSUB
#ZTOOLREF=ZSUB

#PRESETGCODE=#FUNNY
#XSUB=#FUNNY:#YSUB=#FUNNY:#ZSUB=#FUNNY
#XMOVE=XSUB:#YMOVE=YSUB:#ZMOVE=ZSUB
#TMP=#WORKGCODE
%CALL=PT_ABS_DATUM_RECALL
%CALL=UPDATE_OFFSET_REGISTERS
%IF #WORKGCODE<>#FUNNY %THEN #XSUB=XSUB:#YSUB=YSUB:#ZSUB=ZSUB:#XMOVE=#FUNNY:#YMOVE=#FUNNY:#ZMOVE=#FUNNY %ELSE #WORKGCODE=#TMP:#PRESETGCODE=DATA1(23)
%CALL=CODECON_SELECT-WORK-DATUMS
@END

* Save CPL ID
#CURRENTCPL=SUBFUNCT

%CALL=DATUM_HOLD
;%CANCEL=#XMOVE,#YMOVE,#ZMOVE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                      Ŀ
;Ĵ Procedure = UPDATE_OFFSET_REGISTERS
;                                      
%PROCEDURE=UPDATE_OFFSET_REGISTERS
%IF #PROCTRACE=1 %THEN $PROCEDURE=UPDATE_OFFSET_REGISTERS:%CALL=ENTER_PROCEDURE

#XMOVE=#XMOVE-#XABSORIGINHOLD
#YMOVE=#YMOVE-#YABSORIGINHOLD
#ZMOVE=#ZMOVE-#ZABSORIGINHOLD
#XMOVE=#XHOLD-#XMOVE
#YMOVE=#YHOLD-#YMOVE
#ZMOVE=#ZHOLD-#ZMOVE
#XHOLD=#XMOVE
#YHOLD=#YMOVE
#ZHOLD=#ZMOVE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_ABS_DATUM_RECALL                                          ; Make Datum unique by XYZ and Rotation
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ABS_DATUM_RECALL:%CALL=ENTER_PROCEDURE

* ECS27xx uses 20 settings
%IF $MACHINE="ECS2700" %THEN %CALL=PT_ABS_DATUM_RECALL_20
%IF $MACHINE="ECS2700" @END

#WORKGCODE=#FUNNY
#SYSID=SYSID*1000000:%IF #UNIQUEDATUMS=#TRUE %THEN #SYSID=(#SYSID+(ROT1*1000)+ROT2)
%IF #SYSID=#G54 %THEN #WORKGCODE=DATA1(25)
%IF #SYSID=#G55 %THEN #WORKGCODE=DATA1(26)
%IF #SYSID=#G56 %THEN #WORKGCODE=DATA1(27)
%IF #SYSID=#G57 %THEN #WORKGCODE=DATA1(28)
%IF #SYSID=#G58 %THEN #WORKGCODE=DATA1(29)
%IF #SYSID=#G59 %THEN #WORKGCODE=DATA1(30)

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                      Ŀ
;Ĵ Procedure = HOLD                 
;                                      
%PROCEDURE=HOLD
%IF #PROCTRACE=1 %THEN $PROCEDURE=HOLD:%CALL=ENTER_PROCEDURE
* %IF MASK=1 @END
%IF #INCRXYZ=#FALSE @ABSOLUTE_XYZ
#XMOVE=#XSTOREABS:#YMOVE=#YSTOREABS:#ZMOVE=#ZSTOREABS		;	 Retrieve current absolute position
@ABSOLUTE_XYZ

;#XHOLD=#XMOVE:#YHOLD=#YMOVE:#ZHOLD=#ZMOVE
%IF #XMOVE<>#FUNNY %THEN #XHOLD=#XMOVE


%IF #YMOVE<>#FUNNY %THEN #YHOLD=#YMOVE
%IF #HOLECYCLE=#TRUE @HOLES

%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE
%IF #SKIPROT=#TRUE @END
%IF MASK<>1 %THEN #ROT1HOLD=ROT1:#ROT2HOLD=ROT2
%GOTO @END

@HOLES
%IF #SKIPROT=#TRUE @END
%IF $PLANAR=YES @END
*  Rot1/Rot2 are not set from drill array
%IF $ACTIVEROTAXIS=$ROT1 %THEN #ROT1HOLD=YPOINT(#LOOP) %ELSE #ROT2HOLD=YPOINT(#LOOP)

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_INCREMENTAL_XYZ
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_INCREMENTAL_XYZ:%CALL=ENTER_PROCEDURE

* Set Move for XYZ
#MOVE=0
%IF #XMOVE<>#XHOLD %THEN #MOVE=#MOVE+1
%IF #YMOVE<>#YHOLD %THEN #MOVE=#MOVE+2
%IF #ZMOVE<>#ZHOLD %THEN #MOVE=#MOVE+4


#XMOVE=#XMOVE-#XHOLD:#YMOVE=#YMOVE-#YHOLD:#ZMOVE=#ZMOVE-#ZHOLD
%IF #XMOVE=0 %THEN #XMOVE=#FUNNY							;	Supress zero X move
%IF #YMOVE=0 %THEN #YMOVE=#FUNNY							;	Supress zero X move
%IF #ZMOVE=0 %THEN #ZMOVE=#FUNNY							;	Supress zero X move
%CANCEL=#XMOVE,#YMOVE,#ZMOVE		;	Nescessary else incremental motion will be suppressed e.g.  X10, X10 (drilling)

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
%PROCEDURE=PT_CHECK_AXIS_REVERSE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CHECK_AXIS_REVERSE:%CALL=ENTER_PROCEDURE

%IF #XREVERSE=#TRUE %THEN #AXISREVERSE=#TRUE
%IF #YREVERSE=#TRUE %THEN #AXISREVERSE=#TRUE
%IF #ZREVERSE=#TRUE %THEN #AXISREVERSE=#TRUE

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*
%PROCEDURE=PT_REVERSE_XYZ
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_REVERSE_XYZ:%CALL=ENTER_PROCEDURE
%IF #XREVERSE=#TRUE %THEN #XMOVE=#XMOVE*-1:#IVALUE=#IVALUE*-1:#XCENTRE=#XCENTRE*-1
%IF #YREVERSE=#TRUE %THEN #YMOVE=#YMOVE*-1:#JVALUE=#JVALUE*-1:#YCENTRE=#YCENTRE*-1
%IF #ZREVERSE=#TRUE %THEN #ZMOVE=#ZMOVE*-1:#KVALUE=#KVALUE*-1:#ZCENTRE=#ZCENTRE*-1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
%PROCEDURE=PT_SET_PRECISION
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SET_PRECISION:%CALL=ENTER_PROCEDURE

* Round XYZ here for true storeabs position
%IF #XMOVE=#FUNNY @NO-X
#XMOVE=(#XMOVE*#PRECISION)+0.5
#XMOVE=INT(#XMOVE)
#XMOVE=#XMOVE/#PRECISION
@NO-X

%IF #YMOVE=#FUNNY @NO-Y
#YMOVE=(#YMOVE*#PRECISION)+0.5
#YMOVE=INT(#YMOVE)
#YMOVE=#YMOVE/#PRECISION
@NO-Y

%IF #ZMOVE=#FUNNY @NO-Z
#ZMOVE=(#ZMOVE*#PRECISION)+0.5
#ZMOVE=INT(#ZMOVE)
#ZMOVE=#ZMOVE/#PRECISION
@NO-Z

#XSTOREABS=#XMOVE:#YSTOREABS=#YMOVE:#ZSTOREABS=#ZMOVE		;	Store absolute current, position
%IF #HOLECYCLE=1 %THEN #ZSTOREABS=ZCLEAR ; Hole cycle starts and ends at clearance

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_COMPENSATE_TLO
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_COMPENSATE_TLO:%CALL=ENTER_PROCEDURE

* Do not adjust XY arcs, Z is unchanged from previous move
%IF XYPLANE<>0 @ADJUST
%IF #MACRO=53 @END
%IF #MACRO=54 @END
*
@ADJUST
%IF #ADJZMOVE=#FUNNY %THEN #ADJZMOVE=0
#ZMOVE=#ZMOVE+#ADJZMOVE
%IF XYPLANE=0 @END
%IF #ARCTYPE=4 %THEN #KVALUE=#KVALUE+#ADJZMOVE
@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
%PROCEDURE=PT_CALC_VECTOR_DISTANCE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CALC_VECTOR_DISTANCE:%CALL=ENTER_PROCEDURE

*	Calculate vector distance from current to next coordinate
*   Use to determine if rapid move should be converted to feedrate move
*
*	XY distance
#XINC=#XMOVE-#XHOLD:#YINC=#YMOVE-#YHOLD:#ZINC=#ZMOVE-#ZHOLD
#ABSXINC=ABS(#XINC):#ABSYINC=ABS(#YINC)
#ABSXINC=#ABSXINC^2:#ABSYINC=#ABSYINC^2:#TMP=#ABSXINC+#ABSYINC:#TMP=SQR(#TMP):#XINC=#TMP	; Store XY distance
*	3D distance i.e. incorporate Z axis
#ZINC=#ZMOVE-#ZHOLD:#ABSZINC=ABS(#ZINC)
#ABSZINC=#ABSZINC^2:#XINC=#XINC^2:#TMP=#XINC+#ABSZINC:#TMP=SQR(#TMP)


*	If move is smaller than the specified amount then convert to a feedrate at highfeed.
%IF #TMP<=#RAPDIST %THEN #GCODE=DATA1(2):#FEED=#RAPIDFEEDRATE %ELSE #GCODE=DATA1(1):#FEED=#FUNNY	;	#TMP is vector distance returned

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = MILLHEADER           
;                                      
%PROCEDURE=SET_UP_SHEET
%IF #PROCTRACE=1 %THEN $PROCEDURE=SET_UP_SHEET:%CALL=ENTER_PROCEDURE

*	#TOOLSHEET	1=Output with Main NC program	2=Output as seperate file	3=None
%OUTPUT=STANDARD
%IF #TOOLSHEET=1 @OUTPUT_WITH_NC_CODE
APPEND=1:%OUTPUT=$NAME

@OUTPUT_WITH_NC_CODE

%CALL=CODECON_SET-UP-SHEET

%OUTPUT=STANDARD

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = NOMOTION             
;                                      
%PROCEDURE=NOMOTION
%IF #PROCTRACE=1 %THEN $PROCEDURE=NOMOTION:%CALL=ENTER_PROCEDURE

%IF #INCRXYZ=#TRUE @ROT ;XYZ check in PT_INCREMENTAL_XYZ
* Precision calcs moved to PT_SET_PRECISION

#MOVE=0
%IF #XMOVE=#FUNNY @NOX
%IF #XMOVE<>#XHOLD %THEN #MOVE=#MOVE+1
@NOX
%IF #YMOVE=#FUNNY @NOY
%IF #YMOVE<>#YHOLD %THEN #MOVE=#MOVE+2
@NOY
%IF #ZMOVE=#FUNNY @NOZ
%IF #ZMOVE<>#ZHOLD %THEN #MOVE=#MOVE+4
@NOZ

@ROT
@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM



;                                      Ŀ
;Ĵ FIND_PRECISION                   
;                                      
%PROCEDURE=FIND_PRECISION
%IF #PROCTRACE=1 %THEN $PROCEDURE=FIND_PRECISION:%CALL=ENTER_PROCEDURE

#PRECISION=1
#TMP=#INCR
@LOOP
%IF #TMP=>1 @END
#PRECISION=#PRECISION*10
#TMP=#TMP*10
%GOTO @LOOP
@END
*<* #PRECISION=[#PRECISION=!FT_DEBUGREAL] PRECISION=[PRECISION=!FT_DEBUGREAL] #INCR=[#INCR=!FT_DEBUGREAL]>

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ Procedure = PT_ARC_CENTRE        
;                                      
;
%PROCEDURE=PT_ARC_CENTRE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_ARC_CENTRE:%CALL=ENTER_PROCEDURE

*	Determines the method of fixing arc centre
*	NOTE!  Thread Milling uses %PROCEDURE=PT_THRD_ARC_CENTRE for simplicity
*
*	Setvar^#ARCTYPE
*						Signed Start to Centre	1
*						Signed Centre to start	2
*						Unsigned Start / Centre	3
*						Centre					4
*
*	Setvar^#USERADS^Use Radius when possible
*						TRUE / FALSE		Sets #OUTPUTRADS=#TRUE as default, re-assigned FALSE if I&J forced by logic e.g. 360 degrees move

#XCENTRE=(XCENTRE*#PRECISION)+0.5
#XCENTRE=INT(#XCENTRE)
#XCENTRE=#XCENTRE/#PRECISION
#XSTART=(XSTART*#PRECISION)+0.5
#XSTART=INT(#XSTART)
#XSTART=#XSTART/#PRECISION
#IVALUE=#XCENTRE-#XSTART

#YCENTRE=(YCENTRE*#PRECISION)+0.5
#YCENTRE=INT(#YCENTRE)
#YCENTRE=#YCENTRE/#PRECISION
#YSTART=(YSTART*#PRECISION)+0.5
#YSTART=INT(#YSTART)
#YSTART=#YSTART/#PRECISION
#JVALUE=#YCENTRE-#YSTART

#ZCENTRE=(ZCENTRE*#PRECISION)+0.5
#ZCENTRE=INT(#ZCENTRE)
#ZCENTRE=#ZCENTRE/#PRECISION
#ZSTART=(ZSTART*#PRECISION)+0.5
#ZSTART=INT(#ZSTART)
#ZSTART=#ZSTART/#PRECISION
#KVALUE=#ZCENTRE-#ZSTART

* This removed to set IJK for instances when R cannot be used
*%IF #OUTPUTRADS=#TRUE @END						;	Use radius output

%IF #ARCTYPE=1 @END																				;	Signed Start to Centre
%IF #ARCTYPE=2 %THEN #IVALUE=-1*#IVALUE:#JVALUE=-1*#JVALUE:#KVALUE=-1*#KVALUE:					;	Signed Centre to start (reverse of type 1)
%IF #ARCTYPE=3 %THEN #IVALUE=ABS(#IVALUE):#JVALUE=ABS(#JVALUE):#KVALUE=ABS(#KVALUE)         	;	Unsigned Start / Centre
%IF #ARCTYPE=4 %THEN #IVALUE=#XCENTRE:#JVALUE=#YCENTRE:#KVALUE=#ZCENTRE							;	Centre

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
;                                      Ŀ
;Ĵ  Procedure = ARC_TO_LINE         
;                                      
%PROCEDURE=ARC_TO_LINE
%IF #PROCTRACE=1 %THEN $PROCEDURE=ARC_TO_LINE:%CALL=ENTER_PROCEDURE

* procedure is used when a large arc needs to be ignored. output move to end of
* arc
#GCODE=DATA1(2)
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%CALL=PT_OUTPUT_FEED

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*							*********************
*							*	Thread Milling	*
*							*********************
*
*
%PROCEDURE=PT_THRD_MOVE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_THRD_MOVE:%CALL=ENTER_PROCEDURE
%IF XPOINT(#LOOP)=0 %THEN #GCODE=DATA1(1) %ELSE #GCODE=DATA1(2)
#FEED=YPOINT(#LOOP)
#LOOP=#LOOP+1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP):#ZMOVE=RADIUS(#LOOP)

* Next Z for first move
%IF #TOOLCHANGE=0 @SECOND
#TEMP=#LOOP+2
NEXTZMOVE=RADIUS(#TEMP)
#ZMOVE=NEXTZMOVE

@SECOND
* Set canned cycle variables
#HELIXCOUNT=0
%IF #THRDSTARTZ=#FUNNY %THEN #THRDPLUNGE=#ZMOVE
%IF #THRDCLEAR=#FUNNY %THEN #THRDCLEAR=#ZHOLD
%IF #THRDPOSFEED=#FUNNY %THEN #THRDPOSFEED=#FEED
#THRDX=#XMOVE
#THRDY=#YMOVE
*
$MOVETYPE=MOVE
%IF #XHOLD<>#XMOVE @NOT-PLUNGE1
%IF #YHOLD<>#YMOVE @NOT-PLUNGE1
* <Vertical Move>
#OUTPUTPOINT=1
#THRDXPLUNGE=#THRDX
#THRDYPLUNGE=#THRDY
*  %IF #ZMOVE<#ZHOLD %THEN <PLUNGE> %ELSE <LIFT>
$MOVETYPE=PLUNGE
#COMPON=0
#THREADMOVE=0

%IF USERVAR8=1 @NOBLOCK
%IF #GCODE=DATA1(1) %THEN %CALL=PT_OUTPUT_RAPID %ELSE %CALL=PT_OUTPUT_FEED
%GOTO @NOBLOCK


@NOT-PLUNGE1
* <Not PL>
* %IF USERVAR8=1 @NOBLOCK
%IF #GCODE=DATA1(2) @FEED
* <Rapid  XY>
%CALL=PT_OUTPUT_RAPID
%GOTO @NOBLOCK

@FEED
* <Feed Move XY>
#COMPGCODE=#THRDCOMPCODE
#THREADMOVE=1
%IF #LOOP=LAST %THEN #THREADMOVE=2
#NEXTLOOP=#LOOP+1
#NEXTTYPE=XPOINT(#NEXTLOOP)
%IF #NEXTTYPE=0 %THEN #THREADMOVE=2 ; G01 followed by G00
%IF USERVAR8=0 %THEN %CALL=PT_OUTPUT_FEED

@NOBLOCK
%IF $MOVETYPE<>PLUNGE @NOT-PLUNGE2
#COMPON=#COMPCYCLE
%IF #COMPON=0 @NOT-PLUNGE2
#THREADMOVE=1
$COMPOUTPUT=FALSE

@NOT-PLUNGE2
#LOOP=#LOOP+1

%IF USERVAR8=1 %THEN #XHOLD=#XMOVE:#YHOLD=#YMOVE:#ZHOLD=#ZMOVE
#ZLINEAR=#ZMOVE
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*


%PROCEDURE=PT_THRD_ARC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_THRD_ARC:%CALL=ENTER_PROCEDURE

%IF XPOINT(#LOOP)=2 %THEN #GCODE=DATA1(3) %ELSE #GCODE=DATA1(4)	; G02 or G03
#COMPGCODE=#THRDCOMPCODE
%CANCEL=#GCODE
#FEED=YPOINT(#LOOP)
#LOOP=#LOOP+1
#XCENTRE=XPOINT(#LOOP):#YCENTRE=YPOINT(#LOOP):#RADIUS=RADIUS(#LOOP)
#KVALUE=#FUNNY:		;Suppress output of this variables
#LOOP=#LOOP+1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)

%CALL=PT_THRD_ARC_CENTRE			;	Select Arc centre method - I&J will be forced
%IF #LOOP=LAST %THEN #THREADMOVE=2
%IF $COMPOUTPUT=FALSE %THEN %CALL=CRC_HANDLER

%IF USERVAR8=1 @NOBLOCK
%CALL=PT_OUTPUT_ARC
@NOBLOCK

#LOOP=#LOOP+1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*

%PROCEDURE=PT_THRD_ARC_HELICAL
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_THRD_ARC_HELICAL:%CALL=ENTER_PROCEDURE

#COMPGCODE=#THRDCOMPCODE

* Are all helical blocks required
%IF USERVAR8=1 %THEN #THREADSINGLE=1
%IF #THREADSINGLE<>1 %THEN #OUTPUTHELIX=1:%GOTO @CONTINUE

* Output leads & one main helical block only, Find last main helix block
* ZMOVE = Total Movement, KVALUE = Lead
#HELIXCOUNT=#HELIXCOUNT+1
#OUTPUTHELIX=0
#TYPE=XPOINT(#LOOP)
#THISRAD=#LOOP+3
#THISRAD=XPOINT(#THISRAD)
#NEXTLOOP=#LOOP+4
#NEXTTYPE=XPOINT(#NEXTLOOP)
%IF #NEXTTYPE<4 @OUTPUT
#NEXTRADIUS=#NEXTLOOP+3
#NEXTRADIUS=XPOINT(#NEXTRADIUS)
%IF #STARTRAD=#FUNNY %THEN #STARTRAD=#ARCRADIUS
%IF #THISRAD=#FUNNY @OUTPUT

%IF #NEXTRADIUS<>#THISRAD @CHANGE ;Arc rad change
%IF #TYPE<>#NEXTTYPE @CHANGE ;Arc direction change
%GOTO @CONTINUE

@CHANGE
* Suppress first main helix, uless it is also the last
%IF #THISRAD<>#NEXTRADIUS @OUTPUT
%IF #TYPE<>#NEXTTYPE @OUTPUT
%GOTO @CONTINUE

@OUTPUT
#OUTPUTHELIX=1 ; Set to 1 when output block required
%IF USERVAR8=0 @CONTINUE
* Canned Cycles only
%IF #HELIXCOUNT=1 @FIRSTHELIX
* <Not First>
#OUTPUTCYCLE=1
%GOTO @CONTINUE

@FIRSTHELIX
* <Next [#NEXTTYPE=1]>
#OUTPUTCYCLE=0
%IF #NEXTTYPE=4 @CONTINUE
%IF #NEXTTYPE=5 @CONTINUE
* Only 1 helix
#OUTPUTCYCLE=1


@CONTINUE
%IF XPOINT(#LOOP)=4 %THEN #GCODE=DATA1(3) %ELSE #GCODE=DATA1(4)
#FEED=YPOINT(#LOOP)
#LOOP=#LOOP+1
#XCENTRE=XPOINT(#LOOP):#YCENTRE=YPOINT(#LOOP)
#LOOP=#LOOP+1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP):#ZMOVE=RADIUS(#LOOP)
%IF #ZREVERSE=1 %THEN #KVALUE=#ZMOVE-(#ZHOLD*-1) %ELSE #KVALUE=#ZMOVE-#ZHOLD

* #THRDLEAD=#KVALSAVE ; Lead of thread, Z move of last helical block
#KVALSAVE=#KVALUE ; Save KVALUE
#THRDLEAD=#ZMOVE-#ZHOLD

#LOOP=#LOOP+1
#STARTRAD=XPOINT(#LOOP):#ENDRAD=YPOINT(#LOOP)

%IF #STARTRAD=#ENDRAD @NOTAPER
* Helix inaccurate for Taper thread
%IF #TAPERWARN=0 @NOTAPER
$WARNING="Warning - Helix for taper threading may be inaccurate":%CALL=CODECON_WARNING
@NOTAPER

*
* Extract canned cycle parameters
#THRDARCDIR=#GCODE
%IF #THRDLEAD<0 @DOWNCUT

* Cutting upwards
%IF #THRDENDZ=#FUNNY %THEN #THRDENDZ=#ZHOLD ; Start of first helix
#THRDPLUNGE=5

%GOTO @UPDOWN

@DOWNCUT
* Cutting Down
%IF #THRDPLUNGE=#FUNNY %THEN #THRDPLUNGE=#ZHOLD+5
#THRDENDZ=#ZMOVE ; End height last helix

@UPDOWN
#THRDFEED=#FEED
#PLUNGERAD=(#THRDXPLUNGE-#XCENTRE)*(#THRDXPLUNGE-#XCENTRE)
#PLUNGERAD=#PLUNGERAD+((#THRDYPLUNGE-#YCENTRE)*(#THRDYPLUNGE-#YCENTRE))
#PLUNGERAD=SQR(#PLUNGERAD)
* <INOUT #PLUNGERAD=[#PLUNGERAD=0] #STARTRAD=[#STARTRAD=0]>
#THRDINOUT=#THRDINCODE
%IF #PLUNGERAD>#STARTRAD %THEN #THRDINOUT=#THRDOUTCODE
%IF #HELIXCOUNT>2 @DIAFIXED
#THREADDIA=(#THISRAD+TOOLRAD)*2
%IF #PLUNGERAD>#STARTRAD %THEN #THREADDIA=(#THISRAD-TOOLRAD)*2
@DIAFIXED
*

%CANCEL=#XMOVE,#YMOVE,#ZMOVE,#GCODE

%CALL=PT_THRD_ARC_CENTRE			;	Select Arc centre method - I&J will be forced
%IF #LOOP=LAST %THEN #THREADMOVE=2

%IF $COMPOUTPUT=FALSE %THEN %CALL=CRC_HANDLER

%IF USERVAR8=0 @CONTINUE2
%IF #OUTPUTCYCLE=0 @CONTINUE2

* Canned cycle output
#MODALCYCLE=DATA2(48)
%CANCEL=#MODALCYCLE
#XMOVE=#XCENTRE
#YMOVE=#YCENTRE

%IF #CYCOUT>0 @COUNT
%CALL=CODECON_THREAD_CYCLE
@COUNT
%IF #OUTPUTPOINT=0 @CONTINUE2
#ZMOVE=#FUNNY
%CALL=CODECON_HOLE-CYCLEPOINTS
#OUTPUTPOINT=0
#CYCOUT=1

@CONTINUE2
* Count arc blocks skipped
%IF #OUTPUTHELIX=0 %THEN #BLOCKSMISSED=#BLOCKSMISSED+1
*Suppress intermediate helical blocks if instructed. Maintain #ZHOLD
%IF #OUTPUTHELIX=0 %THEN #ZHOLD=#ZMOVE:%GOTO @SKIP
*Set K word to full circle pitch for multi-pass block
%IF #BLOCKSMISSED=0 @OUTPUT2
#KVALUE=#THRDLEAD

@OUTPUT2
%IF USERVAR8=0 %THEN %CALL=PT_OUTPUT_ARC
* reset helical block count
#BLOCKSMISSED=0

@SKIP


#LOOP=#LOOP+1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_THRD_ARC_CENTRE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_THRD_ARC_CENTRE:%CALL=ENTER_PROCEDURE

*	Handle Arc centre for Thread milling - force I&J output
*	Setvar^#ARCTYPE
*						Signed Start to Centre	1
*						Signed Centre to start	2
*						Unsigned Start / Centre	3
*						Centre					4
*
*	Setvar^#USERADS^Use Radius when possible
*						TRUE / FALSE		Sets #OUTPUTRADS=#TRUE as default, re-assigned FALSE if I&J forced by logic e.g. 360 degrees move

#IVALUE=#XCENTRE-#XHOLD
%IF #XREVERSE=1 %THEN #IVALUE=#XCENTRE+#XHOLD
#JVALUE=#YCENTRE-#YHOLD
%IF #YREVERSE=1 %THEN #JVALUE=#YCENTRE+#YHOLD

#ARCRADIUS=#RADIUS
#RADIUS=#FUNNY				;Always assumes IJK method of arc output

%IF #ARCTYPE=1 @END																				;	Signed Start to Centre
%IF #ARCTYPE=2 %THEN #IVALUE=-1*#IVALUE:#JVALUE=-1*#JVALUE:#KVALUE=-1*#KVALUE:					;	Signed Centre to start (reverse of type 1)
%IF #ARCTYPE=3 %THEN #IVALUE=ABS(#IVALUE):#JVALUE=ABS(#JVALUE):#KVALUE=ABS(#KVALUE)         	;	Unsigned Start / Centre
%IF #ARCTYPE=4 %THEN #IVALUE=#XCENTRE:#JVALUE=#YCENTRE							;	Centre
@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

*
%PROCEDURE=PT_SKIP_RECORD
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SKIP_RECORD:%CALL=ENTER_PROCEDURE

* This procedure is called when an unknown move type is detected and
* the record is skipped.

#SKIP=RADIUS(#LOOP)
* #RECORD=XPOINT(#LOOP)
#LOOP=#LOOP+#SKIP:#LOOP=#LOOP+1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*							*******************
*							Block No. Increment
*							*******************
*
%PROCEDURE=PT_BINC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_BINC:%CALL=ENTER_PROCEDURE

;				Use Block numbers					(#USEBNUM=#TRUE)
;				Block No. Start						(#BNUM)
;				Block Number increment				(#BNUMINC)
;				Only Safe block numbers 			(#ONLYSBNUM=#TRUE)
;
%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC
%IF #USEBNUM>0 %THEN #BNUM=+#BNUMVAR
*
* Check top limit, reset if exceeded
%IF #USEBNUM=1 @END ; Reset not required
%IF #BNUM>#USEBNUM %THEN #BNUM=#BNUMINC
*
@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*							******************************
*							Safe Start Block No. Increment
*							******************************
*
%PROCEDURE=PT_SBINC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SBINC:%CALL=ENTER_PROCEDURE

*If #ONLYSBNUM=#TRUE then increment SBNUM only, NOT BNUM - update SBNUM with current if both
%IF #ONLYSBNUM=#TRUE %THEN #SBNUM=#SBNUM+#BNUMVAR %ELSE #BNUM=+#BNUMVAR:#SBNUM=#BNUM
*	Output Block Number same as Tool Number (POSITION)
%IF #SBNUMPOSITION=#TRUE %THEN #SBNUM=POSITION

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*							********************************
*									Set Tooling data
*							********************************
*
%PROCEDURE=PT_SET_TOOL_DATA
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SET_TOOL_DATA:%CALL=ENTER_PROCEDURE

#LOOP=1
@LOOPS
%LOAD=#LOOP:%IF #LOOP>NUMTOOLS @ELOOP

%CALL=CODECON_SET-TOOLING-DATA
#LOOP=#LOOP+1:%GOTO @LOOPS
@ELOOP

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
*		            		*************************************
*									Subroutine Start / Header
*							*************************************
*
*  Note  #incrxyz is current abs/inc setting
*        #incrxyzhold is main program setting
*        #incrsubs is subroutine setting

%PROCEDURE=PT_OUTPUT_SUBSTART
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_SUBSTART:%CALL=ENTER_PROCEDURE

%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC
STARTSUB=#BNUM+#BNUMVAR

%IF MASK=1 %THEN %GOTO @SKIP
%IF #RESTARTSUBSBNUM=#TRUE %THEN #BNUMHOLD=#BNUM:#BNUM=0			;	Restart Block numbering for Subprograms

*	If Increment Subroutines by ... is not set then start at Progid & increment by one else use the increment.
%IF #INCRSUBNUMBER=#FUNNY %THEN #SUBROUTINE=SUBROUTINE+#SUBNOSTART %ELSE #SUBROUTINE=(SUBROUTINE*#INCRSUBNUMBER)+#SUBNOSTART

* Force feedrate if required
%IF #FORCEFEED=1 %THEN %CANCEL=#FEED

*Reset HOLD values for incremental first move
#XHOLD=NEXTXMOVE
#YHOLD=NEXTYMOVE
#ZHOLD=NEXTZMOVE

*	If using incremental subroutines only, it is necessary to hardcode a G91 on extra Sequence definition line
%IF #INCRXYZHOLD=#TRUE @MAIN_PROG_IS_INCREMENTAL
%IF #INCRSUBS=#TRUE %THEN #INCRXYZ=#TRUE	; Set subs to incr if specified
#SPEEDUP=#INCRXYZ+#TLOCOMP+#XREVERSE+#YREVERSE+#ZREVERSE  ;Recalculate shortcut flag
@MAIN_PROG_IS_INCREMENTAL
%IF #INCRXYZ=#TRUE %THEN #ABSINC=DATA1(48) %ELSE #ABSINC=DATA1(47)

%CALL=CODECON_SUBROUTINE-START
* Force GCode on next move
%CANCEL=#GCODE

@SKIP

* Default holecycle flag to zero
UARRAY1(SUBROUTINE)=0

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
*		            		********************************
*									Subroutine Call
*							********************************
*
%PROCEDURE=PT_OUTPUT_SUBCALL
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_SUBCALL:%CALL=ENTER_PROCEDURE

*	If Increment Subroutines by ... is not set then start at Progid & increment by one else use the increment.
%IF #INCRSUBNUMBER=#FUNNY %THEN #SUBROUTINE=SUBROUTINE+#SUBNOSTART %ELSE #SUBROUTINE=(SUBROUTINE*#INCRSUBNUMBER)+#SUBNOSTART

%IF MASK=1 @SKIP
%IF #MACRO=32 @SKIP; Translate
%IF #MACRO=35 @SKIP; Repeat Machining

*Check for hole cyclesub, retrieve stored value
#HOLECYCLE2=UARRAY1(SUBROUTINE)
%IF #HOLECYCLE2=0 @CONTINUE

*Suppress single location cycle, xcept for Heidenhain
%IF $MACHINE="HEIDENHAIN" @SKIP
%IF LAST<2 @END
%GOTO @SKIP

*Output approach move for first call, not translated calls
@CONTINUE
#XMOVE=NEXTXMOVE
#YMOVE=NEXTYMOVE
#ZMOVE=NEXTZMOVE
#FEED=NEXTXYFEED

* Force output if coordinate has changed
* Found to be necessary for some templates, inculding S840
%IF #MACRO<>59 @SKIP59
%IF #XMOVE<>#XHOLD %THEN %CANCEL=#XMOVE
%IF #YMOVE<>#YHOLD %THEN %CANCEL=#YMOVE
%IF #ZMOVE<>#ZHOLD %THEN %CANCEL=#ZMOVE
@SKIP59

%IF #INCRSUBS=0 @SKIP
* Inserted move, only for incremental subroutines
%CALL=PT_OUTPUT_FEED


@SKIP

%CANCEL=STARTSUB,ENDSUB
%CALL=CODECON_SUBROUTINE-CALL

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
*		            		********************************
*									Subroutine End
*							********************************
*
%PROCEDURE=PT_OUTPUT_SUBEND
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_SUBEND:%CALL=ENTER_PROCEDURE

*	If Increment Subroutines by ... is not set then start at Progid & increment by one else use the increment.
%IF #INCRSUBNUMBER=#FUNNY %THEN #SUBROUTINE=SUBROUTINE+#SUBNOSTART %ELSE #SUBROUTINE=(SUBROUTINE*#INCRSUBNUMBER)+#SUBNOSTART

%IF MASK=1 %THEN %GOTO @SKIP
*	If using incremental subroutines only, it is nescessary to hardcode a G90 on extra Sequence definition line

%IF #INCRXYZHOLD=#TRUE %THEN #ABSINC=DATA1(48) %ELSE #ABSINC=DATA1(47)

%CALL=CODECON_SUBROUTINE-END

%IF #INCRXYZHOLD=#TRUE %THEN #INCRXYZ=#TRUE %ELSE #INCRXYZ=#FALSE	;	Reset main program to original abs/incr state
#SPEEDUP=#INCRXYZ+#TLOCOMP+#XREVERSE+#YREVERSE+#ZREVERSE  ;Recalculate shortcut flag

%IF #RESTARTSUBSBNUM=#TRUE %THEN #BNUM=#BNUMHOLD			;	Restart Block numbering for Subprograms - re-instate sequence number
@SKIP
ENDSUB=#BNUM
* Store HOLECYCLE2 flag for this subroutine
UARRAY1(SUBROUTINE)=#HOLECYCLE2

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
*		            		********************************
*							Determine spindle speed and gear
*							********************************
*
%PROCEDURE=PT_SPINDLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SPINDLE:%CALL=ENTER_PROCEDURE

*	The method used allows for range overlap for S-Code type machines by searching through all the gears
*	to determine the closest match rather than testing if the programmed speed is within the min/max of the gear
*	If a Gear has been specified explicitly then the search is restricted to that gear.
*
*	Uses DATA3 for numgears, minrpm, maxrpm, usermax and DATA4 for scode steps, min-scode, max-scode....
*
#NUMGEARS=DATA3(1)
#STEPS=DATA4(1)


*	Test if programmed speed is outside the total range of the machine

*	Less than Minimum speed so set as minimum
#MINRPM=DATA3(2):%IF #MINRPM>=#SPEED %THEN #SPEED=#MINRPM:#GEAR=1:%GOTO @END_RPM_LOOP

*	Greater than the maximum so set as maximum and selet the highest gear
#SPEEDPTR=(#NUMGEARS*3)+1:#MAXRPM=DATA3(#SPEEDPTR):%IF #MAXRPM<=#SPEED %THEN #SPEED=#MAXRPM:#GEAR=#NUMGEARS:%GOTO @END_RPM_LOOP

*	Speed is within machine's range
%IF #NUMGEARS>1 @RPM_GEAR					;	Direct RPM with Gears

#GEAR=1:%GOTO @END_RPM_LOOP			;	Direct Rpm, no (1) gears
;
@RPM_GEAR

*	If Gear has not been specified then loop thro' all gears (seperate loop for simplicity)
%IF #AUTOGEAR=#TRUE %THEN #GEAR=1		 		;	Start search at Gear1 else #gear has already been selected

@RPM_LOOP

#SPEEDPTR=(#GEAR*3)-1							;	Thus Gear1 - Speedptr=2, Gear2 - Speedptr=5 ......

#MINRPM=DATA3(#SPEEDPTR)						;	Retrieve min rpm for the gear
#SPEEDPTR=#SPEEDPTR+2:#MAXRPM=DATA3(#SPEEDPTR)	;	Retrieve max rpm for the gear

%IF #SPEED<#MINRPM @NEXT_GEAR

%IF #SPEED<#MAXRPM @END_RPM_LOOP				;	Speed is within the gear range

@NEXT_GEAR
%IF #GEAR=#NUMGEARS @END_RPM_LOOP

#GEAR=#GEAR+1:%GOTO @RPM_LOOP					;	Select next gear

@END_RPM_LOOP
%IF #STEPS>0 @SPINCODE_GEAR					;	Spindle codes machine
%GOTO @SELECT_GEAR_MCODE

*								Spindle Code type machine
@SPINCODE_GEAR
#RPMMATCH=10000									;	Set RPM difference to test against

%IF #AUTOGEAR=#TRUE %THEN #GEAR=1		 		;	Start search at Gear1
*					Gear has been specified
#SPEEDPTR=(#GEAR*3)-1							;	Thus Gear1 - Speedptr=2, Gear2 - Speedptr=5 ......
#STEPSPTR=(#GEAR*3)-2							;	Thus Gear1 - Stepsptr=1, Gear2 - Stepsptr=4 ......
@LOOP_GEARS
*					Retrieve No. of scodes (Steps), Min_rpm, Max_rpm, User_max_Rpm for each range
#STEPS=DATA4(#STEPSPTR)
#MINRPM=DATA3(#SPEEDPTR)
#MAXRPMPTR=#SPEEDPTR+1:#MAXRPM=DATA3(#MAXRPMPTR)
#USRMAXPTR=#SPEEDPTR+2:#USRMAXRPM=DATA3(#USRMAXPTR)

;					Calc rpm increment for the range using Linear progression
#RPMINC=(#MAXRPM-#MINRPM)/(#STEPS)
#RPMMATCH=#RPMINC
#TESTRPM=#MINRPM:#SPINCOUNTER=1

@TEST_CLOSEST									;	Test difference between programmed speed and
;	that available on machine

#RPMDIFF=(#SPEED-#TESTRPM)
#RPMDIFF=ABS(#RPMDIFF)

%IF #RPMDIFF>#RPMMATCH @NOT_USE
*	Found correct S code in this gear range
#RPMMATCH=#RPMDIFF
#HOLDRANGE=#GEAR								;	Store range for recall after testing complete
#HOLDSPINCOUNTER=#SPINCOUNTER					;	Store available speed in the range
%GOTO @RECALL_CLOSEST

@NOT_USE
%IF #SPINCOUNTER>#STEPS @END_RANGE

#TESTRPM=#TESTRPM+#RPMINC						;	Set next available speed in range
#SPINCOUNTER=#SPINCOUNTER+1

%GOTO @TEST_CLOSEST

@END_RANGE

%IF #AUTOGEAR=#FALSE @EXIT_LOOP_GEARS			;	Gear has been selected

%IF #GEAR=#NUMGEARS @EXIT_LOOP_GEARS

#GEAR=#GEAR+1:#SPEEDPTR=#SPEEDPTR+3:#STEPSPTR=#STEPSPTR+3			;	Move to next range
#SPINCOUNTER=1														;	Reset spindle code counter

%GOTO @LOOP_GEARS

@EXIT_LOOP_GEARS

@RECALL_CLOSEST									;	Retrieve the closest match

;	HOLDRANGE is the range in which the RPM was found
;	HOLDSPINCOUNTER is the offset in the range e.g. the 3rd code

;	Need to retrieve the actual Scode
#GEAR=#HOLDRANGE
#MINSCODE=(#GEAR*3)-1
#MAXSCODE=#MINSCODE+1
#STEPS=DATA4(#STEPSPTR)
#MINSCODE=DATA4(#MINSCODE)
#MAXSCODE=DATA4(#MAXSCODE)
%IF #STEPS=1 %THEN #SCODEINCR=(#MAXSCODE-#MINSCODE):%GOTO @SKIP ; Protect against divide by zero
#SCODEINCR=(#MAXSCODE-#MINSCODE)/(#STEPS-1)
@SKIP
#SCODE=#MINSCODE+((#HOLDSPINCOUNTER-1)*#SCODEINCR)
#SPEED=#SCODE

@SELECT_GEAR_MCODE
*	Warn if Gear Range selected greater than defined in Spindle Tab
%IF #GEAR>#NUMGEARS %THEN $WARNING="Warning - Invalid Gear selected":%CALL=CODECON_WARNING:%CANCEL=#GEAR

*	Assign correct Gear M-Code

%IF #GEAR=1 %THEN #GEARMCODE=DATA2(36)
%IF #GEAR=2 %THEN #GEARMCODE=DATA2(37)
%IF #GEAR=3 %THEN #GEARMCODE=DATA2(38)
%IF #GEAR=4 %THEN #GEARMCODE=DATA2(39)

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_OUTPUT_G54_TO_TABLE_CENTRE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_OUTPUT_G54_TO_TABLE_CENTRE:%CALL=ENTER_PROCEDURE

*	Procedure only applicable to Rotary Table configurations.
*	Must be in Procmill.cgi since called from within Set Work Datums
*
%IF #G54FROMHOME=#FALSE @END		;	Option not required.

XSUB=XHOME*-1:YSUB=YHOME*-1:ZSUB=ZHOME*-1

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

%PROCEDURE=PT_REMOVE_DUPLICATE_TOOLS
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_REMOVE_DUPLICATE_TOOLS:%CALL=ENTER_PROCEDURE

#TMP=1:#TMP2=POSITION

@TOP
%IF #HEADER=#TMP @END
%LOAD=#TMP

%IF #TMP2=POSITION %THEN #TMP1=#TRUE:%GOTO @END
#TMP=#TMP+1
%GOTO @TOP

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_LEAD_OUT
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_LEAD_OUT:%CALL=ENTER_PROCEDURE
*************************************************************
*	Purpose	:	To set number of moves in Lead out sequence	*
*	Called	:	when processing a Feed or Arc move which is	*
*				the first move of the Lead out sequence		*
*				Subfunct=2									*
*															*
*************************************************************
**************************************
*	Lead Out permutations
**************************************
* Following notes apply to pre EC4, may not be correct now
*	Angle + Rad 			= 1 move
*	Length     				= 1 move
*	Length + Angle 			= 1 move
*	Length + Angle + Rad 	= 2 moves
*	All plus one if 90 compensation cancel set i.e. Radius Compensation Factor in MM line

* %IF #COMPFACTOR<>0 %THEN #LEADOUTCOUNT=1 %ELSE #LEADOUTCOUNT=0
* %IF FIELD5<>0 %THEN #LEADOUTCOUNT=#LEADOUTCOUNT+1	;	Lead out radius
* %IF FIELD6<>0 %THEN #LEADOUTCOUNT=#LEADOUTCOUNT+1	;	Lead out length
*
#LEADOUTCOUNT=FIELD12
*
* Check FIELD12 lies in range 1-3
%IF FIELD12<1 @ERROR
%IF FIELD12>3 @ERROR
%GOTO @CONTINUE

@ERROR
$WARNING="Warning - Cutter Compensation active - Lead out invalid":%CALL=CODECON_WARNING


@CONTINUE
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM



; HEIDENHAIN specific procedures
;                                      Ŀ
;Ĵ Procedure = PT_HOLE_POSITION_HH  
;                                      
%PROCEDURE=PT_HOLE_POSITION_HH
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_HOLE_POSITION_HH:%CALL=ENTER_PROCEDURE

*	Output all positioning move for Hole cycles
%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC

#HOLECYCLE=1 ;Needed for Rapid after Tool Change

#ZMOVE=ZCLEAR 				;	Initial move will Rapid to the Clearance Plane
#XMOVE=#FUNNY:#YMOVE=#FUNNY
#TEMP=#ZHOLD
%IF #TEMP>#ZMOVE @HIGHER
%IF #TEMP=#ZMOVE @HIGHER
* Lift to ZCLEAR
%CALL=PT_OUTPUT_RAPID
#ZHOLD=#ZMOVE ; Set because #HOLECYCLE=1
%IF #ZREVERSE=1 %THEN #ZMOVE=#ZMOVE*-1 ; Reverse for re-use

@HIGHER
*	Rapid to first XY position then to Zclear with Tool Length Offset.  Call procedure for single Code Constructor
#LOOP=1
* #ZMOVE=#FUNNY
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP):#TMP=#GCODE								;	First Hole position, store cycle Gcode, set to Rapid
%CALL=PT_OUTPUT_RAPID
*  #ZHOLD=#ZMOVE ; Explicit set because #HOLECYCLE=1

*<zlevel = [ZLEVEL=24] rplane = [RPLANE=24] zdepth = [ZDEPTH=24]>
%IF ZLEVEL=#FUNNY %THEN #ZLEVEL=ZPOINT(#LOOP) %ELSE #ZLEVEL=ZLEVEL
*<#zlevel = [#ZLEVEL=24]>

*	Determine actual Rplane level
%IF ZLEVEL=#FUNNY %THEN #ZMOVE=#ZLEVEL+RPLANE %ELSE #ZMOVE=RPLANE

#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)

%IF #MVRETRACT=2 @SKIP
%IF $MODEL="TNC430" @SKIP
%IF #ZMOVE=#ZHOLD @SKIP
%CALL=PT_OUTPUT_RAPID ;	Rapid to Rplane

@SKIP
#ZHOLD=#ZMOVE ; Explicit set because #HOLECYCLE=1
@END

* TNC426 requires modified action for multi-level/depth holes
%IF $MODEL="TNC426" %THEN %CALL=PT_HOLE_CYCLES_TNC:%GOTO @END99
%IF $MODEL="TNC430" %THEN %CALL=PT_HOLE_CYCLES_TNC:%GOTO @END99
%CALL=PT_HOLE_CYCLES_HH

@END99
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                      Ŀ
;Ĵ Procedure = PT_HOLE_CYCLES_HH    
;                                      
%PROCEDURE=PT_HOLE_CYCLES_HH
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_HOLE_CYCLES_HH:%CALL=ENTER_PROCEDURE

#HOLECYCLE=1
#TEMPREVERSE=1
%IF #ZREVERSE=1 %THEN #TEMPREVERSE=-1

*
*	Output all Hole cycles Drill, Chipbreak, Ream and Bore as Canned Cycles - coords are held in the XYZPOINT array
*   Called from each cycle macro and cyclsub for subroutines
*	Relevant CYCLE DEF called for each cycle
*	expands XY points via Code Constructor CYCLEPOINTS
*
%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC

*#ZMOVE=ZCLEAR 				;	Initial move will Rapid to the Clearance Plane

*	Rapid to first XY position then to Zclear with Tool Length Offset.  Call procedure for single Code Constructor
*	Could put this on a switch e.g. Call Rapid After toolchange ?
#LOOP=1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP):#TMP=#GCODE								;	First Hole position, store cycle Gcode, set to Rapid


#ZMOVE=ZDEPTH-#ZLEVEL:#RPLANE=(RPLANE-#ZLEVEL):#ZDEPTH=ZDEPTH*-1
%IF ZLEVEL=#FUNNY %THEN #ZMOVE=ZDEPTH:#RPLANE=RPLANE:#ZDEPTH=ZDEPTH

%IF ZCLEAR=RPLANE %THEN #RETRACTGCODE=DATA1(50) %ELSE #RETRACTGCODE=DATA1(49)	;	G99 / G98
%IF #GCODE=DATA1(39) %THEN #FEED=SPEED*PITCH %ELSE #FEED=ZFEED		;	If tapping then Feed = revs*pitch
%IF #ZRABSINCR=3 %THEN #ZMOVE=ABS(#ZMOVE) ;Unsigned incremental selected

%CALL=PT_CYCLDEF 	;	Output CYCLDEF Header blocks

*	Reset #ZMOVE
%IF ZLEVEL=#FUNNY %THEN #ZMOVE=#ZLEVEL+RPLANE %ELSE #ZMOVE=RPLANE

@IN_CYCLE

#GCODE=#TMP:%CANCEL=#XMOVE,#YMOVE											;	Retrieve Cycle Gcode

#LOOP=1

%CANCEL=#MODALCYCLE   ; Force M89/99 on first position
*			Load next point Label
@LOOP
%IF #LOOP>LAST @ELOOP
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)


#MULTILEVEL=#FALSE:#MODALCYCLE=DATA2(47)
%IF ZLEVEL=#FUNNY %THEN #MULTILEVEL=#TRUE:#MODALCYCLE=DATA2(48)		;	Set / Re-set default modal M99

%CALL=PT_MULTI_LEVEL_HH

%CALL=PT_GET_NEXT_HOLE		;	Check if next hole is different Zlevel i.e. multi-level

*	Force M99 on last hole XY if multilevel is false else will be output on Zrplane line
%IF #LOOP<>LAST @MISS1
%IF #MULTILEVEL=#FALSE %THEN #MODALCYCLE=DATA2(48):%CANCEL=#MODALCYCLE

@MISS1

%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ

%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

* %IF #LOOP<>1 @NOT_FIRST_POINT	;	Supress first point
* %IF $OUTPUTSUBS=FALSE @LOOPEXPAND
* @NOT_FIRST_POINT

* If subroutines are in use but not being defined/output now, skip point output  (RHA June99)
%IF DRILLSUB=0 @FIRST_POINT
%IF $OUTPUTSUBS=FALSE @END

@FIRST_POINT
*
*		Each cycle will use a different output line but needs to be here to centralise loop expansion.  Could
*		be in each macro but G81, G82 and G83 all use macro 9 and subroutines use same array.
*		Must present different Code Constructors for each cycle otherwise user will be confused - will have
*		to understand that some parameters are not used e.g. DWELL,DEPTH + ALL GCODETYPES i.e G81, G82 etc in one line etc.
*
* %IF #RPLANE=ZCLEAR %THEN %CANCEL=#MODALCYCLE
%IF $CYCLETYPE=COUNTERBORE @G82CYCLE
%IF $CYCLETYPE=PECKDRILL @G83CYCLE
%IF $CYCLETYPE=TAPPING @G84CYCLE
%IF $CYCLETYPE=REAMBORE @G85CYCLE
%IF $CYCLETYPE=BORE @G86CYCLE
%IF $CYCLETYPE=CHIPBREAK @G73CYCLE

*	G81 Drill Cycle
@G81CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.
*	G82 CounterBore (Dwell) Cycle
@G82CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.

*	G83 Peck Drill Cycle
@G83CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.

*	G84 Tapping Cycle
@G84CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.

*	G85 Ream / Bore Cycle
@G85CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.

*	G86 Bore Cycle (note #BOREOFFSET is entered in machine's default units)
@G86CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

%GOTO @LOOPEXPAND										;	Expand 2nd, 3rd point etc.

*	G73 Chipbreak Drill Cycle
@G73CYCLE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE*#TEMPREVERSE

@LOOPEXPAND

* %IF DRILLSUB<>1 @NEXTPOINT
* %IF $OUTPUTSUBS=TRUE @NEXTPOINT
* %GOTO @END
* @NEXTPOINT
%IF #MULTILEVEL=#FALSE @SKIP
%IF #LOOP=1 @RETRACT_TO_CLEAR

*		Rapid to Rplane and execute cycle if Multi-level processing.
*<*	Rapid to Retract & Cycle Call *>
%CANCEL=#MODALCYCLE
#ZMOVE=#RPLANE*#TEMPREVERSE
%IF #RPLANE<>ZCLEAR %THEN %CALL=CODECON_HOLE-CYCLEPOINTS

@RETRACT_TO_CLEAR

*		Retract to Clear for next hole
*<*	Rapid to Clear *>
#ZMOVE=ZCLEAR*#TEMPREVERSE
%IF #RPLANE<>ZCLEAR %THEN %CALL=CODECON_HOLE-CYCLEPOINTS

@SKIP
#ZMOVE=#ZMOVE*#TEMPREVERSE ; Reset Z Move
#LOOP=#LOOP+1:%GOTO @LOOP
@ELOOP											;	End canned cycle output

*	G80 Cancel Canned Cycle

%CALL=CODECON_CANCEL-CANNED-CYCLE

@END

%CALL=HOLD
* #HOLECYCLE2 is now used to suppress sub call approach moves
* Always set 0 if cyclesub macro (after sub call)
* Set 0 if not using drill subroutines
%IF #MACRO=61 %THEN #HOLECYCLE2=1
#HOLECYCLE=#FALSE
@END99

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
%PROCEDURE=PT_CYCLDEF
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_CYCLDEF:%CALL=ENTER_PROCEDURE

%IF $OUTPUTSUBS=TRUE @FINISH-CYCLDEF	;	Miss CYCL DEF if expanding subroutine

*	Call CYCL DEF for each cycle type
%IF $CYCLETYPE=DRILL %THEN %CALL=CODECON_DRILL-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=COUNTERBORE %THEN %CALL=CODECON_COUNTERBORE-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=PECKDRILL %THEN %CALL=CODECON_PECK-DRILL-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=TAPPING %THEN %CALL=CODECON_TAPPING-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=RIGIDTAPPING %THEN %CALL=CODECON_RIGID-TAP-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=REAMBORE %THEN %CALL=CODECON_REAM-BORE-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=BORE %THEN %CALL=CODECON_BORE-CYCLE:%GOTO @FINISH-CYCLDEF
%IF $CYCLETYPE=CHIPBREAK %THEN %CALL=CODECON_CHIPBREAK-CYCLE:%GOTO @FINISH-CYCLDEF

@FINISH-CYCLDEF

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
;                                      Ŀ
;Ĵ Procedure = PT_MULTI_LEVEL_HH    
;                                      
%PROCEDURE=PT_MULTI_LEVEL_HH
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_MULTI_LEVEL_HH:%CALL=ENTER_PROCEDURE

#ZLEVEL=ZPOINT(#LOOP)
#ZDEPTH=ZDEPTH*-1
#RPLANE=#ZLEVEL+RPLANE
@END
*%IF #ZRABSINCR=2 %THEN #RPLANE=#RPLANE*-1

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


%PROCEDURE=PT_GET_NEXT_HOLE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_GET_NEXT_HOLE:%CALL=ENTER_PROCEDURE
*		Load next hole position to determine ;
*		If Multi level output M99, if constant output M98
*		If M99 rapid to Clearance, move to next hole, Zrplane M99

#TMP=#LOOP+1
*	If next Zlevel is different then select M99 (non modal) else select M89 (modal)
#TMP2=ZPOINT(#TMP)
%IF #ZLEVEL<>#TMP2 %THEN #MODALCYCLE=DATA2(48)

* Check Multi-depth for TNC426
%IF $MODEL<>"TNC426" @END
#TMP1=#ZLEVEL-MZDEPTH(#TMP)
%IF #ZDEPTH<>#TMP1 %THEN #MODALCYCLE=DATA2(48)

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


; HEIDENHAIN TNC426 specific procedures

;                                      Ŀ
;Ĵ Procedure = PT_HOLE_CYCLES_TNC    
;                                      
%PROCEDURE=PT_HOLE_CYCLES_TNC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_HOLE_CYCLES_TNC:%CALL=ENTER_PROCEDURE
#HOLECYCLE=1
*
*	Output all Hole cycles Drill, Chipbreak, Ream and Bore as Canned Cycles - coords are held in the XYZPOINT array
*   Called from each cycle macro and cyclsub for subroutines
*	Relevant CYCLE DEF called for each cycle
*	expands XY points via Code Constructor CYCLEPOINTS
*
%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC

*#ZMOVE=ZCLEAR 				;	Initial move will Rapid to the Clearance Plane

*	Rapid to first XY position then to Zclear with Tool Length Offset.  Call procedure for single Code Constructor
*	Could put this on a switch e.g. Call Rapid After toolchange ?
#LOOP=1
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP):#TMP=#GCODE								;	First Hole position, store cycle Gcode, set to Rapid


* Set values for constant Level/Depth
%IF ZLEVEL=#FUNNY %THEN #ZMOVE=ZDEPTH %ELSE #ZMOVE=ZDEPTH-ZLEVEL
#RPLANE=(RPLANE-#ZLEVEL)*-1
#ZDEPTH=(ZDEPTH-#ZLEVEL)*-1

* If multilevel, pick up values from array
%IF ZLEVEL=#FUNNY %THEN #MULTILEVEL=#TRUE:%CALL=PT_MULTI_LEVEL_TNC:#ZMOVE=#ZDEPTH*-1

%IF ZCLEAR=RPLANE %THEN #RETRACTGCODE=DATA1(50) %ELSE #RETRACTGCODE=DATA1(49)	;	G99 / G98
%IF #GCODE=DATA1(39) %THEN #FEED=SPEED*PITCH %ELSE #FEED=ZFEED		;	If tapping then Feed = revs*pitch

#TMP1=ZCLEAR
ZCLEAR=ZCLEAR-#ZLEVEL
%CANCEL=#RPLANE
%CALL=PT_CYCLDEF 	;	Output CYCLDEF Header blocks
ZCLEAR=#TMP1

@IN_CYCLE

#GCODE=#TMP
%IF $MODEL<>"TNC430" %THEN %CANCEL=#XMOVE,#YMOVE											;	Retrieve Cycle Gcode

#LOOP=1

#MODALCYCLE=DATA2(47) ; Set mode M89 for start of cycle
%CANCEL=#MODALCYCLE   ; Force M89/99 on first position
*			Load next point Label
@LOOP
%IF #LOOP>LAST @ELOOP
#XMOVE=XPOINT(#LOOP):#YMOVE=YPOINT(#LOOP)


#RPLANE=RPLANE ; Reset absolute value

%IF #MULTILEVEL=1 %THEN %CALL=PT_MULTI_LEVEL_TNC
%IF #MULTILEVEL=1 %THEN %CALL=PT_GET_NEXT_HOLE		;	Check if next hole is different Zlevel i.e. multi-level

*	Force M99 on last hole XY
%IF #LOOP=LAST %THEN #MODALCYCLE=DATA2(48)
*%IF #MULTILEVEL=#FALSE %THEN #MODALCYCLE=DATA2(48):%CANCEL=#MODALCYCLE

@MISS1

* Force cycle redefinition if depth or level change
#SUPPORTMDEPTH=0
*Check for Zdepth change and respecify cycle
#DEPTHCHANGE=#FALSE
#CYCLEGCODESAVE=#CYCLEGCODE
%IF #SUPPORTMDEPTH=1 @NOCHANGE
%IF #LOOP=1 @NOCHANGE
%IF #ZDEPTH<>#ZDEPTHHOLD @CHANGE
%IF #ZLEVEL<>#ZLEVELHOLD @CHANGE
%GOTO @NOCHANGE

@CHANGE
#DEPTHCHANGE=#TRUE
%CANCEL=#XMOVE,#YMOVE,#FEED
@NOCHANGE
#ZDEPTHHOLD=#ZDEPTH ; Save z Depth
#ZLEVELHOLD=#ZLEVEL

%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ

%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ

* %IF #LOOP<>1 @NOT_FIRST_POINT	;	Supress first point
* %IF $OUTPUTSUBS=FALSE @LOOPEXPAND
* @NOT_FIRST_POINT

* If subroutines are in use but not being defined/output now, skip point output  (RHA June99)
%IF DRILLSUB=0 @FIRST_POINT
%IF $OUTPUTSUBS=FALSE @END

@FIRST_POINT
*
*	G81 Drill Cycle
@G81CYCLE
%IF #DEPTHCHANGE=#FALSE @G81-2
#CYCLEGCODE=#CYCLEGCODESAVE
#TMP=#FEED
#ZMOVE=#FUNNY
%CALL=PT_OUTPUT_RAPID
#MODALCYCLE=DATA2(47) ; Set mode M89 for start of cycle
#FEED=#TMP
#TMP1=ZCLEAR
ZCLEAR=ZCLEAR-#ZLEVEL
#ZMOVE=#ZDEPTH*-1
%CANCEL=#RPLANE
%CALL=PT_CYCLDEF 	;	Output CYCLDEF Header blocks
ZCLEAR=#TMP1


@G81-2
%IF $MODEL<>"TNC430" %THEN %CANCEL=#XMOVE,#YMOVE
%CALL=CODECON_HOLE-CYCLEPOINTS
%IF #ZMOVE<>#FUNNY %THEN #ZHOLD=#ZMOVE

@LOOPEXPAND

#LOOP=#LOOP+1:%GOTO @LOOP
@ELOOP											;	End canned cycle output

*	G80 Cancel Canned Cycle

%CALL=CODECON_CANCEL-CANNED-CYCLE

@END

%CALL=HOLD
* #HOLECYCLE2 is now used to suppress sub call approach moves
* Always set 0 if cyclesub macro (after sub call)
* Set 0 if not using drill subroutines
%IF #MACRO=61 %THEN #HOLECYCLE2=1
#HOLECYCLE=#FALSE
@END99
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM
*
*
;                                      Ŀ
;Ĵ Procedure = PT_MULTI_LEVEL_TNC    
;                                      
%PROCEDURE=PT_MULTI_LEVEL_TNC
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_MULTI_LEVEL_TNC:%CALL=ENTER_PROCEDURE

* #USER1=MZDEPTH(#LOOP)   ;diagnostic?
#ZLEVEL=ZPOINT(#LOOP)
#ZDEPTH=#ZLEVEL-MZDEPTH(#LOOP)
#RPLANE=MRPLANE(#LOOP)-#ZLEVEL
@END

%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                Ŀ
;Ĵ Procedure = PT_RAPID_TO_HOME_TOOLCHANGE
;                                
%PROCEDURE=PT_RAPID_TO_HOME_TOOLCHANGE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_RAPID_TO_HOME_TOOLCHANGE:%CALL=ENTER_PROCEDURE

#USEDTOKEN=#FALSE
%IF #FEEDRAPIDS=#TRUE %THEN #GCODE=DATA1(2):#FEED=#RAPIDFEEDRATE %ELSE #GCODE=DATA1(1):#FEED=#FUNNY   ;	All Rapids are being converted to feeds
#TMP1=#XMOVE:#TMP2=#YMOVE:#TMP3=#ZMOVE

;********* FIELD4 0=NO PRIORITY, 1=X FIRST, 2=Y FIRST, 3=Z FIRST
%IF FIELD4=0 %THEN #MOVE=1:%GOTO @FINAL-LEG ; No preference - one move only
%IF FIELD4=1 %THEN #YMOVE=#FUNNY:#ZMOVE=#FUNNY:#MOVE=1
%IF FIELD4=2 %THEN #XMOVE=#FUNNY:#ZMOVE=#FUNNY:#MOVE=1
%IF FIELD4=3 %THEN #XMOVE=#FUNNY:#YMOVE=#FUNNY:#MOVE=1
*
* Reverse stored absolutes if needed
%IF #INCRXYZ=#TRUE @SKIP1
%IF #XREVERSE=#TRUE %THEN #XSTOREABS=#XSTOREABS*-1
%IF #YREVERSE=#TRUE %THEN #YSTOREABS=#YSTOREABS*-1
%IF #ZREVERSE=#TRUE %THEN #ZSTOREABS=#ZSTOREABS*-1
@SKIP1

* Check for no First move needed, already there
%IF FIELD4<>3 @MARK1
%IF #ZHOLD=#ZSTOREABS @SKIP-NULL

@MARK1
%IF FIELD4<>2 @MARK2
%IF #YHOLD=#YSTOREABS @SKIP-NULL

@MARK2
%IF FIELD4<>1 @MARK3
%IF #XHOLD=#XSTOREABS @SKIP-NULL
@MARK3

*
%IF #MACRO=40 %THEN %CALL=CODECON_RAPID-TO-HOME
%IF #MACRO=41 %THEN %CALL=CODECON_RAPID-TO-TOOLCHANGE

%IF #USEDTOKEN=#FALSE @END
@SKIP-NULL

#XMOVE=#TMP1:#YMOVE=#TMP2:#ZMOVE=#TMP3

@FINAL-LEG
;******* FIELD 1-3 SET <> 0 IF USER HAS SELECTED AXIS IS FIXED
%IF FIELD1<>0 %THEN #XMOVE=#FUNNY:#TMP1=#XHOLD:#MOVE=#MOVE+1 ; no move
%IF FIELD2<>0 %THEN #YMOVE=#FUNNY:#TMP2=#YHOLD:#MOVE=#MOVE+1 ; no move
%IF FIELD3<>0 %THEN #ZMOVE=#FUNNY:#TMP3=#ZHOLD:#MOVE=#MOVE+1 ; no move

%IF #MOVE=3 @END ; no more axis moves
%IF #MACRO=40 %THEN %CALL=CODECON_RAPID-TO-HOME
%IF #MACRO=41 %THEN %CALL=CODECON_RAPID-TO-TOOLCHANGE

@END
* Reset stored absolutes if needed
%IF #INCRXYZ=#TRUE @SKIP2
%IF #XREVERSE=#TRUE %THEN #XSTOREABS=#XSTOREABS*-1
%IF #YREVERSE=#TRUE %THEN #YSTOREABS=#YSTOREABS*-1
%IF #ZREVERSE=#TRUE %THEN #ZSTOREABS=#ZSTOREABS*-1
@SKIP2

#XMOVE=#TMP1:#YMOVE=#TMP2:#ZMOVE=#TMP3
%CALL=HOLD
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                      Ŀ
;Ĵ Procedure = PT_COUNT_PECKS    
;                                      
%PROCEDURE=PT_COUNT_PECKS
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_COUNT_PECKS:%CALL=ENTER_PROCEDURE

* Calculates number of pecks/chipbreaks in cycle
* Called from Token
#NPECKS=1
%IF DEGR=0 @END
%IF DEGR=#FUNNY @END

#TMP1=ABS(#ZMOVE-ZLEVEL)  ; Remaining depth
#TMP2=ABS(DEPTH)  ; This peck
%IF #TMP2>#TMP1 @END

#TMP1=#TMP1-#TMP2

@LOOP
#TMP2=#TMP2-DEGR
%IF #TMP2<DEGR %THEN #TMP2=DEGR
#TMP1=#TMP1-#TMP2
#NPECKS=#NPECKS+1
%IF #TMP1>0 @LOOP

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                      Ŀ
;Ĵ Procedure = PT_SET_TLO    
;                                      
%PROCEDURE=PT_SET_TLO
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_SET_TLO:%CALL=ENTER_PROCEDURE

%IF USERVAR3<>0 %THEN #HCODE=USERVAR3:%GOTO @REGISTER_SET ;Use entered value if available
* Nothing specified, use defaults
%IF #AUTOTLO=1 %THEN #HCODE=POSITION+#MAXTOOLS1
%IF #AUTOTLO=2 %THEN #HCODE=POSITION
%IF #AUTOTLO=3 %THEN #HCODE=#MAXTOOLS1+#TOOLCOUNT
@REGISTER_SET

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                      Ŀ
;Ĵ Procedure = PT_WARNING_COUNT    
;                                      
%PROCEDURE=PT_WARNING_COUNT
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_WARNING_COUNT:%CALL=ENTER_PROCEDURE

%IF #WARNCOUNT=0 @END
$TEMP=99
%OPTIONS=Errors or Warnings in NC data file^OK=#TMP

@END
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM


;                                      Ŀ
;Ĵ Procedure = PT_TAPPING_REVERSE    
;                                      
%PROCEDURE=PT_TAPPING_REVERSE
%IF #PROCTRACE=1 %THEN $PROCEDURE=PT_TAPPING_REVERSE:%CALL=ENTER_PROCEDURE
* Called by Attribute macro to reverse spindle when longhand tapping

#DWELLGCODE=DATA1(5)
%IF FIELD5=1 %THEN %CALL=CODECON_TAPREV_B:%GOTO @ENDM
%IF FIELD5=2 %THEN %CALL=CODECON_TAPREV_T
#SKIPTAP=1

@ENDM
%ENDM
*** End of include file B:\Pams\cam\machdef\template\MPROCEED.CGI ***
*** Start of include file M-FANUC.CGI ***
*************************************************************************
*   Machine specific Code Generator include file                        *
*                                                                       *
*   Filename:	FANUC.CGI                                               *
*	Machine:	Fanuc                                                   *
*	Author:		ADM (Derived from 3M-MACH.FAN -r1.3, 3M-START.FAN -r1.8 *
*                    3M-CODE.FAN -r1.9, 3M-FORM.FAN -r1.1)              *
*   Date:		16th March 1998                                         *
*                                                                       *
*************************************************************************
*   Change History                                                      *
*   30/03/98 ADM - Implement Warning code constructor                   *
*   16/04/98 ADM - Removed spline code constructors until implemented   *
*                  as option in machine parameters                      *
*   05/06/98 ADM - Added spline code constructor (QA B180)              *
*   24/09/98 RHA - Spline procedure & vars moved from mproceed/mdeclare *
*                  Codcon trace added to END                            *
*   13/10/98 RHA - MACRONAMEOP control made visible in wizard.          *
*                  Reverse Sign text clarified                          *
*                  #MACHTYPE added, set from MM sw9                     *
*                  #REVANGDIR - reverse direction of 0-360 switch added *
*                  #ROTARYINDEX setting and use removed                 *
*   03/03/99 RHA - Precision calculation now #INCR/2  task Ref A567     *
*   11/03/99 RHA - EC4 controller comp enabled, MM(SW8) help expanded   *
*   10/05/99 RHA - #HIGHSPEED removed to save var name                  *
*   17/06/99 RHA   New procedure trace control added, old DEBUG removed *
* 20/07/99  RHA   DB11141 - Block number reset added                    *
*                 DB11497 - List NC Code controlled by Setvar           *
* 10/08/99  RHA  DB11566 - Tool tokens made more widely available       *
* 22/09/99  RHA  DB11654 - Rotary limit 0-360 made switchable           *
* 07/01/00 RHA DB11691 Call order of COMP_TLO, INCXYZ, REVERSE standardised, Macros START, END
* 10/02/00 RHA DB11963 - Add user tokens, all code constructors
* 10/02/00 RHA DB11879 - Add Tool/Home position tokens - Rapid to ToolChange/Home
* 10/02/00 RHA DB11745 - Extend token availablity
* 10/02/00 RHA DB11746 - Add Safeblk token to Rapid After Toolchange
* 14/02/00 RHA DB11745 - Changes to method of abs/inc switching
*         #incrxyz is set to #incrxyzhold in main prog and #incrsubs in subroutines
* 07/03/00 RHA DB11941 All CRC warnings now controlled by #WARNCRC
*                      Cancel CRC allowed on Z move if required, #CRCONZ
* 10/03/00 RHA DB11984 Add CRC tokens to rapid moves
* 15/03/00 RHA         Change use of #tmp in ;setvar commands to avoid reset on update
* 20/03/00 RHA         Correct block num reset to use #tmp3 properly
* 19/05/00 RHA DB11177 Implement option for abs/inc runtime switch
* 07/06/00 RHA Modify data2 array to allow 6 gear ranges
* 29/09/00 RHA DEV0991 Intermediate variable removed from $CONDEBUG setting
* 17/10/00 RHA DEV00000433 Add TURRETNO token to Rapid to Home/ToolChange
* 08/11/00 RHA DEV  Increase number of user tokens, test in START only
*              Multi-depth hole cycle control question added
* 09/11/00 RHA DEV00001691 Add more user tokens
*              DEV00001683 Add Multi-depth drilling
* 15/11/00 RHA DEV00001682 Add warning notes to Start Code Constructor
* 13/12/00 RHA DEV00001886 - Replace text Imperial with Inch
* 14/12/00 RHA DEV00002151 Better toolchange position warning control
* 18/12/00 RHA DEV00000377 ZGAUGELENGTH added to Set Up/Tooling Sheet
* 19/12/00 RHA DEV00002152 TOOLTYPE token added to ToolChange and to Tooling Data
* 15/01/01 RHA DEV00002142 Add admin tokens to Program End code constructor
* 25/01/01 RHA DEV00002157 Add single helical block option for Thread Mill (Circ Interpolation Tab)
* 12/09/01 RHA DEV00000377 LENGTHOFFSET added to Set Up/Tooling Sheet
* 18/09/01 RHA DEV00000894 Add G91 X0 Y0 to G28 blocks to mimic EdgeCAM
* 25/09/01 RHA DEV00000894 Further modify to use secondary code construcors, as Mori Seiki
* 11/10/01 RHA DEV00002359 Add switch for Arc move check to CRC tab
* 25/10/01 RHA Add Job Record Tokens to START and END constructors
* 30/10/01 RHA DEV00003388 Longhand cycle options, Q67
* 01/03/02 RHA DEV00004755 Add switch for force XYZ after index
* 01/03/02 RHA DEV00004482 Set up sheet header/trailer added
* 30/04/02 RHA DEV00005006 Add token for High Speed Tolerance
* 15/05/02 RHA DEV00005448 Add angular range option - +/-180
* 15/05/02 RHA DEV00005454 Allow incremental angular moves
* 16/05/02 RHA DEV00005448 Change angle limit setting for safer updates
* 30/05/02 RHA DEV00003830 Add control for incremental in rotary mode
* 22/11/02 RHA DEV00006698 Add CPLNAME token to Rapid after ToolChange
* 27/11/02 RHA DEV00006442 Make hole cycle expansion switchable
* 27/11/02 RHA DEV00006251 Automate subroutine abs/inc code output
* 27/11/02 RHA DEV00006476 Duplicate tools checkbox moved to set up tab
* 02/12/02 RHA DEV00006563 Change default Rapid and High Feed values
* 04/12/02 RHA DEV00006788 Add SPINDIR to tokens for Hole cycle drill
* 20/02/03 RHA DEV00007049 Make Exact stop properly switchable
* 21/02/03 RHA DEV00007249 Add hole cycle control switches
* 12/03/03 RHA             Correct default settings for above
* 02/07/03 RHA DEV00008021 Add text case switch
* 11/08/03 RHA Various	   Make additional tokens available
* 13/08/03 RHA DEV00007955 Force feedrate at start of subroutine #FORCEFEED
* 13/08/03 RHA DEV00007537 TLO options as for CRC
* 22/08/03 RHA DEV00008536 Improve CRC warnings
* 26/08/03 RHA DEV00008539 Add warning counter
* 27/08/03 RHA DEV00007609 ToolChange & Home setting Option
* 04/12/03 RHA DEV00007048 Add Rigid Tapping Option
* 05/12/03 RHA DEV00007400 Option to force XYZ on full circle
* 05/12/03 RHA DEV00007045 Table clamp codes and tokens
* 15/12/03 RHA DEV00009612 Add new date tokens
* 10/02/04 RHA DEV00007045 Reposition setvars into macro
* Version 9
* 19/07/04 RHA DEV00011202 Set bulge check parameters in START
* Version 9.5
* 18/11/04 RHA DEV00011790 Document double call for Rapid to ToolChange
* 01/12/04 RHA DEV00011681 Additional mill tool tokens
* 08/12/04 RHA DEV00012640 Make max block number subserviant to Use Block Numbers
* 05/01/05 RHA DEV00012845 Remove duplicate tooltype setting
* 19/01/05 RHA DEV00012616 Correct HOLD setting for initial home position
* Version 9.75
* 03/03/05 RHA DEV00007742 Add stub for CODECON_THREAD_CYCLE
* 10/03/05 RHA DEV00012923 Set #XTOOLREF etc. for tool change position offset
* 11/03/05 RHA DEV00012923 Set HOLD vars to HOME in START macro
* 14/03/05 RHA DEV00012923 Correct axis reversal of Home setting
* 30/03/05 RHA DEV00012923 Corrections
* Version 10.0
* 15/06/05 RHA DEV00012923 Correct use of ZSUB etc
* 08/07/05 RHA DEV00014063 Correct max block setting
* 04/10/05 RHA DEV00012923 Move initial position setting to PT_INIT_POSITION and fix
* Version 11.0
* 03/08/06 RHA DEV00017814 Add WORKGCODE token to Rapid Home & Rapid TC
* Version 12.25
* 03/12/07 RHA DEV00021534 Enable longhand tapping
*************************************************************************


***********************************************
*
*  TEMPLATE SPECIFIC DECLARATIONS AND TOKENS
*
***********************************************
*   SPLINE OUTPUT
%DECLARE=#KNOT,#WEIGHT,#ORDER
%DECLARE=#K1VALUE,#K2VALUE,#K3VALUE,#K1EXP,#K2EXP,#K3EXP,$AXIS,$CONTINUE
*** Machine parameters
;                                                       Ŀ
;Ĵ Macro = Machine 
;                                                       
%MACHINE=MILL=Mach3_3x
;
;
;                                           Ŀ
;Ĵ MM=Machine Details Line   
;                                           
; SETTING UP MACHINE DEFAULTS (MM section)
; sw 1  default to Inch/Met              0=Inch 1=Metric
; sw 2  max RAPID                       value
; sw 3  max RPM                         value
; sw 4  max ANG FEED (deg/min)          Not used in mill post
; sw 5  Twotapes                        Not used in mill post
; sw 6  Rapid 3D                        0=no       1=yes
; sw 7  Unresolved RAPID movement       0=resolved 1=unresolved
; sw 8  Index / Non-indexable post / Misc settings (Bitwise additional)
;       Bit 0  Simple index disabled (Milling only)
;           1  Simple Index enabled (Milling only)
;           2  Visit reset macro once after mirror (Milling only)
;           4  Enable reverse offset (Milling only)
;           8  Reverse tool side - 45degree line (Turning only)
;          16  Enable NEXTMOVE "look ahead" in toolchange
;          32  Enable version 4 controller compensation enhancements (Milling only)
;		Examples - 3=index support + visit mirror reset
;    			   7=index support, visit mirror reset + reverse offset
;                 32=As 7, above, plus EC4 controller compensation
; sw 9  Rotation Axis                   see Manual
; sw 10 Plane Switching                 0=xy only 1=xy,zx 2=xy,zy 3=xy,zx,zy
; sw 11 Z initial plane                 value
; sw 12 Wire guide output
; sw 13 Centre Gauge point supported 	Turning only
; sw 14 Z seperation					Turning only - 2 turrets on single slide
; sw 15 X seperation 					Turning only - 2 turrets on single slide
; sw 16 90 deg Cutter Radius Comp		Factor * toolradius
; sw 17 Output wrapped co-ordinates		Rotary milling (including Caxis Turn-mill)
; sw 18 Maximum programmable radius
; sw 19 Support radial Arcs				Rotary Milling 0=No, 1=Yes
; sw 20 Support XC interpolation 		Turning - Axial only
; sw 21 Support Splines	0=No 1=Fanuc 2=TNC
;
;
;  1| 2 | 3  |4|5|6|7|8|9|10|11|12|13|14|15| 16|17|   18   |19|20|21
MM=1,6000,24000,0,0,0,1,39,0,0,20,0,0,0,0,1.5,0,9999.999,0,0,0,0,0,0,0,0,,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0
;
;Ĵ MT=Turret Details Line    
;                                           
; sw 1  Turret name
; sw 2  Number of stations
; sw 3  Tool change X
; sw 4  Tool change Y
; sw 5  Tool change Z
; sw 6  Home X
; sw 7  Home Y
; sw 8  Home Z
; sw 9  Max Extents X
; sw10  Max Extents Y
; sw11  Max Extents Z
; sw12  Min Extents x
; sw13  Min Extents y
; sw14  Min Extents z
; sw15  Max Primary feed
; sw16  Max Secondary feed
; sw17  TC Dwell
;
; |  1     | 2| 3 | 4 |5 | 6 | 7 |8 | 9 | 10|11 | 12 | 13 | 14 | 15 | 16 | 17
MT=head one,32,224,112,60,224,112,60,500,500,500,500,500,100,5000,1000,6,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,,
;
;
;                                           Ŀ
;Ĵ User defined variables    
;                                           
; USER DEFINED VARS
Q67=..Longhand ^No^Yes [9,10,11,12,13]
Q67=..Register ..[29]
Q68=..Workshift..Select^No Override^G54^G55^G56^G57^G58^G59 [15]
Q69=..Tlo No   ..Tool length offset No. ?     [15,116]
Q69=..ToleranceHigh speed tolerance ?     	[110]
Q69=..Tap Type Cycle Type^Floating^Rigid  [9,10,11,12,13]
Q70=..Tap CycleTap Cycle^Right Hand^Left Hand [9,10,11,12,13]
Q70=..Gear     Select gear range^Auto^Gear 1^Gear 2^Gear 3^Gear 4 [15]
Q70=..Chord    Enter chord length for arc splitting ? [102]
;SPLINE_OUTPUT=1
*
%ENDMACH

*
******************************************************************************************************
*	Gcodes                                            20                            30             35             40              45
%DATA1=0.0,1,2,3,4,0,0,0,-1,9,10,11,17,18,19,20,21,33,76,40,41,42,92,53,54,55,56,57,58,59,70,71,72,73,80,81,82,83,84,85,86,84.1,97,96,94,95,90,91,98,99,92,74,75,-1,-1
*	Mcodes
%DATA2=0.0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,30,31,32,33,34,35,36,37,38,80,81,23,24,98,99,41,42,43,44,0,0,0,53,54,-1,-1
*
*********************************
*	Gears and Spindle speeds
*********************************
*
* numgears,min_rpm1,maxrpm1,usermax1,min_rpm2,max_rpm2,usermax2,....
%DATA3=1,0,1200,24000,0
*Scodes - steps,smin1,smax1,smin2,smax2,.....
%DATA4=0,0,0

*** Start/End macros

%PROCEDURE=NC_Style
*
*						*************************************************************
*						*	Template Dependant Language extensions for Code Wizard	*
*						*************************************************************
*
*************************************************
*	Tab Name 	:	General G-Codes
*************************************************
;Setvar^DATA1(!RAPIDGCODE)^0.0^<1>G-Codes^REAL^<2>Rapid Traverse^-1
;Setvar^DATA1(!FEEDGCODE)^1^<1>G-Codes^REAL^<3>Linear Interpolation^-1

;Setvar^DATA1(!CIRCGCODE)^2^<1>G-Codes^REAL^<4>Circular Interpolation (CLW)^-1
;Setvar^DATA1(!CIRCGCODE+1)^3^<1>G-Codes^REAL^<5>Circular Interpolation (CCLW)^-1

;Setvar^DATA1(!DWELLGCODE)^4^<1>G-Codes^REAL^<6>Dwell^-1

;Setvar^DATA1(!EXACTGCODE)^9^<1>G-Codes^REAL^<7>Exact Stop^-1
;Setvar^DATA1(!EXACTGCODE-1)^#FUNNY^<1>G-Codes^REAL^<1774>Exact Stop Cancel^-1

;Setvar^DATA1(!PLANEGCODE)^17^<1>G-Codes^REAL^<513>XY Plane^-1
;Setvar^DATA1(!PLANEGCODE+1)^18^<1>G-Codes^REAL^<514>XZ Plane^-1
;Setvar^DATA1(!PLANEGCODE+2)^19^<1>G-Codes^REAL^<515>YZ Plane^-1

;Setvar^DATA1(!UNITSGCODE)^20^<1>G-Codes^REAL^<1621>Inch^-1
;Setvar^DATA1(!UNITSGCODE+1)^21^<1>G-Codes^REAL^<9>Metric^-1

;Setvar^DATA1(!COMPGCODE)^40^<1>G-Codes^REAL^<516>Cutter Compensation (Off)^-1
;Setvar^DATA1(!COMPGCODE+1)^41^<1>G-Codes^REAL^<517>Cutter Compensation (Left)^-1
;Setvar^DATA1(!COMPGCODE+2)^42^<1>G-Codes^REAL^<518>Cutter Compensation (Right)^-1

;Setvar^DATA1(!ABSINCRGCODE)^90^<1>G-Codes^REAL^<13>Absolute Coordinates^-1
;Setvar^DATA1(!ABSINCRGCODE+1)^91^<1>G-Codes^REAL^<14>Incremental Coordinates^-1

;Setvar^DATA1(!FEEDMODEGCODE)^94^<1>G-Codes^REAL^<15>Feed / Minute^-1
;Setvar^DATA1(!FEEDMODEGCODE+1)^95^<1>G-Codes^REAL^<16>Feed / Revolution^-1
*************************************************
*	Tab Name 	:	Hole Cycle G-Codes
*************************************************
;Setvar^DATA1(!DRILLGCODE)^80^<26>Hole Cycle G-Codes^REAL^<519>Cancel Canned Cycle^-1
;Setvar^DATA1(!DRILLGCODE+1)^81^<26>Hole Cycle G-Codes^REAL^<27>Drill Cycle^-1
;Setvar^DATA1(!DRILLGCODE+2)^82^<26>Hole Cycle G-Codes^REAL^<520>Counterbore Cycle^-1
;Setvar^DATA1(!DRILLGCODE+3)^83^<26>Hole Cycle G-Codes^REAL^<99>Peck Drill Cycle^-1
;Setvar^DATA1(!DRILLGCODE+4)^84^<26>Hole Cycle G-Codes^REAL^<521>Tapping Cycle (Right Hand)^-1
;Setvar^DATA1(!DRILLGCODE+7)^84.1^<26>Hole Cycle G-Codes^REAL^<522>Tapping Cycle (Left Hand)^-1
;Setvar^DATA1(!DRILLGCODE+5)^85^<26>Hole Cycle G-Codes^REAL^<102>Ream / Bore Cycle^-1
;Setvar^DATA1(!DRILLGCODE+6)^86^<26>Hole Cycle G-Codes^REAL^<104>Bore Cycle^-1
;Setvar^DATA1(!CHIPBREAKGCODE)^73^<26>Hole Cycle G-Codes^REAL^<108>Chipbreak Drill Cycle^-1
;Setvar^DATA1(!RETRACTGCODE)^98^<26>Hole Cycle G-Codes^REAL^<523>Return to Initial level^-1
;Setvar^DATA1(!RETRACTGCODE+1)^99^<26>Hole Cycle G-Codes^REAL^<524>Return to Rplane^-1


*************************************************
*	Tab Name 	:	Datum G-Codes
*************************************************

;Setvar^DATA1(!PRESETGCODE)^92^<34>Datum G-Codes^REAL^<525>Max Rpm / Preset Registers^-1

;Setvar^DATA1(!WORKGCODE)^53^<34>Datum G-Codes^REAL^<36>Machine Coord System^-1
;Setvar^DATA1(!WORKGCODE+1)^54^<34>Datum G-Codes^REAL^<37>Work Coord System 1^-1
;Setvar^DATA1(!WORKGCODE+2)^55^<34>Datum G-Codes^REAL^<38>Work Coord System 2^-1
;Setvar^DATA1(!WORKGCODE+3)^56^<34>Datum G-Codes^REAL^<39>Work Coord System 3^-1
;Setvar^DATA1(!WORKGCODE+4)^57^<34>Datum G-Codes^REAL^<40>Work Coord System 4^-1
;Setvar^DATA1(!WORKGCODE+5)^58^<34>Datum G-Codes^REAL^<41>Work Coord System 5^-1
;Setvar^DATA1(!WORKGCODE+6)^59^<34>Datum G-Codes^REAL^<42>Work Coord System 6^-1

;Setvar^DATA1(!SETTOOLGCODE)^10^<34>Datum G-Codes^REAL^<43>Set Tool Data^-1

********************************************
*	Tab Name 	:		M-Codes
********************************************
;Setvar^DATA2(!STOPMCODE)^0.0^<44>M-Codes^REAL^<45>Program Stop^-1
;Setvar^DATA2(!STOPMCODE+1)^1^<44>M-Codes^REAL^<46>Optional Stop^-1

;Setvar^DATA2(!SPINMCODE)^3^<44>M-Codes^REAL^<47>Spindle CLW^-1
;Setvar^DATA2(!SPINMCODE+1)^4^<44>M-Codes^REAL^<48>Spindle CCLW^-1
;Setvar^DATA2(!SPINMCODE+2)^5^<44>M-Codes^REAL^<49>Spindle Stop^-1
;Setvar^DATA2(!SPINCOOLMCODE)^13^<44>M-Codes^REAL^<50>Spindle CLW with coolant^-1
;Setvar^DATA2(!SPINCOOLMCODE+1)^14^<44>M-Codes^REAL^<51>Spindle CCLW with coolant^-1

;Setvar^DATA2(!COOLMCODE)^7^<44>M-Codes^REAL^<52>Coolant Flood^-1
;Setvar^DATA2(!COOLMCODE+1)^8^<44>M-Codes^REAL^<53>Coolant Mist^-1
;Setvar^DATA2(!COOLMCODE+2)^9^<44>M-Codes^REAL^<54>Coolant Off^-1
;Setvar^DATA2(!SUBPROGMCODE)^98^<44>M-Codes^REAL^<69>Subprogram Call^-1
;Setvar^DATA2(!SUBPROGMCODE+1)^99^<44>M-Codes^REAL^<70>Subprogram End^-1

;Setvar^DATA2(!GEARMCODE)^41^<44>M-Codes^REAL^<71>Gear 1^-1
;Setvar^DATA2(!GEARMCODE+1)^42^<44>M-Codes^REAL^<72>Gear 2^-1
;Setvar^DATA2(!GEARMCODE+2)^43^<44>M-Codes^REAL^<73>Gear 3^-1
;Setvar^DATA2(!GEARMCODE+3)^44^<44>M-Codes^REAL^<74>Gear 4^-1

%ENDM
;                                                           Ŀ
;Ĵ Macro = 51  
;                                                           
%MACRO=START
$MACHINE=FANUC
*	Initialisation system and user defined variables
STARTSUB=0:ENDSUB=0
#TRUE=1:#FALSE=0:#RIGHT=0:#LEFT=1
XYPLANE=0:#FIRSTIME=1:#FUNNY=9989999000000:#PI=3.141593
#CURPLANE=0:#ABS=#FUNNY:#CONARC=0
#CANCELCOMP=#TRUE						;	Cutter Radius Comp off on Start-up
#INCRXYZHOLD=#FALSE											;	Needed to reset G90 for Incr Subs (See SUBEND)
#G18SWAP=#FALSE:#G19SWAP=#FALSE
#ZTOOLSUB=0:#PLANEGCODE=DATA1(13)
#TOOLCOUNT=0
#WARNCOUNT=0
*
TRUEARCOP=1

*
*	Retrieve from MM & MT lines
#MAXTOOLS1=32
#COMPFACTOR=1.5
*
#AUTOGEAR=#TRUE
#EXACTSTOP=1															;	Exact positioning off by default
#FEEDMODEGCODE=DATA1(45)

#G81CYCLE=#TRUE
*	To avoid call in Procmill.cgi
#G54FROMHOME=#FALSE
*
********************************************
*	Tab Name 	:		Program Defaults
********************************************
;Setvar^#DIRECTION^1^<778>Program Defaults^LIST^<127>Spindle Direction^1^<854>^Forward (CLW)^Reverse (CCLW)^Stop^CLW + Coolant^CCLW + Coolant^^-1
#DIRECTION=1
;Setvar^#COOL^1^<778>Program Defaults^LIST^<425>Coolant^1^<780>^Flood^Mist^Off^^-1
#COOL=1
*
*************************************************
*	Tab Name 	:		NC File General			*
*************************************************
;Setvar^NUMBLOCKS^#FUNNY^<383>NC File General^INT^<558>Max Program Size (Blocks)^-1
NUMBLOCKS=#FUNNY
;Setvar^NUMCHARS^#FUNNY^<383>NC File General^INT^<559>Max Program Size (Characters)^-1
NUMCHARS=#FUNNY
;Setvar^#LEADER^#FUNNY^<383>NC File General^INT^<386>Punch Tape Leader (Nulls)^-1
#LEADER=#FUNNY

;Setvar^#INCHINCR^0.0000254^<383>NC File General^REAL^<387>Minimum movement Inches^-1
#INCHINCR=0.0000254
;Setvar^#MMINCR^0.001^<383>NC File General^REAL^<388>Minimum movement millimetres^-1
#MMINCR=0.001

;Setvar^#INCRXYZ^0^<383>NC File General^LIST^<389>Coordinate Mode^0^<1552>^Absolute^Incremental^Run Time Switch^^-1
#INCRXYZ=0
;Setvar^#XREVERSE^0^<383>NC File General^YESNO^<391>Reverse X Axis^-1
#XREVERSE=0
;Setvar^#YREVERSE^0^<383>NC File General^YESNO^<560>Reverse Y Axis^-1
#YREVERSE=0
;Setvar^#ZREVERSE^0^<383>NC File General^YESNO^<561>Reverse Z Axis^-1
#ZREVERSE=0
;Setvar^#TLOCOMP^0^<383>NC File General^YESNO^<562>Compensate Z for Tool Gauge Length^-1
#TLOCOMP=0

;Setvar^MACRONAMEOP^0^<383>NC File General^YESNO^<1255>Generate Macro Calls Trace^-1
MACRONAMEOP=0
;Setvar^$CONDEBUG^0^<383>NC File General^YESNO^<395>Generate Code Constructor Trace^-1
$CONDEBUG=0
%IF $CONDEBUG=0 %THEN $CONDEBUG=N
;Setvar^#PROCTRACE^0^<383>NC File General^YESNO^<1330>Generate Procedures Trace^-1
#PROCTRACE=0
;Setvar^#TMP2^0^<383>NC File General^YESNO^<1391>List NC Code^-1
#TMP2=0
%IF #TMP2=0 %THEN SILENT=1
;Setvar^TEXTCASE^0^<383>NC File General^LIST^<1797>Text Case Output^0^<1798>^Leave as Input^Force UPPER case^Force lower case^^-1
TEXTCASE=0

****************************************************************
*   Tab Name    :      Setup Sheet
****************************************************************
;Setvar^#TOOLSHEET^1^<1714>Set Up Sheet^LIST^<393>Output Set-up Sheet^1^<784>^With NC program^Separate File^None^^-1
#TOOLSHEET=1
;Setvar^$NAME^Setup^<1714>Set Up Sheet^STRING^<394>Set-Up / Tooling Sheet Append Name^-1
$NAME=Setup
;Setvar^#SETUPHEAD^0^<1714>Set Up Sheet^YESNO^<1715>Output Setup Header / Trailer^-1
#SETUPHEAD=0
;Setvar^#REMOVEDUPLICATES^0^<1714>Set Up Sheet^YESNO^<783>Suppress Duplicate Tools (Tooling Sheet / List)^-1
#REMOVEDUPLICATES=0

*************************************************
*	Tab Name 	:		Block Numbers
*************************************************
;Setvar^#BNUM^10^<397>Block Numbers^INT^<325>Block Number Start^-1
#BNUM=10
;Setvar^#BNUMINC^1^<397>Block Numbers^INT^<398>Block Number Increment^-1
#BNUMINC=1
;Setvar^#USEBNUM^1^<397>Block Numbers^YESNO^<399>Output Block Numbers^-1
#USEBNUM=1
;Setvar^#MAXTMP^999999^<397>Block Numbers^INT^<1392>Max Block Number (If reset required)^-1
#MAXTMP=999999
%IF #USEBNUM=0 @NOMAX
%IF #MAXTMP>0 %THEN #USEBNUM=#MAXTMP ; Reset level for numbering
@NOMAX
;Setvar^#ONLYSBNUM^0^<397>Block Numbers^YESNO^<400>Output Safe/Toolchange Block Numbers only^-1
#ONLYSBNUM=0
;Setvar^#SBNUMPOSITION^0^<397>Block Numbers^YESNO^<401>Safe/Toolchange Block Numbers as Tool Position^-1
#SBNUMPOSITION=0
;Setvar^#RESTARTSUBSBNUM^0^<397>Block Numbers^YESNO^<402>Restart Block Numbering in Sub Programs^-1
#RESTARTSUBSBNUM=0


*************************************************
*	Tab Name 	:		Rapid Traverse
*************************************************
;Setvar^#FEEDRAPIDS^0^<2>Rapid Traverse^YESNO^<403>Convert All Rapids to Feedmoves at Highfeed^-1
#FEEDRAPIDS=0
;Setvar^#RAPIDFEEDRATE^5000^<2>Rapid Traverse^REAL^<565>Highfeed (units/min.)^-1
#RAPIDFEEDRATE=5000
;Setvar^#RAPDIST^0.0^<2>Rapid Traverse^REAL^<405>Convert to Feedmoves if less than ..^-1
#RAPDIST=0.0

*************************************************
*	Tab Name 	:		Circular Interpolation
*************************************************
;Setvar^CIRCLE^0^<406>Circular Interpolation^YESNO^<567>Single Quadrant Interpolation^-1
CIRCLE=0
;Setvar^#THREADSINGLE^0^<406>Circular Interpolation^YESNO^<1633>Thread Mill Single Block^-1
#THREADSINGLE=0
;Setvar^#ARCTYPE^1^<406>Circular Interpolation^LIST^<407>Arc Centre type when IJK^1^<855>^Signed Start to Centre^Signed Centre to Start^Unsigned Start / Centre^Centre^^-1
#ARCTYPE=1
;Setvar^#USERADS^1^<406>Circular Interpolation^YESNO^<408>Use Radius when possible^-1
#USERADS=1
;Setvar^#FULLARCXYZ^1^<406>Circular Interpolation^YESNO^<2119>Force XYZ Output on Full Circle^-1
#FULLARCXYZ=1
;Setvar^#ADJARCFEED^1^<406>Circular Interpolation^YESNO^<568>Adjust Feedrate to Side of tool^-1
#ADJARCFEED=1
;Setvar^#G18SWAP^0^<406>Circular Interpolation^YESNO^<914>Reverse CLW/CCLW codes for XZ plane^-1
#G18SWAP=0
;Setvar^#G19SWAP^0^<406>Circular Interpolation^YESNO^<915>Reverse CLW/CCLW codes for YZ plane^-1
#G19SWAP=0
;Setvar^#MINFEEDADJ^25^<406>Circular Interpolation^INT^<569>Adjust Feedrate Maximum Decrease (%)^-1
#MINFEEDADJ=25
;Setvar^#MAXFEEDADJ^25^<406>Circular Interpolation^INT^<570>Adjust Feedrate Maximum Increase (%)^-1
#MAXFEEDADJ=25

*************************************************
*	Tab Name 	:		Cutter Compensation
*************************************************
;Setvar^#REGOFFSET^#FUNNY^<411>Cutter Compensation^REAL^<571>Start Register Numbering at ...^-1
#REGOFFSET=#FUNNY
;Setvar^#AUTOREG^1^<411>Cutter Compensation^LIST^<1808>CRC Register Number^1^<967>^Max Tools + Turret Position^Turret Position^Max Tools + Tool Count^^-1
#AUTOREG=1
;Setvar^#WARNCRC^0^<411>Cutter Compensation^YESNO^<413>Warn if Cutter Compensation used^-1
#WARNCRC=0
;Setvar^#WARNCRC90^0^<411>Cutter Compensation^YESNO^<414>Warn if Lead In not at 90 degrees^-1
#WARNCRC90=0
;Setvar^#CRCONZ2^0^<411>Cutter Compensation^YESNO^<1809>Warn if CRC applied on ramp^-1
#CRCONZ2=0
;Setvar^#CRCONZ1^0^<411>Cutter Compensation^YESNO^<1810>Warn if CRC Cancelled with Z move^-1
#CRCONZ1=0
;Setvar^#WARNCRCARC^1^<411>Cutter Compensation^YESNO^<1653>Warn if CRC changes on arc move^-1
#WARNCRCARC=1
;Setvar^#AUTOTLO^2^<411>Cutter Compensation^LIST^<1811>TLO Register Number^1^<967>^Max Tools + Turret Position^Turret Position^Max Tools + Tool Count^^-1
#AUTOTLO=2

*************************************************
*	Tab Name 	:		Hole Cycles
*************************************************
;Setvar^#BOREOFFSETMM^0.25^<415>Hole Cycles^REAL^<572>Fine Bore stand-off distance (MM)^-1
#BOREOFFSETMM=0.25
;Setvar^#BOREOFFSETINCH^0.010^<415>Hole Cycles^REAL^<573>Fine Bore stand-off distance (INCH)^-1
#BOREOFFSETINCH=0.010
;Setvar^#ZRABSINCR^1^<415>Hole Cycles^LIST^<416>Cycle Z depth^1^<787>^Absolute^Incremental signed^Incremental unsigned^^-1
#ZRABSINCR=1
;Setvar^#SUPPORTG98G99^1^<415>Hole Cycles^YESNO^<857>Support G98/G99^-1
#SUPPORTG98G99=1
;Setvar^#SUPPORTMDEPTH^1^<415>Hole Cycles^YESNO^<1618>Support Multi Depth Cycles?^-1
#SUPPORTMDEPTH=1

;Setvar^#PREPOSITION^0^<415>Hole Cycles^YESNO^<1775>Move to position before cycle^-1
#PREPOSITION=0
;Setvar^#CYCLEPOINTS^2^<415>Hole Cycles^LIST^<1776>Calls Hole Cycle Points^1^<1777>^None^Except First^All^^-1
#CYCLEPOINTS=2

;Setvar^#EXPANDG81^0^<415>Hole Cycles^YESNO^<1764>Drill Cycles Always Longhand^-1
#EXPANDG81=0
;Setvar^#EXPANDG82^0^<415>Hole Cycles^YESNO^<1765>Counterbore Cycles Always Longhand^-1
#EXPANDG82=0
;Setvar^#EXPANDG83^0^<415>Hole Cycles^YESNO^<1766>Peck Drill Cycles Always Longhand^-1
#EXPANDG83=0
;Setvar^#EXPANDG85^0^<415>Hole Cycles^YESNO^<1767>Ream Cycles Always Longhand^-1
#EXPANDG85=0
;Setvar^#EXPANDG86^0^<415>Hole Cycles^YESNO^<1768>Bore Cycles Always Longhand^-1
#EXPANDG86=0
;Setvar^#EXPANDG87^0^<415>Hole Cycles^YESNO^<1769>Chipbreak Cycles Always Longhand^-1
#EXPANDG87=0

;Setvar^#TAPERWARN^1^<415>Hole Cycles^YESNO^<3395>Warn for Helical Taper Thread Mill^-1
#TAPERWARN=1
;Setvar^#SUBWARN^1^<415>Hole Cycles^YESNO^<3396>Warn for Subroutines with Longhand Hole Cycles^-1
#SUBWARN=1

;SetController^9^1^<415>Hole Cycles^<574>Subroutine Drill / CounterBore / Peck Drill Cycle Co-ordinates ?
;SetController^10^1^<415>Hole Cycles^<575>Subroutine Chipbreak Cycle Co-ordinates?
;SetController^11^1^<415>Hole Cycles^<576>Subroutine Ream Bore Cycle Co-ordinates?
;SetController^12^1^<415>Hole Cycles^<577>Subroutine Bore Cycle Co-ordinates?
;SetController^13^1^<415>Hole Cycles^<578>Subroutine Tapping Cycle Co-ordinates?

*************************************************
*	Tab Name 	:		Subroutines
*************************************************
;Setvar^#SUBNOSTART^#FUNNY^<417>Subroutines^INT^<579>Start Subroutine Program Numbers (blank = Progid)^-1
#SUBNOSTART=#FUNNY
;Setvar^#INCRSUBNUMBER^#FUNNY^<417>Subroutines^INT^<580>Increment Subroutine Program Numbers by ...^-1
#INCRSUBNUMBER=#FUNNY
;Setvar^#INCRSUBS^0^<417>Subroutines^YESNO^<598>Incremental Subroutines Co-ordinates^-1
#INCRSUBS=0
;Setvar^#FORCEFEED^0^<417>Subroutines^YESNO^<1812>Force Feed Output at Start^-1
#FORCEFEED=0
;SetController^32^1^<417>Subroutines^<581>Output Subroutines for Translate ?
;SetController^35^1^<417>Subroutines^<582>Output Subroutines for Repeat (Peck) ?

*************************************************
*	Tab Name 	:		Tool Change
*************************************************
;Setvar^#TOOLRAPWARN^1^<1622>Tool Change^YESNO^<1631>Warn if no Rapid to Tool Change^-1
#TOOLRAPWARN=1
;Setvar^#TOOLZWARN^0^<1622>Tool Change^YESNO^<1632>Warn if not at Tool Change Z^-1
#TOOLZWARN=0
;Setvar^#REFSHIFT^0^<1622>Tool Change^LIST^<1813>Values of ToolChange Home^0^<1814>^Machine Datum Coords^Current CPL Coords^^-1
#REFSHIFT=0


*******************************************************************************************
*	Modal Variables
;Setmodal^#GCODE^1^Modal^G-Codes
%OUTPUT-IF-CHANGED=#GCODE
;Setmodal^#MCODE^1^Modal^M-Codes
%OUTPUT-IF-CHANGED=#MCODE
;Setmodal^#XMOVE^1^Modal^X Axis Coordinates
%OUTPUT-IF-CHANGED=#XMOVE
;Setmodal^#YMOVE^1^Modal^Y Axis Coordinates
%OUTPUT-IF-CHANGED=#YMOVE
;Setmodal^#ZMOVE^1^Modal^Z Axis Coordinates
%OUTPUT-IF-CHANGED=#ZMOVE
;Setmodal^#IVALUE^0^Modal^Arc I Coordinates
;Setmodal^#JVALUE^0^Modal^Arc J Coordinates
;Setmodal^#KVALUE^0^Modal^Arc K Coordinates
;Setmodal^#RADIUS^0^Modal^Arc Radius
;Setmodal^#PLANEGCODE^1^Modal^XY / XZ / YZ Plane
%OUTPUT-IF-CHANGED=#PLANEGCODE
;Setmodal^#SPEED^1^Modal^Spindle Speed
%OUTPUT-IF-CHANGED=#SPEED
;Setmodal^#DIRECTION^1^Modal^Spindle Direction
%OUTPUT-IF-CHANGED=#DIRECTION
;Setmodal^#COOL^1^Modal^Coolant
%OUTPUT-IF-CHANGED=#COOL
;Setmodal^#FEED^1^Modal^Feedrates
%OUTPUT-IF-CHANGED=#FEED
;Setmodal^#HCODE^1^Modal^Tool Length Offset
%OUTPUT-IF-CHANGED=#HCODE
;Setmodal^#COMPGCODE^1^Modal^Cutter Compensation G-Code
%OUTPUT-IF-CHANGED=#COMPGCODE
;Setmodal^#COMPDCODE^1^Modal^Cutter Compensation Register
%OUTPUT-IF-CHANGED=#COMPDCODE
;Setmodal^#CYCLEGCODE^1^Modal^Hole Cycle G-Codes
%OUTPUT-IF-CHANGED=#CYCLEGCODE
;Setmodal^#RETRACTGCODE^1^Modal^Hole Cycle Return to Rplane
%OUTPUT-IF-CHANGED=#RETRACTGCODE
;Setmodal^DWELL^1^Modal^Dwell Time
%OUTPUT-IF-CHANGED=DWELL
;Setmodal^#RPLANE^1^Modal^Hole Cycle - Rplane
%OUTPUT-IF-CHANGED=#RPLANE
;Setmodal^ZCLEAR^0^Modal^Hole Cycle - Zclear
;Setmodal^#DEPTH^1^Modal^Hole Cycle Peck Depth
%OUTPUT-IF-CHANGED=#DEPTH
;Setmodal^#DEGR^1^Modal^Hole Cycle Degression
%OUTPUT-IF-CHANGED=#DEGR
;Setmodal^#BOREOFFSET^1^Modal^Hole Cycle Bore Stand Off distance
%OUTPUT-IF-CHANGED=#BOREOFFSET
;Setmodal^#FEEDMODEGCODE^1^Modal^Fpr/Fpm G-Code
%OUTPUT-IF-CHANGED=#FEEDMODEGCODE
;Setmodal^#ABSINC^1^Modal^Absolute/Incremental Coords Code
%OUTPUT-IF-CHANGED=#ABSINC
;Setmodal^#EXACTGCODE^0^Modal^Exact Stop


%CALL=PT_DEFAULTS						;	Set up defaults depending on Program Defaults Tab

*
*	Not configurable by the Code Wizard
*
%OUTPUT-IF-CHANGED=STARTSUB,ENDSUB			;	Nescessary since can be included in cycle line
*********************************************************************************************


#BNUM=#BNUM-#BNUMINC:#SBNUM=#BNUM						; so that first increment is the user's start number
%IF #USEBNUM=#FALSE %THEN %DONT-OUTPUT=#BNUM,#SBNUM		; suppress both block and safestart blocks
%IF #ONLYSBNUM=#TRUE %THEN %DONT-OUTPUT=#BNUM  			; suppress Blocknum if toolchange only

********************************************************************************************
*

%IF UNIT=0 %THEN #UNITSGCODE=DATA1(16) %ELSE #UNITSGCODE=DATA1(17)

%IF MASK=1 %THEN #BNUMVAR=0 %ELSE #BNUMVAR=#BNUMINC		;	supress block no. increment when processing subroutines

%IF UNIT=0 %THEN #INCR=#INCHINCR %ELSE #INCR=#MMINCR	;	set smallest machine movement depending on NC Pogram units
*PRECISION=#INCR-(#INCR/100)		;	Set compiler to work to one digit less than machine minimum
PRECISION=#INCR/2
%CALL=FIND_PRECISION

%IF UNIT=0 %THEN RESOLUTION=#INCHINCR %ELSE RESOLUTION=#MMINCR ; Used for Arc bulge checking
%IF #USERADS=0 %THEN NOBULGECORRECTION=1 ; Suppress correction if IJK arcs
%IF CIRCLE=1 %THEN NOBULGECORRECTION=1 ; Suppress correction if single quadrant arcs

%IF UNIT=0 %THEN #BOREOFFSET=#BOREOFFSETINCH %ELSE #BOREOFFSET=#BOREOFFSETMM	;	Bore Cycle Stand Off amount depending on units
#BOREOFFSETHOLD=#BOREOFFSET

#MINFEEDADJ=1-(#MINFEEDADJ/100)					;	Convert from % to decimal
#MAXFEEDADJ=(#MAXFEEDADJ/100)+1					;	Convert from % to decimal

%IF #RAPDIST=#FUNNY %THEN #RAPDIST=0			;	cater for input for convert moves less than ... being zero or unset

#PECKREVERSE=1


%IF #INCRXYZ<>2 @RUNTIME1
%OPTIONS=Coordinate Mode^Absolute^Incremental=#INCRXYZ
#INCRXYZ=#INCRXYZ-1
*  Note  #incrxyz is current abs/inc setting
*        #incrxyzhold is main program setting
*        #incrsubs is subroutine setting
@RUNTIME1

%IF #TOOLSHEET<>3 %THEN %CALL=SET_UP_SHEET

%CALL=PT_CHECK_AXIS_REVERSE ; Check for reversed axes

%CALL=PT_INIT_POSITION ; Set initial position, Hold values etc

%IF #INCRXYZ=#TRUE %THEN #ABSINC=DATA1(48) %ELSE #ABSINC=DATA1(47)
#INCRXYZHOLD=#INCRXYZ
*
*	*****************************************
*	*	Tab Name	:	Program Start		*
*	*****************************************
*
*	Note ! Cannot be a procedure because %SUBROUTINE must be defined in the START or END macros
*
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Program Start	*****>
@NO_CON-DEBUG

;Sequence Definition^<434>Program Start^-1^<899>NC Program General^
;Use Tokens^DELETE^BLKNUM^ABS-INC^XHOME^YHOME^ZHOME^COOLANT OFF^UNITSGCODE^PROGID^SUBROUTINES^PLANEGCODE^PROGDESCR^TIME^DATE^UKDATE^DAY^MONTH^YEAR^PROGRAMMER^PROGVERSION^MANREADABLE^LEADER^MACHINENAME^PARTNAME^SEQUENCENAME^CYCLETIME^JM-DESC^JM-COM^JM-FAM^JM-MACH^JM-CUST^JM-PROG^JM-MATL^JM-REV^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^(*)
;Default Sequence^(**********************************************************************)
;Default Sequence^(* Machine Tool   : ^[MACHINENAME]^)
;Default Sequence^(* Part Name      : ^[PARTNAME]^)
;Default Sequence^(* Sequence       : ^[SEQUENCENAME]^)
;Default Sequence^(* Programmed By  : J.S.)
;Default Sequence^(* Date           : ^[DATE]^)
;Default Sequence^(* Time           : ^[TIME]^)
;Default Sequence^(*)
;Default Sequence^(* Celkov as programu vetn vmny nstroj : ^[CYCLETIME]^ Minutes)
;Default Sequence^(**********************************************************************)
;Default Sequence^(*^[PROGID]^)
;Default Sequence^(^[PROGDESCR]^)
;Default Sequence^[DELETE]^[BLKNUM]^[UNITSGCODE]^ G90 G91.1 G40
<(*)>
<(**********************************************************************)>
<(* Machine Tool   : [MACHINENAME])>
<(* Part Name      : [PARTNAME])>
<(* Sequence       : [SEQUENCENAME])>
<(* Programmed By  : J.S.)>
<(* Date           : [DATE])>
<(* Time           : [TIME])>
<(*)>
<(* Celkov as programu vetn vmny nstroj : [MACHTIME1=24] Minutes)>
<(**********************************************************************)>
%CALL=PT_ASK_PROGID
<(*[#PROGID=13])>
%CALL=PT_ASK_PROGDESCR
<([$DESCR])>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#UNITSGCODE=19] G90 G91.1 G40>



%CALL=SET_TOOLING_DATA

%CALL=SET_WORK_DATUMS



%IF #SUBNOSTART=#FUNNY %THEN #SUBNOSTART=#PROGID	; If user has not specified subroutine start number, use Progid+1 etc.
*$DEBUG=Y
%ENDM


*****************************************************************************************************************
%PROCEDURE=SPLINE
%IF #PROCTRACE=1 %THEN $PROCEDURE=SPLINE:%CALL=ENTER_PROCEDURE

%IF SUBFUNCT=1 %THEN %CANCEL=#CYCLEGCODE,#ORDER
#CYCLEGCODE=6.2
#KNOT=FIELD2
#WEIGHT=FIELD3
#ORDER=FIELD1
%OUTPUT-IF-CHANGED=#ORDER

%CALL=CODECON_SPLINE-PARAMETER
%CANCEL=#GCODE
%IF #PROCTRACE=1 %THEN %CALL=EXIT_PROCEDURE
%ENDM

;                                                           Ŀ
;Ĵ Macro = 58  
;                                                           
%MACRO=END
*	Note ! Cannot be a procedure because %SUBROUTINE must be defined in the START or END macros
$SPC=" "; Reset trace spacing
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Program End	*****>
@NO_CON-DEBUG


#XMOVE=XHOME:#YMOVE=YHOME:#ZMOVE=ZHOME
%IF #TLOCOMP=#TRUE %THEN %CALL=PT_COMPENSATE_TLO
%CALL=PT_SET_PRECISION
%IF #INCRXYZ=#TRUE %THEN %CALL=PT_INCREMENTAL_XYZ
%IF #AXISREVERSE=#TRUE %THEN %CALL=PT_REVERSE_XYZ
#XHOLD=XHOME:#YHOLD=YHOME:#ZHOLD=ZHOME						;	 Necessary for incremental output

;Sequence Definition^<435>Program End^-1^<899>NC Program General^
;Use Tokens^DELETE^BLKNUM^G28ZBlock^G28XYBlock^RAPIDGCODE^XHOME^YHOME^ZHOME^COOLANT OFF^FIRSTTOOL^SUBROUTINES^PROGDESCR^TIME^DATE^UKDATE^DAY^MONTH^YEAR^PROGRAMMER^PROGVERSION^PROGID^MACHINENAME^PARTNAME^SEQUENCENAME^CYCLETIME^WARNCOUNT^JM-DESC^JM-COM^JM-FAM^JM-MACH^JM-CUST^JM-PROG^JM-MATL^JM-REV^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[G28ZBlock]
;Default Sequence^[DELETE]^[BLKNUM]^ M30
;Default Sequence^%
;Default Sequence^[SUBROUTINES]
;Default Sequence^[WARNCOUNT]
%CALL=CODECON_G28ZBlock
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] M30>
<%>
%SUBROUTINE
%CALL=PT_WARNING_COUNT



%ENDM
;                                                           Ŀ
;Ĵ Macro = HIGH SPEED   
;                                                           
%MACRO=110=../..=High Speed M/c=69[0.01],=Off/On
$SPC=" "; Reset trace spacing
*%IF SUBFUNCT=2 %THEN #HIGHSPEED=#TRUE:%CALL=CODECON_HIGHSPEED-ON %ELSE #HIGHSPEED=#FALSE:%CALL=CODECON_HIGHSPEED-OFF
%IF SUBFUNCT=2 %THEN %CALL=CODECON_HIGHSPEED-ON %ELSE %CALL=CODECON_HIGHSPEED-OFF
%ENDM
;
; workaround for rigid tapping until ;MACHINE implemented
%MACRO=9=DR=Drill cycle=4,6,7,9,10,23,21,27,28,29,50,53|176,70,200,201,67,69,
$SPC=" "; Reset trace spacing
%CALL=DRILL-CYCLE
%ENDM
;
%MACRO=10=CB=Chip break cycle=4,6,7,9,10,23,21,27,28,29,50,53|176,70,200,201,67,69,
$SPC=" "; Reset trace spacing
%CALL=CHIPBREAK-CYCLE
%ENDM

%MACRO=11=RE=Ream/Bore cycle=4,6,7,9,21,27,28,29,50,53|176,70,200,201,67,69,
$SPC=" "; Reset trace spacing
%CALL=REAM-CYCLE
%ENDM

%MACRO=12=BO=Bore cycle=4,6,7,9,21,27,28,29,50,53|176,70,200,201,67,69,
$SPC=" "; Reset trace spacing
%CALL=BORE-CYCLE
%ENDM

%MACRO=13=TA=Tapping cycle=4,6,7,9,21,27,28,29,70,200,201,67,69,
$SPC=" "; Reset trace spacing
%CALL=TAP-CYCLE
%ENDM

*** Code constructors

* Secondary Codeconstructors, only called from other codeconstructors
*   *************************************************
*	*	Tab Name	:	G28 Z Block		*
*	*************************************************
*
%PROCEDURE=CODECON_G28ZBlock
* Procedure to output a G28 block with Z movement, using variables
* to preserve modality where appropriate
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	G28-ZBlock 	*****>
@NO_CON-DEBUG

*Set G91 mode for G28 block
#TMP=#ABSINC
#ABSINC=DATA1(48)
;Sequence Definition^<1316>G28 Z Block^-1^<1317>Secondary Code Constructors^
;Use Tokens^DELETE^BLKNUM^ABS-INC^ZTOOL^ZHOME^ZINITIAL^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:*Only used if token placed in Rapid-Home or Rapid-ToolChange
;Default Sequence^(^[DELETE]^[BLKNUM]^[ABS-INC]^ G28 Z0 H0 M19)
*Only used if token placed in Rapid-Home or Rapid-ToolChange
%CALL=PT_BINC
<([#DELETE=25][#BNUM=20][#ABSINC=19] G28 Z0 H0 M19)>


* Reset G90/1 code
#ABSINC=#TMP
%ENDM

*   *************************************************
*	*	Tab Name	:	G28 XY Block		*
*	*************************************************
**
%PROCEDURE=CODECON_G28XYBlock
* Procedure to output a G28 block with Z movement, using variables
* to preserve modality where appropriate
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	G28-XYBlock 	*****>
@NO_CON-DEBUG

*Set G91 mode for G28 block
#TMP=#ABSINC
#ABSINC=DATA1(48)
;Sequence Definition^<1318>G28 XY Block^-1^<1317>Secondary Code Constructors^
;Use Tokens^DELETE^BLKNUM^ABS-INC^XTOOL^YTOOL^XHOME^YHOME^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:*Only used if token placed in Rapid-Home or Rapid-ToolChange
;Default Sequence^(^[DELETE]^[BLKNUM]^[ABS-INC]^ G28 X0 Y0)
*Only used if token placed in Rapid-Home or Rapid-ToolChange
%CALL=PT_BINC
<([#DELETE=25][#BNUM=20][#ABSINC=19] G28 X0 Y0)>


* Reset G90/1 code
#ABSINC=#TMP
%ENDM



*   *************************************************
*	*	Tab Name	:	Set-Up / Tooling Sheet		*
*	*************************************************
%PROCEDURE=SETUP_HEADER

;Sequence Definition^<1716>Set-Up Header^-1^<899>NC Program General^
;Use Tokens^PROGID^PROGDESCR^TIME^DATE^UKDATE^DAY^MONTH^YEAR^PROGRAMMER^PROGVERSION^MANREADABLE^MACHINENAME^PARTNAME^SEQUENCENAME^CYCLETIME^JM-DESC^JM-COM^JM-FAM^JM-MACH^JM-CUST^JM-PROG^JM-MATL^JM-REV^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^This constructor is only called if selected in SET UP SHEET (NC Style) tab
;Default Sequence^_____________________________________________________________________________
;Default Sequence
;Default Sequence^                     Machine Tool Set Up Details
;Default Sequence^_____________________________________________________________________________
;Default Sequence
;Default Sequence^                    Job Description     ^[JM-DESC]
;Default Sequence^                                        ^[JM-COM]
;Default Sequence
;Default Sequence^                    Machine             ^[JM-MACH]
;Default Sequence
;Default Sequence^     Total Machining Time (including Toolchange) : ^[CYCLETIME]^ Minutes
;Default Sequence
;Default Sequence
;Default Sequence^Tools used in this program
;Default Sequence^.
<This constructor is only called if selected in SET UP SHEET (NC Style) tab>
<_____________________________________________________________________________>
< >
<                     Machine Tool Set Up Details>
<_____________________________________________________________________________>
< >
<                    Job Description     [JOBDESC]>
<                                        [JOBCOM]>
< >
<                    Machine             [JOBMACH]>
< >
<     Total Machining Time (including Toolchange) : [MACHTIME1=24] Minutes>
< >
< >
<Tools used in this program>
<.>


%ENDM
*
%PROCEDURE=SETUP_TRAILER

;Sequence Definition^<1717>Set-Up Trailer^-1^<899>NC Program General^
;Use Tokens^PROGID^PROGDESCR^TIME^DATE^UKDATE^DAY^MONTH^YEAR^PROGRAMMER^PROGVERSION^MANREADABLE^MACHINENAME^PARTNAME^SEQUENCENAME^CYCLETIME^JM-DESC^JM-COM^JM-FAM^JM-MACH^JM-CUST^JM-PROG^JM-MATL^JM-REV^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^_____________________________________________________________________________
;Default Sequence^.
;Default Sequence^                    Programmed By       ^[JM-PROG]^              Date           : ^[DATE]
;Default Sequence^ End of setup Sheet
;Default Sequence^
<_____________________________________________________________________________>
<.>
<                    Programmed By       [JOBPROG]              Date           : [DATE]>
< End of setup Sheet>


%ENDM
*
%PROCEDURE=CODECON_SET-UP-SHEET

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Set-Up / Tooling Sheet	*****>
@NO_CON-DEBUG
*
* Setup sheet header if requested (not in loop)
%IF #SETUPHEAD=1 %THEN %CALL=SETUP_HEADER
*

#HEADER=1
@HEADER              ;output header at top of cnc file
%LOAD=#HEADER

*	Remove duplicate tools from Tool Sheet
%IF #REMOVEDUPLICATES=#FALSE @MISS_REMOVE_DUPLICATES
#TMP1=#FALSE:%CALL=PT_REMOVE_DUPLICATE_TOOLS:%IF #TMP1=#TRUE @SKIP
@MISS_REMOVE_DUPLICATES

%LOAD=#HEADER

%IF TOOLUNIT=0 %THEN $UNIT=IN %ELSE $UNIT=MM

#TOOLDIA=2*TOOLRAD
%IF TOOLEN=#FUNNY %THEN TOOLEN=0				;	If Gauge Length unset then force zero

;Sequence Definition^<436>Set-Up / Tooling Sheet^-1^<899>NC Program General^
;Use Tokens^HDR-TURRETNO^TOOLDESCR^COMMENT^HDR-TOOLDIAM^TOOLTYPE^HDR-TOOLGAUGE^ZGAUGELENGTH^FLUTE^LENGTHOFFSET^CORNER^REACH^TOOLUNITS^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^(* Turret No. :^[HDR-TURRETNO]^Diameter :^[HDR-TOOLDIAM]^[TOOLUNITS]^[TOOLTYPE]^)
#TOOLDIA=TOOLRAD*2
%CALL=SET_TOOL_TYPE
<(* Turret No. :[POSITION=23]Diameter :[#TOOLDIA=24][$UNIT=5][$TYPE=10])>


@SKIP
#HEADER=#HEADER+1:%IF #HEADER<=NUMTOOLS @HEADER  ;check number of tools used

*
* Setup sheet trailer if requested (not in loop)
%IF #SETUPHEAD=1 %THEN %CALL=SETUP_TRAILER
*
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Set Tooling Data			*
*	*************************************************
*
%PROCEDURE=CODECON_SET-TOOLING-DATA

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Set Tooling Data List	*****>
@NO_CON-DEBUG

;Sequence Definition^<437>Set Tooling Data List^-1^<899>NC Program General^
;Use Tokens^DELETE^BLKNUM^SETTOOLGCODE^LOOPNUMBER^TOOLDESCR^TOOLTYPE^COMMENT^ZGAUGELENGTH^FLUTE^LENGTHOFFSET^CORNER^REACH^TOOLRADIUS^TOOLDIAM^TURRETNO^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[SETTOOLGCODE]^ L2^[LOOPNUMBER]^[TOOLRADIUS]^[TURRETNO]
%CALL=PT_BINC
#SETTOOLGCODE=DATA1(11)
<[#DELETE=25][#BNUM=20][#SETTOOLGCODE=37] L2[#HEADER=38][TOOLRAD=39][POSITION=10]>




%ENDM
*
*	*****************************************
*	*	Tab Name	:	Rapid Move			*
*	*****************************************
*
%PROCEDURE=CODECON_RAPID-MOVE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Rapid Move	*****>
@NO_CON-DEBUG

*%CANCEL=#XMOVE,#YMOVE,#ZMOVE,#FEED,#COOL
;Sequence Definition^<438>Rapid Move^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^ABS-INC^RAPIDGCODE^EXACTSTOPGCODE^XMOVE^YMOVE^ZMOVE^COOLANT ON^SPEED^FEED^WORKGCODE^FEEDMODEGCODE^COMPGCODE^CRC REGISTER^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RAPIDGCODE]^[XMOVE]^[YMOVE]^[ZMOVE]^[FEED]^[COOLANT ON]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#GCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=2][#FEED=7][#COOL=18]>




;
%CALL=HOLD
%ENDM
*
*	*********************************************
*	*	Tab Name	:	Linear Interpolation	*
*	*********************************************
*
%PROCEDURE=CODECON_LINEAR-INTERPOLATION

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Linear Interpolation	*****>
@NO_CON-DEBUG

;Sequence Definition^<3>Linear Interpolation^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^ABS-INC^FEEDGCODE^EXACTSTOPGCODE^XMOVE^YMOVE^ZMOVE^COOLANT ON^COMPGCODE^CRC REGISTER^FEED^SPEED^FEEDMODEGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[COMPGCODE]^[FEEDGCODE]^[XMOVE]^[YMOVE]^[ZMOVE]^[CRC REGISTER]^[FEED]^[SPEED]^[COOLANT ON]
%CALL=PT_BINC
%CALL=PT_SPEED_SET
<[#DELETE=25][#BNUM=20][#COMPGCODE=19][#GCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=2][#COMPDCODE=12][#FEED=7][#SPEED=8][#COOL=18]>



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Circular Interpolation Clw	*
*	*************************************************
*
%PROCEDURE=CODECON_CIRCULAR-INT-CLW

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Circular Interpolation Clw	*****>
@NO_CON-DEBUG
;Sequence Definition^<439>Circular Interpolation CLW^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^ABS-INC^PLANEGCODE^CLWGCODE^EXACTSTOPGCODE^XARCEND^YARCEND^ZARCEND^IVALUE^JVALUE^KVALUE^ARCRADIUS^XCENTRE^YCENTRE^ZCENTRE^COOLANT ON^COMPGCODE^CRC REGISTER^SPEED^FEED^FEEDMODEGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[PLANEGCODE]^[COMPGCODE]^[CLWGCODE]^[XARCEND]^[YARCEND]^[ZARCEND]^[IVALUE]^[JVALUE]^[KVALUE]^[ARCRADIUS]^[FEED]^[CRC REGISTER]^[COOLANT ON]^[SPEED]
%CALL=PT_BINC
%CALL=PT_SPEED_SET
<[#DELETE=25][#BNUM=20][#PLANEGCODE=19][#COMPGCODE=19][#GCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=2][#IVALUE=3][#JVALUE=4][#KVALUE=5][#RADIUS=6][#FEED=7][#COMPDCODE=12][#COOL=18][#SPEED=8]>





%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Circular Interpolation CClw	*
*	*************************************************
*
%PROCEDURE=CODECON_CIRCULAR-INT-CCLW

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Circular Interpolation CCLw	*****>
@NO_CON-DEBUG

;Sequence Definition^<440>Circular Interpolation CCLW^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^ABS-INC^PLANEGCODE^CCLWGCODE^EXACTSTOPGCODE^XARCEND^YARCEND^ZARCEND^IVALUE^JVALUE^KVALUE^ARCRADIUS^XCENTRE^YCENTRE^ZCENTRE^COOLANT ON^COMPGCODE^CRC REGISTER^SPEED^FEED^FEEDMODEGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[PLANEGCODE]^[COMPGCODE]^[CCLWGCODE]^[XARCEND]^[YARCEND]^[ZARCEND]^[IVALUE]^[JVALUE]^[KVALUE]^[ARCRADIUS]^[FEED]^[CRC REGISTER]^[COOLANT ON]^[SPEED]
%CALL=PT_BINC
%CALL=PT_SPEED_SET
<[#DELETE=25][#BNUM=20][#PLANEGCODE=19][#COMPGCODE=19][#GCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=2][#IVALUE=3][#JVALUE=4][#KVALUE=5][#RADIUS=6][#FEED=7][#COMPDCODE=12][#COOL=18][#SPEED=8]>




%CALL=HOLD
%ENDM
*
*	*****************************************
*	*	Tab Name	:	Dwell				*
*	*****************************************
*
%PROCEDURE=CODECON_DWELL

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Dwell	*****>
@NO_CON-DEBUG

;Sequence Definition^<6>Dwell^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^DWELLGCODE^DWELLTIME^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[DWELLGCODE]^[<C>DWELLTIME]
%CALL=PT_BINC
%CANCEL=DWELL
<[#DELETE=25][#BNUM=20][#DWELLGCODE=19][DWELL=9]>

%ENDM
*
*	*****************************************
*	*	Tab Name	:	Cutter Compensation	*
*	*****************************************
*
%PROCEDURE=CODECON_CUTTER-COMPENSATION

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Cutter Compensation	*****>
@NO_CON-DEBUG

;Sequence Definition^<411>Cutter Compensation^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^EXACTSTOPGCODE^FEEDGCODE^COMPGCODE^PLANEGCODE^CRC REGISTER^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^



; MCB - why is XMOVE and YMOVE available
%ENDM
*
*
*	*************************************************
*	*	Tab Name	:	Cancel Cutter Compensation	*
*	*************************************************
*
%PROCEDURE=CODECON_CANCEL-CUTTER-COMP

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Cancel Cutter Compensation	*****>
@NO_CON-DEBUG

;Sequence Definition^<588>Cancel Cutter Compensation^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^EXACTSTOPGCODE^FEEDGCODE^COMPGCODE^PLANEGCODE^CRC REGISTER^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^



; MCB - why is XMOVE and YMOVE available
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Drill Cycle					*
*	*************************************************
*
*
%PROCEDURE=CODECON_DRILL-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Drill Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<27>Drill Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^DRILLGCODE^XMOVE^YMOVE^ZDEPTH^RAPIDGCODE^ZCLEAR^RPLANE^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^SPINDIR^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[DRILLGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Counterbore Cycle			*
*	*************************************************
*
*
%PROCEDURE=CODECON_COUNTERBORE-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	CounterBore Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<589>CounterBore Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^SPOTGCODE^XMOVE^YMOVE^ZDEPTH^RPLANE^ZCLEAR^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^SPINDIR^CYCLEDWELLTIME^DWELLGCODE^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[SPOTGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[CYCLEDWELLTIME]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][DWELL=30][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Peck Drill Cycle			*
*	*************************************************
*
*
%PROCEDURE=CODECON_PECK-DRILL-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Peck Drill Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<99>Peck Drill Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^PECKGCODE^XMOVE^YMOVE^ZDEPTH^RPLANE^ZCLEAR^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^PECKDEPTH^DEGRESSION^SPINDIR^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[PECKGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[PECKDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#DEPTH=32][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Tapping Cycle				*
*	*************************************************
*
*
%PROCEDURE=CODECON_TAPPING-CYCLE
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Tapping Cycle Choice	*****>
@NO_CON-DEBUG

* Rigid or floating
%IF USERVAR3=2 %THEN %CALL=CODECON_RIGID_TAP-CYCLE %ELSE %CALL=CODECON_FLOAT_TAP-CYCLE

%ENDM

%PROCEDURE=CODECON_FLOAT_TAP-CYCLE
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Tapping Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<28>Tapping Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^TAPGCODE^XMOVE^YMOVE^ZDEPTH^ZCLEAR^RPLANE^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^PITCH^SPINDIR^CYCLEDWELLTIME^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[TAPGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM


%PROCEDURE=CODECON_RIGID_TAP-CYCLE
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Rigid Tapping Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<1069>Rigid Tapping Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^TAPGCODE^XMOVE^YMOVE^ZDEPTH^ZCLEAR^RPLANE^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^PITCH^SPINDIR^CYCLEDWELLTIME^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[TAPGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM

%PROCEDURE=CODECON_TAPREV_B
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Tapping Spindle Reverse (Bottom)	*****>
@NO_CON-DEBUG

;Sequence Definition^<3255>Tapping Spindle Reverse (Bottom)^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^DWELLGCODE^DWELLTIME^SPINDLE OFF^SPINDLE REV^SPEED^SPINDIR^GEARMCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[SPINDLE OFF]
;Default Sequence^[DELETE]^[BLKNUM]^[DWELLGCODE]^[<C>DWELLTIME]
;Default Sequence^[DELETE]^[BLKNUM]^[SPINDLE REV]
;TEXT^Longhand tapping spindle reverse at bottom of hole
%CALL=PT_BINC
#DIRHOLD=#DIRECTION:#DIRECTION=Data2(6)
<[#DELETE=25][#BNUM=20][#DIRECTION=18]>
#DIRECTION=#DIRHOLD
%CALL=PT_BINC
%CANCEL=DWELL
<[#DELETE=25][#BNUM=20][#DWELLGCODE=19][DWELL=9]>
%CALL=PT_BINC
%IF #DIRECTION=DATA2(5) %THEN #DIRECTION=DATA2(4) %ELSE #DIRECTION=DATA2(5)
<[#DELETE=25][#BNUM=20][#DIRECTION=18]>




@END
%ENDM


%PROCEDURE=CODECON_TAPREV_T
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Tapping Spindle Reverse (Top)	*****>
@NO_CON-DEBUG

;Sequence Definition^<3256>Tapping Spindle Reverse (Top)^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^DWELLGCODE^DWELLTIME^SPINDLE OFF^SPINDLE REV^SPEED^SPINDIR^GEARMCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[SPINDLE OFF]
;Default Sequence^[DELETE]^[BLKNUM]^[DWELLGCODE]^[<C>DWELLTIME]
;Default Sequence^[DELETE]^[BLKNUM]^[SPINDLE REV]
;TEXT^Longhand tapping spindle reverse at top of retract
%CALL=PT_BINC
#DIRHOLD=#DIRECTION:#DIRECTION=Data2(6)
<[#DELETE=25][#BNUM=20][#DIRECTION=18]>
#DIRECTION=#DIRHOLD
%CALL=PT_BINC
%CANCEL=DWELL
<[#DELETE=25][#BNUM=20][#DWELLGCODE=19][DWELL=9]>
%CALL=PT_BINC
%IF #DIRECTION=DATA2(5) %THEN #DIRECTION=DATA2(4) %ELSE #DIRECTION=DATA2(5)
<[#DELETE=25][#BNUM=20][#DIRECTION=18]>




@END
%ENDM



*
*	*************************************************
*	*	Tab Name	:	Ream / Bore Cycle			*
*	*************************************************
*
*
%PROCEDURE=CODECON_REAM-BORE-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Ream / Bore Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<102>Ream / Bore Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^REAMGCODE^XMOVE^YMOVE^ZDEPTH^RPLANE^ZCLEAR^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^SPINDIR^CYCLEDWELLTIME^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[REAMGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Bore Cycle					*
*	*************************************************
*
*
%PROCEDURE=CODECON_BORE-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Bore Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<104>Bore Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^BOREGCODE^XMOVE^YMOVE^ZDEPTH^RPLANE^ZCLEAR^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^SPINDIR^CYCLEDWELLTIME^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^BORESTANDOFF^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[BOREGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Chipbreak Cycle				*
*	*************************************************
*
*
%PROCEDURE=CODECON_CHIPBREAK-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Chipbreak Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<590>Chipbreak Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^CHIPBREAKGCODE^XMOVE^YMOVE^ZDEPTH^RPLANE^ZCLEAR^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^PECKDEPTH^DEGRESSION^SPINDIR^CYCLEDWELLTIME^RAPIDGCODE^CYCLESPEED^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[CHIPBREAKGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[PECKDEPTH]^[DEGRESSION]^[RPLANE]^[CYCLEZFEED]^[LENGTHOFFSET]^[COOLANT ON]^[CYCLESPEED]
%CALL=PT_BINC
#SPEED=SPEED:%CALL=PT_SPINDLE
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#CYCLEGCODE=26][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#DEPTH=32][#DEGR=33][#RPLANE=35][#FEED=28][#HCODE=11][#COOL=18][#SPEED=29]>




%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Hole Cycle Points			*
*	*************************************************
*
*
%PROCEDURE=CODECON_HOLE-CYCLEPOINTS

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Hole Cycle Points	*****>
@NO_CON-DEBUG

;Sequence Definition^<602>Hole Cycle Points^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^CYCLEGCODE^XMOVE^YMOVE^ZDEPTH^RAPIDGCODE^ZCLEAR^RPLANE^CYCLEZFEED^RETRACTGCODE^PLANEGCODE^FEEDMODEGCODE^LENGTHOFFSET^COOLANT ON^CYCLESPEED^N-SUBSTART^N-SUBEND^SPINDIR^CYCLEDWELLTIME^DWELLGCODE^PECKDEPTH^DEGRESSION^PITCH^BORESTANDOFF^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[RETRACTGCODE]^[XMOVE]^[YMOVE]^[ZDEPTH]^[RPLANE]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#RETRACTGCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=27][#RPLANE=35]>

;MCB - why does this include RAPIDGCODE



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Cancel Canned Cycle			*
*	*************************************************
*
*
%PROCEDURE=CODECON_CANCEL-CANNED-CYCLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Cancel Canned Cycle	*****>
@NO_CON-DEBUG

;Sequence Definition^<519>Cancel Canned Cycle^-1^<415>Hole Cycles^
;Use Tokens^DELETE^BLKNUM^ENDCYCLEGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[ENDCYCLEGCODE]
%CALL=PT_BINC
#CYCLEGCODE=DATA1(35)
<[#DELETE=25][#BNUM=20][#CYCLEGCODE=26]>


%ENDM

*
*	*****************************************
*	*	Tab Name	:	First Toolchange	*
*	*****************************************
*
%PROCEDURE=CODECON_FIRST-TOOLCHANGE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	First Toolchange	*****>
@NO_CON-DEBUG

;Sequence Definition^<444>First Toolchange^-1^<905>Toolchange^
;Use Tokens^DELETE^BLKNUM^SAFEBLKNUM^G28ZBlock^G28XYBlock^ABS-INC^TOOLDESCR^TOOLTYPE^COMMENT^TURRETNO^LENGTHOFFSET^SPEED^NEXTTOOL^COOLANT ON^COOLANT OFF^SPINDIR^WORKGCODE^FEEDMODEGCODE^XTOOL^YTOOL^ZTOOL^ZGAUGELENGTH^GEARMCODE^SETTOOLGCODE^TOOLRADIUS^TOOLDIAM^UNITSGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* G28 Tokens call complete secondary code constructors for that block
;Default Sequence^[G28ZBlock]
;Default Sequence^[G28XYBlock]
;Default Sequence^[DELETE]^[BLKNUM]^[<C>ABS-INC]
;Default Sequence^[DELETE]^[SAFEBLKNUM]^[TURRETNO]^ (^[COMMENT]^ -^[TOOLDIAM]^)
;Default Sequence^[DELETE]^[BLKNUM]^[WORKGCODE]^ M05 M9
;Default Sequence^[DELETE]^[BLKNUM]^[NEXTTOOL]^ M01
;Default Sequence^[DELETE]^[BLKNUM]^[SPEED]^ M3^[GEARMCODE]^[COOLANT ON]
* G28 Tokens call complete secondary code constructors for that block
%CALL=CODECON_G28ZBlock
%CALL=CODECON_G28XYBlock
%CALL=PT_BINC
%CANCEL=#ABSINC
<[#DELETE=25][#BNUM=20][#ABSINC=19]>
%CALL=PT_SBINC
#TOOLDIA=TOOLRAD*2
<[#DELETE=25][#SBNUM=21][POSITION=10] ([USERDEFINEDSTRING] -[#TOOLDIA=40])>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#WORKGCODE=22] M05 M9>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#NEXTTOOL=10] M01>
%CALL=PT_BINC
%CALL=PT_SPEED_SET
<[#DELETE=25][#BNUM=20][#SPEED=8] M3[#GEARMCODE=18][#COOL=18]>



%ENDM
*
*	*****************************************
*	*	Tab Name	:	General Toolchange	*
*	*****************************************
*
%PROCEDURE=CODECON_GENERAL-TOOLCHANGE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	General Toolchange	*****>
@NO_CON-DEBUG

;Sequence Definition^<445>General Toolchange^-1^<905>Toolchange^
;Use Tokens^DELETE^BLKNUM^SAFEBLKNUM^G28ZBlock^G28XYBlock^ABS-INC^TOOLDESCR^TOOLTYPE^COMMENT^TURRETNO^LENGTHOFFSET^SPEED^NEXTTOOL^COOLANT ON^COOLANT OFF^SPINDIR^WORKGCODE^FEEDMODEGCODE^XTOOL^YTOOL^ZTOOL^ZGAUGELENGTH^GEARMCODE^SETTOOLGCODE^TOOLRADIUS^TOOLDIAM^UNITSGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* G28 Tokens call complete secondary code constructors for that block
;Default Sequence^[DELETE]^[SAFEBLKNUM]^[<C>TURRETNO]^ (^[COMMENT]^ -^[TOOLDIAM]^)
;Default Sequence^[DELETE]^[BLKNUM]^[WORKGCODE]^ M05 M9
;Default Sequence^[DELETE]^[BLKNUM]^[NEXTTOOL]^ M01
;Default Sequence^[DELETE]^[BLKNUM]^[<C>ABS-INC]^[<C>SPEED]^ M3^[<C>GEARMCODE]^[<C>COOLANT ON]
* G28 Tokens call complete secondary code constructors for that block
%CALL=PT_SBINC
%CANCEL=POSITION
#TOOLDIA=TOOLRAD*2
<[#DELETE=25][#SBNUM=21][POSITION=10] ([USERDEFINEDSTRING] -[#TOOLDIA=40])>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#WORKGCODE=22] M05 M9>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#NEXTTOOL=10] M01>
%CALL=PT_BINC
%CANCEL=#ABSINC
%CALL=PT_SPEED_SET
%CANCEL=#SPEED
%CANCEL=#GEARMCODE
%CANCEL=#COOL
<[#DELETE=25][#BNUM=20][#ABSINC=19][#SPEED=8] M3[#GEARMCODE=18][#COOL=18]>



%ENDM
*
*	*****************************************
*	*	Tab Name	:	Last Toolchange		*
*	*****************************************
*
%PROCEDURE=CODECON_LAST-TOOLCHANGE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Last Toolchange	*****>
@NO_CON-DEBUG

;Sequence Definition^<591>Last Toolchange^-1^<905>Toolchange^
;Use Tokens^DELETE^BLKNUM^SAFEBLKNUM^G28ZBlock^G28XYBlock^ABS-INC^TOOLDESCR^TOOLTYPE^COMMENT^TURRETNO^LENGTHOFFSET^SPEED^FIRSTTOOL^COOLANT ON^COOLANT OFF^SPINDIR^WORKGCODE^FEEDMODEGCODE^XTOOL^YTOOL^ZTOOL^ZGAUGELENGTH^GEARMCODE^SETTOOLGCODE^TOOLRADIUS^TOOLDIAM^UNITSGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* G28 Tokens call complete secondary code constructors for that block
;Default Sequence^[DELETE]^[SAFEBLKNUM]^[<C>TURRETNO]^ (^[COMMENT]^ -^[TOOLDIAM]^)
;Default Sequence^[DELETE]^[BLKNUM]^[WORKGCODE]^ M05 M9
;Default Sequence^[DELETE]^[BLKNUM]^[FIRSTTOOL]^ M01
;Default Sequence^[DELETE]^[BLKNUM]^[<C>ABS-INC]^[<C>SPEED]^ M3^[<C>GEARMCODE]^[<C>COOLANT ON]
* G28 Tokens call complete secondary code constructors for that block
%CALL=PT_SBINC
%CANCEL=POSITION
#TOOLDIA=TOOLRAD*2
<[#DELETE=25][#SBNUM=21][POSITION=10] ([USERDEFINEDSTRING] -[#TOOLDIA=40])>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#WORKGCODE=22] M05 M9>
%CALL=PT_BINC
%LOAD=1:#FIRSTTOOL=POSITION:%LOAD=SUBFUNCT
<[#DELETE=25][#BNUM=20][#FIRSTTOOL=10] M01>
%CALL=PT_BINC
%CANCEL=#ABSINC
%CALL=PT_SPEED_SET
%CANCEL=#SPEED
%CANCEL=#GEARMCODE
%CANCEL=#COOL
<[#DELETE=25][#BNUM=20][#ABSINC=19][#SPEED=8] M3[#GEARMCODE=18][#COOL=18]>



%ENDM
*
*	*****************************************
*	*	Tab Name	:	Spindle				*
*	*****************************************
*
%PROCEDURE=CODECON_SPINDLE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Spindle	*****>
@NO_CON-DEBUG

;Sequence Definition^<446>Spindle^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^STOPMCODE^SPEED^SPINDIR^COOLANT ON^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Program Stop		*
*	*****************************************
*
%PROCEDURE=CODECON_PROGRAM-STOP

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Program Stop	*****>
@NO_CON-DEBUG

;Sequence Definition^<45>Program Stop^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^STOPMCODE^SPINDIR^COOLANT ON^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[STOPMCODE]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#STOPMCODE=18]>


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Coolant				*
*	*****************************************
*
%PROCEDURE=CODECON_COOLANT

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Coolant	*****>
@NO_CON-DEBUG

;Sequence Definition^<425>Coolant^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^COOLANT ON^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Exact Stop			*
*	*****************************************
*
%PROCEDURE=CODECON_EXACT-STOP

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Exact Stop	*****>
@NO_CON-DEBUG

;Sequence Definition^<7>Exact Stop^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^EXACTSTOPGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Feed / min / rev	*
*	*****************************************
*
%PROCEDURE=CODECON_FEED-MIN-REV

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Feed / Min / Rev	*****>
@NO_CON-DEBUG

;Sequence Definition^<447>Feed / Min / Rev^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^FEEDMODEGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[FEEDMODEGCODE]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#FEEDMODEGCODE=19]>


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Comment				*
*	*****************************************
*
%PROCEDURE=CODECON_COMMENT

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Comment	*****>
@NO_CON-DEBUG

;Sequence Definition^<448>Comment^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^COMMENT^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^ (^[COMMENT]^)
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] ([USERDEFINEDSTRING])>


%ENDM
*
*	*****************************************
*	*	Tab Name	:	Insert NC Code		*
*	*****************************************
*
%PROCEDURE=CODECON_INSERT-NC-CODE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Insert Nc Code	*****>
@NO_CON-DEBUG

;Sequence Definition^<449>Insert Nc Code^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^COMMENT^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^ ^[COMMENT]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] [USERDEFINEDSTRING]>


%ENDM
*
*	*****************************************************
*	*	Tab Name	:	Re-Select Tool Length Offset	*
*	*****************************************************
*
%PROCEDURE=CODECON_SELECT-LENGTH-OFFSET

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Select Length Offset	*****>
@NO_CON-DEBUG

;Sequence Definition^<450>Select Length Offset^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^LENGTHOFFSET^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[LENGTHOFFSET]
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#HCODE=11]>


%ENDM
*
*	*****************************************************
*	*	Tab Name	:	High Speed M/c - ON				*
*	*****************************************************
*
%PROCEDURE=CODECON_HIGHSPEED-ON

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	HPCC Mode ON	*****>
@NO_CON-DEBUG

;Sequence Definition^<1063>HPCC Mode On^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^HIGHSPEED TOL^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^ G05 P1000 (HPCC mode ON)
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] G05 P1000 (HPCC mode ON)>

%ENDM
*
*	*****************************************************
*	*	Tab Name	:	High Speed M/c - OFF			*
*	*****************************************************
*
%PROCEDURE=CODECON_HIGHSPEED-OFF

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	HPCC Mode OFF *****>
@NO_CON-DEBUG

;Sequence Definition^<1064>HPCC Mode Off^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^HIGHSPEED TOL^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^ G05 P0 (HPCC mode OFF)
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] G05 P0 (HPCC mode OFF)>

%ENDM

*
*	*****************************************
*	*	Tab Name	:	Rapid To Toolchange	*
*	*****************************************
*
%PROCEDURE=CODECON_RAPID-TO-TOOLCHANGE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Rapid To Toolchange	*****>
@NO_CON-DEBUG

;Sequence Definition^<451>Rapid To Toolchange^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^G28ZBlock^G28XYBlock^ABS-INC^RAPIDGCODE^XTOOL^YTOOL^ZTOOL^XTOOLPOS^YTOOLPOS^ZTOOLPOS^ZINITIAL^COMPGCODE^CRC REGISTER^TURRETNO^NEXTTOOL^COOLANT OFF^SPINDLE OFF^WORKGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* G28 Tokens call complete secondary code constructors for that block
;Default Sequence^[G28ZBlock]
;Default Sequence^[G28XYBlock]
;Default Sequence^[DELETE]^[BLKNUM]^[<C>ABS-INC]
;TEXT^If the XYZ movement tokens are not used this code constructor is called once.
;TEXT^If they are used then it is called twice. Z and then XY.
* G28 Tokens call complete secondary code constructors for that block
%CALL=CODECON_G28ZBlock
%CALL=CODECON_G28XYBlock
%CALL=PT_BINC
%CANCEL=#ABSINC
<[#DELETE=25][#BNUM=20][#ABSINC=19]>



%CALL=HOLD
%ENDM

*
*	*********************************************
*	*	Tab Name	:	Rapid After Toolchange	*
*	*********************************************
*
%PROCEDURE=CODECON_RA-AFTER-TOOLCHANGE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Rapid After Toolchange	*****>
@NO_CON-DEBUG


;Sequence Definition^<452>Rapid After Toolchange^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^SAFEBLKNUM^ABS-INC^RAPIDGCODE^XMOVE^YMOVE^ZMOVE^ZINITIAL^TURRETNO^LENGTHOFFSET^COOLANT ON^SPEED^NEXTTOOL^SPINDIR^WORKGCODE^CPLNAME^FEEDMODEGCODE^FEED^COMPGCODE^CRC REGISTER^UNITSGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[<C>RAPIDGCODE]^[<C>XMOVE]^[<C>YMOVE]
;Default Sequence^[DELETE]^[BLKNUM]^ G43^[<C>ZMOVE]^[<C>LENGTHOFFSET]^[<C>COOLANT ON]
%CALL=PT_BINC
%CANCEL=#GCODE
%CANCEL=#XMOVE
%CANCEL=#YMOVE
<[#DELETE=25][#BNUM=20][#GCODE=19][#XMOVE=0][#YMOVE=1]>
%CALL=PT_BINC
%CANCEL=#ZMOVE
%CANCEL=#HCODE
%CANCEL=#COOL
<[#DELETE=25][#BNUM=20] G43[#ZMOVE=2][#HCODE=11][#COOL=18]>




%CALL=HOLD
%ENDM
*
*	*****************************************
*	*	Tab Name	:	Rapid To Home		*
*	*****************************************
*
%PROCEDURE=CODECON_RAPID-TO-HOME

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Rapid To Home	*****>
@NO_CON-DEBUG

;Sequence Definition^<453>Rapid To Home^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^G28ZBlock^G28XYBlock^RAPIDGCODE^ABS-INC^XHOME^YHOME^ZHOME^XHOMEPOS^YHOMEPOS^ZHOMEPOS^ZINITIAL^COMPGCODE^CRC REGISTER^TURRETNO^NEXTTOOL^COOLANT OFF^SPINDLE OFF^WORKGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* G28 Tokens call complete secondary code constructors for that block
;Default Sequence^[G28ZBlock]
;Default Sequence^[G28XYBlock]
;TEXT^If the XYZ movement tokens are not used this code constructor is called once.
;TEXT^If they are used then it is called twice. Z and then XY.
* G28 Tokens call complete secondary code constructors for that block
%CALL=CODECON_G28ZBlock
%CALL=CODECON_G28XYBlock



%CALL=HOLD
%ENDM
*
*	*************************************************
*	*	Tab Name	:	Translate					*
*	*************************************************
*
%PROCEDURE=CODECON_TRANSLATE

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Translate	*****>
@NO_CON-DEBUG

;Sequence Definition^<592>Translate^32^<918>Repeat Machining^
;Use Tokens^DELETE^BLKNUM^XINC^YINC^ZINC^PRESETGCODE^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[PRESETGCODE]^[XINC]^[YINC]
%CALL=PT_BINC
%CANCEL=#XMOVE
%CANCEL=#YMOVE
<[#DELETE=25][#BNUM=20][#PRESETGCODE=19][#XMOVE=0][#YMOVE=1]>


#SKIPROT=#TRUE
%CALL=HOLD
#SKIPROT=#FALSE
%ENDM
*
*
*	*************************************************
*	*	Tab Name	:	Set Work Datums				*
*	*************************************************
*
%PROCEDURE=CODECON_SET-WORK-DATUMS

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Set Work Datums	*****>
@NO_CON-DEBUG

;Sequence Definition^<593>Set Work Datums^-1^<919>Datum Shifting^
;Use Tokens^DELETE^BLKNUM^WORKGCODE^WORKREGISTER^CPLNAME^XABSORIGIN^YABSORIGIN^ZABSORIGIN^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^(^[DELETE]^[BLKNUM]^ G10 L2^[WORKREGISTER]^[XABSORIGIN]^[YABSORIGIN]^[ZABSORIGIN]^)
;Default Sequence^[DELETE]^[BLKNUM]^ G10 L2^[WORKREGISTER]^ (^[CPLNAME]^)
%CALL=PT_BINC
%CANCEL=#XSUB
%CANCEL=#YSUB
%CANCEL=#ZSUB
<([#DELETE=25][#BNUM=20] G10 L2[#COORDNUM=38][#XSUB=0][#YSUB=1][#ZSUB=2])>
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20] G10 L2[#COORDNUM=38] ([$CPLNAME])>




%ENDM
*
*
*	*************************************************
*	*	Tab Name	:	Select Work Datums			*
*	*************************************************
*
%PROCEDURE=CODECON_SELECT-WORK-DATUMS
*
*	Datum Shift- no rotary motion, called from Datum Shift and Index Pallet commands
*	Assumes exclusive use of Absolute OR Incremental i.e. Tokens used accordingly.
*	Index Pallet with Rotary output via Index Pallet Code Constructor.
*
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Select Work Datums	*****>
@NO_CON-DEBUG

;Sequence Definition^<594>Select Work Datums^-1^<919>Datum Shifting^
;Use Tokens^DELETE^BLKNUM^PRESETGCODE^WORKGCODE^XABSORIGIN^YABSORIGIN^ZABSORIGIN^XINC^YINC^ZINC^CPLNAME^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[WORKGCODE]^[PRESETGCODE]^[XINC]^[YINC]^[ZINC]^ (^[CPLNAME]^)
%CALL=PT_BINC
%CANCEL=#XMOVE
%CANCEL=#YMOVE
%CANCEL=#ZMOVE
<[#DELETE=25][#BNUM=20][#WORKGCODE=22][#PRESETGCODE=19][#XMOVE=0][#YMOVE=1][#ZMOVE=2] ([$CPLNAME])>


%ENDM
*
*	*************************************************
*	*	Tab Name	:	Subroutine Start			*
*	*************************************************
*
%PROCEDURE=CODECON_SUBROUTINE-START

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Subroutine Start	*****>

@NO_CON-DEBUG

;Sequence Definition^<454>Subroutine Start^-1^<417>Subroutines^
;Use Tokens^DELETE^BLKNUM^SUBNO^ABS-INC^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[SUBNO]
;Default Sequence^;CODE:* Output mode change for subroutines if different
;Default Sequence^;CODE:%IF #INCRSUBS=#INCRXYZHOLD @END
;Default Sequence^[DELETE]^[BLKNUM]^[ABS-INC]
;Default Sequence^;CODE:@END
<[#SUBROUTINE=14]>
* Output mode change for subroutines if different
%IF #INCRSUBS=#INCRXYZHOLD @END
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#ABSINC=19]>
@END


%ENDM
*
*	*************************************************
*	*	Tab Name	:	Subroutine Call				*
*	*************************************************
*
%PROCEDURE=CODECON_SUBROUTINE-CALL

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Subroutine Call	*****>

@NO_CON-DEBUG

;Sequence Definition^<455>Subroutine Call^-1^<417>Subroutines^
;Use Tokens^DELETE^BLKNUM^SUBCALL^SUBNOCALL^N-SUBSTART^N-SUBEND^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[SUBCALL]^[SUBNOCALL]
%CALL=PT_BINC
#SUBSTARTMCODE=DATA2(34)
<[#DELETE=25][#BNUM=20][#SUBSTARTMCODE=18][#SUBROUTINE=15]>


%ENDM

*
*	*************************************************
*	*	Tab Name	:	Spline Parameter   			*
*	*************************************************
*
%PROCEDURE=CODECON_SPLINE-PARAMETER
%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	NURB Interpolation	*****>
@NO_CON-DEBUG

** removed until can enable spline interpolation in the code wizard

;Sequence Definition^<1065>NURB Interpolation^-1^<902>General Motion^
;Use Tokens^DELETE^BLKNUM^CYCLEGCODE^ORDER^KNOT^XMOVE^YMOVE^ZMOVE^WEIGHT^FEED^SPEED^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^[DELETE]^[BLKNUM]^[CYCLEGCODE]^[ORDER]^[KNOT]^[XMOVE]^[YMOVE]^[ZMOVE]^[WEIGHT]^[FEED]^[SPEED]
%CALL=PT_BINC
%CALL=PT_SPEED_SET
<[#DELETE=25][#BNUM=20][#CYCLEGCODE=26][#ORDER=42][#KNOT=44][#XMOVE=0][#YMOVE=1][#ZMOVE=2][#WEIGHT=43][#FEED=7][#SPEED=8]>


%ENDM

*
*	*************************************************
*	*	Tab Name	:	Subroutine End				*
*	*************************************************
*
%PROCEDURE=CODECON_SUBROUTINE-END

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Subroutine End	*****>

@NO_CON-DEBUG
;Sequence Definition^<456>Subroutine End^-1^<417>Subroutines^
;Use Tokens^DELETE^BLKNUM^SUBCALL^SUBNO^SUBEND^ABS-INC^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^;CODE:* Output mode change for subroutines if different
;Default Sequence^;CODE:%IF #INCRSUBS=#INCRXYZHOLD @END
;Default Sequence^[DELETE]^[BLKNUM]^[ABS-INC]
;Default Sequence^;CODE:@END
;Default Sequence^[DELETE]^[BLKNUM]^[SUBEND]
* Output mode change for subroutines if different
%IF #INCRSUBS=#INCRXYZHOLD @END
%CALL=PT_BINC
<[#DELETE=25][#BNUM=20][#ABSINC=19]>
@END
%CALL=PT_BINC
#SUBENDMCODE=DATA2(35)
<[#DELETE=25][#BNUM=20][#SUBENDMCODE=18]>


%ENDM

*
*	*************************************************
*	*	Tab Name	:	Warnings        			*
*	*************************************************
*
%PROCEDURE=CODECON_WARNING

%IF $CONDEBUG=N @NO_CON-DEBUG
<*****	Code Constructor	:	Warnings	*****>
@NO_CON-DEBUG

#WARNCOUNT=#WARNCOUNT+1

;Sequence Definition^<1011>Warnings^-1^<917>Miscellaneous Functions^
;Use Tokens^DELETE^BLKNUM^WARNING^USER-STRING^USER-STRING-1^USER-STRING-2^USER-STRING-3^USER-STRING-4^USER-STRING-5^USER-1^USER-2^USER-3^USER-4^USER-5^USER-6^USER-7^USER-8^USER-9^USER-10
;Default Sequence^* ^[WARNING]
<* [$WARNING]>


%ENDM

* Following code constructors for MPL support only

; Dummy procedures

%PROCEDURE=CODECON_TRANSLATE_RESET
%ENDM

%PROCEDURE=CODECON_RIGID-TAP-CYCLE
%ENDM

%PROCEDURE=CODECON_SPLINE-POINT
%ENDM

%PROCEDURE=CODECON_THREAD_CYCLE
%ENDM

*** Format table

;                                      Ŀ
;Ĵ           Format Table           
;                                      
%FORMAT
 X,3,4,640,4,3,640, ; 0  (!FT_XMOVE)        X Move
 Y,3,4,640,4,3,640, ; 1  (!FT_YMOVE)        Y Move
 Z,3,4,640,4,3,640, ; 2  (!FT_ZMOVE)        Z Move
 I,3,4,640,4,3,640, ; 3  (!FT_IMOVE)        I Arc
 J,3,4,640,4,3,640, ; 4  (!FT_JMOVE)        J Arc
 K,3,4,640,4,3,640, ; 5  (!FT_KMOVE)        K Arc
 R,3,4,640,4,3,640, ; 6  (!FT_RMOVE)        Arc Radius
 F,4,0,640,4,0,640, ; 7  (!FT_FEED)         Feed Code
 S,5,0,0,5,0,0,     ; 8  (!FT_SPEED)        Speed Code
 P,1,3,20,1,3,20,   ; 9  (!FT_DWELL)        Dwell Time (Non cycle e.g. G04 Ptime)
 T,2,0,1,2,0,1,     ; 10 (!FT_TPOSN)        Turret Position
 H,2,0,1,2,0,1,     ; 11 (!FT_TLONO)        Tool Length Offset (Tlo)
 D,2,0,1,2,0,1,     ; 12 (!FT_CRCNO)        Cutter Compensation Register
:,4,0,21,4,0,21,    ; 13 (!FT_PROGID)       Main NC Program Number
:O,4,0,21,4,0,21,   ; 14 (!FT_SUBID)        Subprogram Number
 P,4,0,21,4,0,21,   ; 15 (!FT_SUBCALL)      Subprogram Call
 P,4,0,0,4,0,0,     ; 16 (!FT_SSNUM)        Subroutine Block No. Start
 Q,4,0,0,4,0,0,     ; 17 (!FT_SENUM)        Subroutine Block No. End
 M,2,0,0,2,0,0,     ; 18 (!FT_MCODE)        Miscellaneous "M" Codes
 G,2,0,0,2,0,0,     ; 19 (!FT_GCODE)        Preparatory "G" Codes
N,5,0,0,5,0,0,      ; 20 (!FT_BLKNUM)       Block Number
N,5,0,0,5,0,0,      ; 21 (!FT_SAFEBLKNUM)   Safe / Tool Block No.
 G,2,0,0,2,0,0,     ; 22 (!FT_WORKGCODE)    Work Coord System / Fixture offset
,4,3,10,4,3,10,     ; 23 (!FT_INTSETUP)     Set-up Sheet (Integers)
,4,3,2052,4,3,2052, ; 24 (!FT_REALSETUP)    Set-up Sheet (Reals)
/,0,0,0,0,0,0,      ; 25 (!FT_DELETE)       Block Delete / Skip
 G,3,1,0,3,1,0,     ; 26 (!FT_GCYCLE)       Hole Cycles - G Code
 Z,3,4,640,4,3,640, ; 27 (!FT_ZCYCLE)       Hole Cycles - Z Depth
 F,4,2,640,4,2,640, ; 28 (!FT_FCYCLE)       Hole Cycles - Feedrate
 S,4,0,0,4,0,0,     ; 29 (!FT_SCYCLE)       Hole Cycles - Speed Code
 P,4,0,0,4,0,0,     ; 30 (!FT_DWCYCLE)      Hole Cycles - Dwell Time
 Q,3,4,640,4,3,640, ; 31 (!FT_OFFCYCLE)     Hole Cycles - Bore Stand-off
 Q,3,4,640,4,3,640, ; 32 (!FT_PECKCYCLE)    Hole Cycles - Peck Depth
 D,3,4,640,4,3,640, ; 33 (!FT_DEGCYCLE)     Hole Cycles - Degression
 Z,3,4,640,4,3,640, ; 34 (!FT_CLEARCYCLE)   Hole Cycles - Z Clear
 R,3,4,640,4,3,640, ; 35 (!FT_RETRACTCYCLE) Hole Cycles - Retract plane
 K,3,0,640,3,0,640, ; 36 (!FT_PITCHCYCLE)   Hole Cycles - Thread / Tap Pitch
 G,2,0,0,2,0,0,     ; 37 (!FT_GCODETSET)    Tooling Data - G Code
 P,4,0,0,4,0,0,     ; 38 (!FT_LOOPTSET)     Offset Store - Loop Number
 R,3,4,640,4,3,640, ; 39 (!FT_RADTSET)      Tooling Data - Tool Radius
 D,3,4,640,4,3,640, ; 40 (!FT_DIATSET)      Tooling Data - Tool Diameter
 Z,3,4,640,4,3,640, ; 41 (!FT_ZGAUGETSET)   Tooling Data - Zgauge Length
 P,4,3,0,4,3,0,     ; 42 (!FT_ORDER)        Spline Order
 R,4,3,0,4,3,0,     ; 43 (!FT_WEIGHT)       Spline Weight
 K,4,3,640,4,3,640, ; 44 (!FT_KNOT)         Spline Knot
 T,3,4,640,4,3,640, ; 45 (!FT_HIGHSPEEDTOL) High Speed Tolerance
,3,4,0,3,4,0,       ; 46 (!FT_USER-1)       User Numeric Token 1
,3,4,0,3,4,0,       ; 47 (!FT_USER-2)       User Numeric Token 2
,3,4,0,3,4,0,       ; 48 (!FT_USER-3)       User Numeric Token 3
,3,4,0,3,4,0,       ; 49 (!FT_USER-4)       User Numeric Token 4
,3,4,0,3,4,0,       ; 50 (!FT_USER-5)       User Numeric Token 5
,3,4,0,3,4,0,       ; 51 (!FT_USER-6)       User Numeric Token 6
,3,4,0,3,4,0,       ; 52 (!FT_USER-7)       User Numeric Token 7
,3,4,0,3,4,0,       ; 53 (!FT_USER-8)       User Numeric Token 8
,3,4,0,3,4,0,       ; 54 (!FT_USER-9)       User Numeric Token 9
,3,4,0,3,4,0,       ; 55 (!FT_USER-10)      User Numeric Token 10
%ENDF
*** End of include file B:\Pams\cam\machdef\template\M-FANUC.CGI ***
